/*  $Id: btypes.h,v 1.2 1998/08/22 03:34:45 shaggy Exp $
 *      relative path: ./lib
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Libraries
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is part of the Shag/OS distribution, and may be freely used and
 *  distributed by the terms of the ShagWare General Public License (SGPL),
 *  version 2, or, at your option, any newer official version of that License.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND,
 *  INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE, AND WILL NOT BE LIABLE FOR ANY DAMAGES.
 *  For more warranty details, see the ShagWare General Public License, which
 *  should have been received with this program, in a file called 'lic_spl2.txt'
 *  If this license is missing, please contact the author and describe how
 *  this software was obtained.  Email: shaggy@csh.rit.edu
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/*  $Log: btypes.h,v $
 *  Revision 1.2  1998/08/22 03:34:45  shaggy
 *  header update
 *
 *  Revision 1.1  1996/12/08 18:45:10  shaggy
 *  Initial revision
 *
 *      creation date: Dec 1994
 */

#define _K_	1024			// Kilo (2^10)
#define	_M_	1048576			// Mega (2^20)
#define _G_	1073741824		// Giga (2^30)
#define _T_	1099511627776		// Tera (2^40)


#ifndef ASM

typedef unsigned char		uchar;
typedef signed char		schar;
typedef unsigned short int	ushort;
typedef unsigned long int	ulong;
typedef unsigned long long int	ullong;
typedef long long int		llong;
typedef unsigned int		uint;
 
typedef long double 	ldouble;

typedef uint8	flag8;
typedef uint16	flag16;
typedef uint32	flag32;
typedef uint64	flag64;

// deprecated, hopefully:
//
// typedef void	fvoid_t();
// typedef int	fint_t();
// typedef char	*fstr_t();
// typedef int	fmain_t(int argc, char **argv);

typedef uchar 		lock_t; 
// typedef	uint32		obj_t;
// typedef obj_t		status_t;
// typedef obj_t		label_t;


// Note that 'signed char' and 'unsigned char'
// are *not* included as builtin char types, because
// when the signed-ness of a char type is being depended upon,
// it is generally being used as an integer, not a character.

#ifndef FOR_ALL_BUILTIN_CHAR_TYPES
#define FOR_ALL_BUILTIN_CHAR_TYPES(x)	\
		x(char) x(wchar_t)
#endif

#ifndef FOR_ALL_BUILTIN_INT_TYPES
#define FOR_ALL_BUILTIN_INT_TYPES(x)	\
		x(int8) x(uint8) \
		x(int16) x(uint16) \
		x(int32) x(uint32) \
		x(int64) x(uint64)
#endif

#ifndef FOR_ALL_BUILTIN_FLOAT_TYPES
#define FOR_ALL_BUILTIN_FLOAT_TYPES(x)	\
		x(float) x(double) x(long double)
#endif

#ifndef FOR_ALL_BUILTIN_TYPES
#define FOR_ALL_BUILTIN_TYPES(x)	FOR_ALL_BUILTIN_CHAR_TYPES(x)	\
					FOR_ALL_BUILTIN_INT_TYPES(x)	\
					FOR_ALL_BUILTIN_FLOAT_TYPES(x)	
#endif

#endif	/* ASM */

