/*  $Id: ActionStack.h,v 1.4 1998/08/22 03:35:08 shaggy Exp $
 *      C/C++ Parser (yacc grammar)
 *      
 *      relative path: .//lib/cparse
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Libraries
 *        C/C++ Parsing classes
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is part of the Shag/OS distribution, and may be freely used and
 *  distributed by the terms of the ShagWare Non-profit Public License (SNPL),
 *  version 2, or, at your option, any newer official version of that License.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND,
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE, AND WILL NOT BE LIABLE FOR ANY DAMAGES.
 *  For more warranty details, see the ShagWare Non-profit Public License, which
 *  should have been received with this program, in a file called 'lic_spl2.txt'
 *  If this license is missing, please contact the author and describe how
 *  this software was obtained.  Email: shaggy@csh.rit.edu
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/*  
 *  $Log: ActionStack.h,v $
 *  Revision 1.4  1998/08/22 03:35:08  shaggy
 *  header update
 *
 *  Revision 1.3  1998/07/28 16:43:15  shaggy
 *  moved lots of Deco into generic CParse lib
 *  CAction split into vCAction and CAction
 *  printaction -> part of CAction
 *  ccint -> CRep (C Representation)
 *  ccout -> COut (C output)
 *
 *  Revision 1.2  1998/05/25 23:28:41  shaggy
 *  major rework of func/param info
 *
 *  Revision 1.1  1998/01/12 04:12:48  shaggy
 *  Initial revision
 *
 */

#include <vCAction>

class ActionStack {
public:
	typedef vCAction::Item Item;
	typedef const vCAction::Item &Item_;
	typedef vCAction::Action Action;
private:
	struct Node {
		int	actionindex;	
		Item	param1, param2, param3;
	};
	Node *_stack;
	int _sp;
	int _stacksize;
	vCAction *_caction;
public:
	void push(Item *range, Item_ linkrange, int actionindex,
		Item_ p1 = vCAction::none,
		Item_ p2 = vCAction::none,
		Item_ p3 = vCAction::none);	
	void pop_fifo(Item *result, Item_ range,
		const Action action_table[], Item_ param);
	void pop_lifo(Item *result, Item_ range,
		const Action action_table[], Item_ param);
	ActionStack(vCAction *caction);
	~ActionStack();
};

