/*  $Id: COut.cc,v 1.18 1998/08/22 03:35:12 shaggy Exp $
 *      C++ output
 *      
 *      relative path: .//lib/cparse
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Libraries
 *        C/C++ Parsing classes
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is part of the Shag/OS distribution, and may be freely used and
 *  distributed by the terms of the ShagWare Non-profit Public License (SNPL),
 *  version 2, or, at your option, any newer official version of that License.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND,
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE, AND WILL NOT BE LIABLE FOR ANY DAMAGES.
 *  For more warranty details, see the ShagWare Non-profit Public License, which
 *  should have been received with this program, in a file called 'lic_spl2.txt'
 *  If this license is missing, please contact the author and describe how
 *  this software was obtained.  Email: shaggy@csh.rit.edu
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

//  $Log: COut.cc,v $
//  Revision 1.18  1998/08/22 03:35:12  shaggy
//  header update
//
//  Revision 1.17  1998/08/16 22:17:58  shaggy
//  improved header output
//
//  Revision 1.16  1998/08/13 04:26:35  shaggy
//  bug fixes and dynamic sized arrays
//
//  Revision 1.15  1998/08/12 15:18:33  shaggy
//  better typing; fixed some type coercions;
//  cleanup for #include's, and fixed some constructor call bugs
//
//  Revision 1.14  1998/08/10 13:09:43  shaggy
//  some code cleanup (casts, etc)
//
//  Revision 1.13  1998/08/10 03:11:57  shaggy
//  deco 0.10
//
//  Revision 1.12  1998/08/09 21:49:50  shaggy
//  DECO *finally* converts all of my original testcases automatically
//
//  Revision 1.11  1998/08/09 03:57:34  shaggy
//  lots of work on output dependency checking
//
//  Revision 1.10  1998/08/03 04:11:32  shaggy
//  deco can *finally* generate code which binds a type to a class
//
//  Revision 1.9  1998/08/03 00:12:56  shaggy
//  tons of work-- friends, class scope fixes, tons of bugfixes,
//  lots more cleanup, more DC++ work, etc
//
//  Revision 1.8  1998/08/01 21:02:07  shaggy
//  much more cleanup; many bugfixes; DC++ progress
//
//  Revision 1.7  1998/08/01 14:56:45  shaggy
//  about to restructure deco
//
//  Revision 1.6  1998/07/31 23:44:26  shaggy
//  running out of time
//
//  Revision 1.5  1998/07/31 02:03:10  shaggy
//  better
//
//  Revision 1.4  1998/07/30 22:27:18  shaggy
//  broken
//
//  Revision 1.3  1998/07/30 04:40:30  shaggy
//  much more dtype and dclass work
//
//  Revision 1.2  1998/07/28 19:55:25  shaggy
//  moved most of generic parsing from Deco into CAction
//
//  Revision 1.1  1998/07/28 16:43:17  shaggy
//  moved lots of Deco into generic CParse lib
//  CAction split into vCAction and CAction
//  printaction -> part of CAction
//  ccint -> CRep (C Representation)
//  ccout -> COut (C output)
//
//  Revision 1.87  1998/07/28 04:46:01  shaggy
//  more dtype work
//
//  Revision 1.86  1998/07/28 01:24:22  shaggy
//  initial support for implementation specifiers
//
//  Revision 1.85  1998/07/21 14:57:28  shaggy
//  trying to get dtype conversion working right
//
//  Revision 1.84  1998/07/20 17:51:46  shaggy
//  added bitfield support
//
//  Revision 1.83  1998/07/20 14:59:36  shaggy
//  more dtype conv work
//
//  Revision 1.82  1998/07/19 22:33:36  shaggy
//  part 2 of major overhaul (needed for type-safty and to start
//  being more consistent)
//
//  Revision 1.81  1998/07/16 23:21:43  shaggy
//  more anon struct/union support
//
//  Revision 1.80  1998/07/14 14:55:38  shaggy
//  fixing MPTRTO and PtrTo(Method) for const
//
//  Revision 1.79  1998/07/12 19:01:24  shaggy
//  many more cvqual fixes
//
//  Revision 1.78  1998/07/12 03:58:47  shaggy
//  lots of const fixes, -frealtype option, -dT option; better debugging
//
//  Revision 1.77  1998/07/11 23:06:50  shaggy
//  fixed labels and goto
//
//  Revision 1.76  1998/07/11 19:03:01  shaggy
//  declarations in for() work now (even multiple decls)
//
//  Revision 1.75  1998/07/10 13:45:09  shaggy
//  working on decls in conditions
//
//  Revision 1.74  1998/07/09 04:53:28  shaggy
//  more fn matching fixes
//
//  Revision 1.73  1998/07/08 21:45:03  shaggy
//  lots of enhancements for function call matching
//
//  Revision 1.72  1998/07/08 13:42:43  shaggy
//  started adding proper function calls
//
//  Revision 1.71  1998/07/07 13:41:41  shaggy
//  enum cleanup, and can define types inside functions now
//
//  Revision 1.70  1998/07/07 02:51:14  shaggy
//  more fixes for declaration ordering
//
//  Revision 1.69  1998/07/06 22:49:43  shaggy
//  reworked symtab, output ordering, etc
//
//  Revision 1.68  1998/07/06 15:07:51  shaggy
//  more config fixes
//
//  Revision 1.67  1998/07/06 13:39:07  shaggy
//  many more changes/fixes for first pre-release
//
//  Revision 1.66  1998/07/05 20:32:57  shaggy
//  tons of bugfixes, enhancements and parser improvements
//
//  Revision 1.65  1998/07/05 02:47:38  shaggy
//  tons of bug fixes
//
//  Revision 1.64  1998/07/04 20:39:00  shaggy
//  lots of bug fixes; fn, aggr, etc improvements, new/delete
//
//  Revision 1.63  1998/07/04 01:23:30  shaggy
//  anonymous unions work now
//
//  Revision 1.62  1998/07/03 16:53:52  shaggy
//  new Scope wrapper class, and dcast_XXX functions eliminate lots of casts
//
//  Revision 1.61  1998/07/02 13:25:52  shaggy
//  public/private/protected works for inheritance
//
//  Revision 1.60  1998/06/30 15:38:38  shaggy
//  better support for member fns and member fn ptrs
//
//  Revision 1.59  1998/06/29 14:14:17  shaggy
//  more DECO conversions, support for 'this', etc
//
//  Revision 1.58  1998/06/29 01:36:55  shaggy
//  fixed inline attr, output of pure virtuals, etc...
//
//  Revision 1.57  1998/06/07 18:09:04  shaggy
//  added types to Expr()'s, and fixed output of members (. and ->)
//
//  Revision 1.56  1998/06/07 15:45:12  shaggy
//  realtype() works, and . and -> now work
//
//  Revision 1.55  1998/06/07 02:33:40  shaggy
//  uses hex for digits > 9
//
//  Revision 1.54  1998/06/02 14:50:42  shaggy
//  in the midst of more full parsing updates
//
//  Revision 1.53  1998/06/01 02:10:35  shaggy
//  more code parsing working
//
//  Revision 1.52  1998/05/31 21:08:03  shaggy
//  fixed output scoping
//
//  Revision 1.51  1998/05/26 21:34:16  shaggy
//  C/C++/DC++ header formats now supported
//  header output includes external requirements
//
//  Revision 1.50  1998/05/26 13:40:14  shaggy
//  many more fixes
//
//  Revision 1.49  1998/05/26 05:02:55  shaggy
//  parameter scoping works correctly
//  most basic C/C++ statements now work
//
//  Revision 1.48  1998/05/25 23:28:45  shaggy
//  major rework of func/param info
//
//  Revision 1.47  1998/05/25 20:08:41  shaggy
//  more bugfixes
//
//  Revision 1.46  1998/05/25 04:22:14  shaggy
//  enough for tonight
//
//  Revision 1.45  1998/05/24 23:39:33  shaggy
//  various bug fixes and code cleanup
//
//  Revision 1.44  1998/05/24 18:42:00  shaggy
//  improved regression testing
//  proper scoping for initializers
//  decls available for their initializer
//
//  Revision 1.43  1998/05/24 01:41:42  shaggy
//  internal support for most statements
//
//  Revision 1.42  1998/05/22 14:42:39  shaggy
//  fixed output formatting
//
//  Revision 1.41  1998/05/21 13:27:21  shaggy
//  output formatting problems
//
//  Revision 1.40  1998/05/20 14:41:24  shaggy
//  better code output
//
//  Revision 1.39  1998/05/19 14:55:36  shaggy
//  a bit closer to generating code (stmtlists work)
//
//  Revision 1.38  1998/05/18 05:24:28  shaggy
//  more cleanup of declaration support functions
//
//  Revision 1.37  1998/05/17 23:14:57  shaggy
//  expressions, expression lists, etc
//
//  Revision 1.36  1998/05/16 23:30:44  shaggy
//  added CTOR_ID and some rules to help fix ctor ambiguity problem
//  output turned off for #include'ed files
//  better error checking, and ability to list locations
//  of symbol declaration and definition
//
//  Revision 1.35  1998/05/15 07:03:37  shaggy
//  dependency ordering fixed; constructor initializers; lots of bug fixes, etc
//
//  Revision 1.34  1998/05/15 00:17:27  shaggy
//  ctor initializers work, and enums are fixed so declarations
//  in an enum can be immediately re-used
//
//  Revision 1.33  1998/05/14 18:02:05  shaggy
//  fixed constant handling, enums, function cv tags, etc
//
//  Revision 1.32  1998/05/14 05:08:42  shaggy
//  inheritence works and lots of bugs fixed
//
//  Revision 1.31  1998/05/13 21:39:36  shaggy
//  switched to dtype/ptype/rtype
//
//  Revision 1.30  1998/05/13 21:02:48  shaggy
//  deinitions/initializations work better now
//
//  Revision 1.29  1998/05/12 22:40:24  shaggy
//  scoping FINALLY works right (or seems to)
//
//  Revision 1.28  1998/05/12 20:14:09  shaggy
//  scoping works except for output with nested dependencies
//
//  Revision 1.27  1998/05/12 15:53:21  shaggy
//  scoping and class tags almost work
//
//  Revision 1.26  1998/05/12 05:00:14  shaggy
//  more scope work
//
//  Revision 1.25  1998/05/08 13:03:24  shaggy
//  fixed const/volatile
//
//  Revision 1.24  1998/05/07 14:46:40  shaggy
//  const/volatile partially working
//
//  Revision 1.23  1998/05/04 04:39:50  shaggy
//  first stage of function overloading
//
//  Revision 1.22  1998/05/04 03:09:21  shaggy
//  support for ctors, dtors, conversion operators, operator overloading, etc
//
//  Revision 1.21  1998/05/03 17:07:30  shaggy
//  more improvements to make internal declarations easier
//
//  Revision 1.20  1998/05/03 02:47:08  shaggy
//  added inheritence to parser
//
//  Revision 1.19  1998/04/27 04:36:48  shaggy
//  started auto-generation of code
//
//  Revision 1.18  1998/04/26 14:58:52  shaggy
//  fixed to output standard C++ types (instead of int32,etc)
//
//  Revision 1.17  1998/04/23 20:11:41  shaggy
//  more changes for Solaris
//
//  Revision 1.16  1998/04/22 13:06:39  shaggy
//  better enum handling
//
//  Revision 1.15  1998/04/22 12:17:51  shaggy
//  changed ID to Id for consistency
//
//  Revision 1.14  1998/04/17 18:02:03  shaggy
//  more stuff to make it build under Solaris
//
//  Revision 1.13  1998/04/17 04:37:41  shaggy
//  public/privat/protected works now
//
//  Revision 1.12  1998/04/16 13:35:33  shaggy
//  access control
//
//  Revision 1.11  1998/04/15 14:47:58  shaggy
//  array output works
//
//  Revision 1.10  1998/04/15 13:39:56  shaggy
//  added types to constants
//
//  Revision 1.9  1998/04/14 13:18:58  shaggy
//  fixed stuff
//
//  Revision 1.8  1998/04/13 01:30:23  shaggy
//  even better C++ output
//
//  Revision 1.7  1998/04/12 18:38:07  shaggy
//  improved code output
//
//  Revision 1.6  1998/04/12 03:19:34  shaggy
//  got function output working
//
//  Revision 1.5  1998/04/11 21:48:42  shaggy
//  added some simple regurgitation
//
//  Revision 1.4  1998/04/07 13:38:19  shaggy
//  fixed up enums some more
//
//  Revision 1.3  1998/04/06 14:27:43  shaggy
//  lots more changes, and added some tests
//
//  Revision 1.2  1998/02/09 00:06:54  shaggy
//  proper C++ output
//
//  Revision 1.1  1998/02/08 23:41:58  shaggy
//  Initial revision
//

// #pragma Make Config_Needed += local
#pragma Make Includes_Banned += -nostdinc -nostdinc++
#pragma Make Flags_Banned += -static

#define USE_STDLIB
#include <sys/types.h>
#include <defines>
#include <unistd.h>
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <cstdarg>
#include <fcntl.h>

#include <CObj>
#include <CLex>
#include <CParse>
#include <vCAction>
#include <TokenList>	// perhaps should be part of CAction
#include <StrTab>
#include <SymTab>
#include <posix/assert.h>

#include <CRep>

#include "COut.hh"


#define INTERNAL_ERROR	{ _err.internal_error(__FILE__, __LINE__, __FUNCTION__); \
			  for(;;) ; }

// lexical shortcuts
typedef vStrTab::Id Id;
typedef vCAction::Token Token;
typedef CLex::Token LToken;
typedef vCAction::Item Item;


sz *
strpcat(sz *str, csz *prefix)
{
	size_t n = strlen(prefix);
	memmove(str+n, str, strlen(str)+1);
	memcpy(str, prefix, n);
	return str;
}


struct objtn { obj_Integral *o; csz *n; } itypes[] = {
	{&Type_char, "char"},
	{&Type_schar, "signed char"},
	{&Type_uchar, "unsigned char"},
	{&Type_int, "int"},
	{&Type_uint, "unsigned int"},
	{&Type_short, "short"},
	{&Type_ushort, "unsigned short"},
	{&Type_long, "long"},
	{&Type_ulong, "unsigned long"},
	{&Type_long2, "long long"},
	{&Type_ulong2, "unsigned long long"},
	{0, 0},
};


csz*
simple_typename(const type_t type)
{
	for(objtn *ip = itypes; ip->n; ip++) {
		if(ip->o == type)
			return ip->n;
	}
	return "?";
}

void
CCOut::_assertfail(csz *cond, csz *file, int line)
{
	sz buf[MAXIDLEN];

	onl();
	_err.error("Assertion \"%s\" failed (%s:%d)", cond, file, line);
	if(_curdecl)
		_err.error("Failed for %s", scoped_string(_curdecl, buf, true));
	_err.internal_error(file, line, 0);
}

sz *
CCOut::literal_string(const type_t type, uint64 val, sz *s)
{
	sz *saveobuf = _obuf;
	_obuf = s;
	printliteral(type, val);
	_obuf = saveobuf;
	return s;
}


sz *
CCOut::dbg_type_string(const type_t type, sz *s)
{
	assert(s);

	if(!type)
		strcat(s, "<null>");
	else if(Method *meth = dcast_Method(type)) {
		strcat(s, "Method(");
		s = dbg_type_string(meth->otype(), s);
		strcat(s, ",");
		s = dbg_type_string(meth->ftype(), s);
		strcat(s, ")");
	} else if(Func *func = dcast_Func(type)) {
		strcat(s, "Func(");
		if(func->scope())
			scoped_string(func->scope(), s+strlen(s));
		else
			strcat(s, "<null>");
		strcat(s, ", ");
		dbg_type_string(func->rtype(), s);
		strcat(s, ", ");
		dbg_type_string(func->psig(), s);
	} else if(Params *par = dcast_Params(type)) {
		strcat(s, "Params(");
		for(uint i=0; i<par->nparam(); i++) {
			if(i)
				strcat(s, ", ");
			s = dbg_type_string(par->ptype(i), s);
		}
		if(par->is_variable())
			strcat(s, "...");
		strcat(s, ")");
	} else if(Array *array = dcast_Array(type)) {
		sprintf(s+strlen(s), "Array(%d, ", array->size());
		s = dbg_type_string(array->rtype(), s);
		strcat(s, ")");
	} else if(PtrTo *ptr = dcast_PtrTo(type)) {
		strcat(s, "PtrTo(");
		if(ptr->is_volatile()) strcat(s, "v, ");
		if(ptr->is_const()) strcat(s, "c, ");
		s = dbg_type_string(ptr->rtype(), s);
		strcat(s, ")");
	} else if(RefTo *ref = dcast_RefTo(type)) {
		strcat(s, "RefTo(");
		if(ref->is_volatile()) strcat(s, "v, ");
		if(ref->is_const()) strcat(s, "c, ");
		s = dbg_type_string(ref->rtype(), s);
		strcat(s, ")");
	} else if(Qualifier *qual = dcast_Qualifier(type)) {
		strcat(s, "Qual(");
		if(qual->is_volatile()) strcat(s, "v, ");
		if(qual->is_const()) strcat(s, "c, ");
		s = dbg_type_string(qual->rtype(), s);
		strcat(s, ")");
	} else if(DeclRef *dref = dcast_DeclRef(type)) {
		strcat(s, "DeclRef(");
		scoped_string(dref->decl(), s+strlen(s));
		strcat(s, ")");
	} else if(Aggr *aggr = dcast_Aggr(type)) {
		strcat(s, "Aggr(");
		if(aggr->name())
			strcat(s, cstr(aggr->name()));
		else
			strcat(s, "<null>");
		if(aggr->scope())
			sprintf(s+strlen(s), "%p", aggr->scope());
		strcat(s, ")");
	} else if(Enum *enm = dcast_Enum(type)) {
		strcat(s, "Enum(");
		scoped_string(enm->decl(), s+strlen(s));
		strcat(s, ")");
	} else if(Integral *integ = dcast_Integral(type)) {
		sprintf(s+strlen(s), "Integral(%d,%d,%c,%c)",
			integ->bitsize(), integ->alignment(),
			integ->is_signed() ? 's' : 'u',
			integ->is_big_endian() ? 'b' : 'l');
	} else if(type == &Type_bool)
		strcat(s, "bool");
	else if(type == &Type_wchar)
		strcat(s, "wchar_t");
	else if(type == &Type_float)
		strcat(s, "float");
	else if(type == &Type_double)
		strcat(s, "double");
	else if(type == &Type_void)
		strcat(s, "void");
	else if(type->is_null())
			strcat(s, "<null type>"); 
	else {
		sprintf(s+strlen(s), "<unknown:%p/%#llx>",
				type->type(), type->data());
	}
	return s;
}

sz *
CCOut::type_string(const type_t type, sz *s)
{
	assert(s);

	sz buf[MAXTYPELEN];

	if(_debugtypes) {
		if(*s)
			strcat(s, ": ");
		return dbg_type_string(type, s);
	}
	if(!type)
		return s;
	if(Method *meth = dcast_Method(type)) {
		type_t otype = meth->otype();
		bool is_const = false;
		bool is_volatile = false;
		while(Qualifier *qual = dcast_Qualifier(otype)) {
			if(qual->is_const())
				is_const = true;
			if(qual->is_volatile())
				is_volatile = true;
			otype = qual->rtype();
		}
		if(s[0] == '*') {
			type_t ot = meth->otype();
			while(Qualifier *qual = dcast_Qualifier(ot))
				ot = qual->rtype();
			strpcat(s, "::");
			s = type_string(ot, s);
			strpcat(s, "(");
			strcat(s, ")");
		}
		s = type_string(meth->ftype(), s);
		if(is_const)
			strcat(s, " const");
		if(is_volatile)
			strcat(s, " volatile");
	} else if(Func *func = dcast_Func(type)) {
		if(s[0] == '*' || s[0] == '&') {
			strpcat(s, "(");
			strcat(s, ")");
		}
		Scope savescope = scope();
		assert(func->scope());
		scope(func->scope());
		strcat(s, "(");
		for(uint i=0; i<func->nparam(); i++) {
			if(i)
				strcat(s, ", ");
			Decl *d = param_decl(func, i);
			if(d && d->id)
				strcpy(buf, cstr(d->id));
			else 
				buf[0] = '\0';
			strcat(s, type_string(func->ptype(i),
						buf));
			if(d && d->initialized) {
				strcat(s, " = ");
				if(d->storage == TDecl::sc_constant)
					sprintf(s+strlen(s), "%lld", d->c.val);
				else {
					sz *saveobuf = _obuf;	
					_obuf = s+strlen(s);
					printexpr(d->v.expr);
					_obuf = saveobuf;
				}
			}
		}
		if(func->is_variable()) {
			if(func->nparam())
				strcat(s, ", ");
			strcat(s, "...");
		}
		strcat(s, ")");
		scope(savescope);
		s = type_string(func->rtype(), s);
	} else if(Params *par = dcast_Params(type)) {
		if(s[0] == '*' || s[0] == '&') {
			strpcat(s, "(");
			strcat(s, ")");
		}
		strcat(s, "(");
		for(uint i=0; i<par->nparam(); i++) {
			if(i)
				strcat(s, ", ");
			buf[0] = '\0';
			strcat(s, type_string(par->ptype(i),
						buf));
		}
		if(par->is_variable()) {
			if(par->nparam())
				strcat(s, ", ");
			strcat(s, "...");
		}
		strcat(s, ")");
	} else if(Array *array = dcast_Array(type)) {
		if(s[0] == '*' || s[0] == '&') {
			strpcat(s, "(");
			strcat(s, ")");
		}
		if(array->size() == NPOS) {
			Expr e = reinterpret_cast<ExprNode*>(array->dsize());
			if(e) {
				buf[0] = '[';
				buf[1] = '\0';
				sz *saveobuf = _obuf;
				_obuf = &buf[1];
				printexpr(e);
				_obuf = saveobuf;
				strcat(buf, "]");
			} else
				sprintf(buf, "[]");
		} else if(0 == array->lower_bound()) 
			sprintf(buf, "[%d]", array->size());
		else
			sprintf(buf, "[%d..%d]", array->lower_bound(),
					array->upper_bound());
		strcat(s, buf);
		s = type_string(array->rtype(), s);
	} else if(PtrTo *ptr = dcast_PtrTo(type)) {
		if(ptr->is_volatile()) strpcat(s, "volatile ");
		if(ptr->is_const()) strpcat(s, "const ");
		strpcat(s, "*");
		s = type_string(ptr->rtype(), s);
	} else if(RefTo *ref = dcast_RefTo(type)) {
		if(ref->is_volatile()) strpcat(s, "volatile ");
		if(ref->is_const()) strpcat(s, "const ");
		strpcat(s, "&");
		s = type_string(ref->rtype(), s);
	} else if(Qualifier *qual = dcast_Qualifier(type)) {
		type_t rtype = qual->rtype();
		s = type_string(rtype, s);
		if(rtype->is_type(Type_Func)) {
			if(qual->is_volatile()) strcat(s, " volatile");
			if(qual->is_const()) strcat(s, " const");
		} else {
			if(qual->is_volatile()) strpcat(s, "volatile ");
			if(qual->is_const()) strpcat(s, "const ");
		}
	} else {
		if(*s) strpcat(s, " ");
		if(DeclRef *dref = dcast_DeclRef(type)) {
			sz buf[MAXIDLEN];
			Decl *decl = dref->decl();
			strpcat(s, scoped_string(decl, buf));
		} else if(Aggr *aggr = dcast_Aggr(type)) {
			/* XXX - needs scope */
			if(aggr->name())
				strpcat(s, cstr(aggr->name()));
			else if (aggr->scope()) {
				Decl *d = Scope(aggr->scope()).decl();
				strpcat(s, cstr(d->id));
			} else {	
				sprintf(buf, "anonymous%lx", (uintptr)aggr->scope());
				strpcat(s, buf);
			}
			if(aggr->scope()) {
				sz buf[MAXIDLEN];
				scoped_string(Scope(aggr->scope()).parent(), buf);
				strpcat(s, buf);
			}
		} else if(Enum *enm = dcast_Enum(type)) {
			sz buf[MAXIDLEN];
			strpcat(s, scoped_string(enm->decl(), buf));
		} else if(type->is_type(Type_Integral)) 
			strpcat(s, simple_typename(type));
		else if(type == &Type_bool)
			strpcat(s, "bool");
		else if(type == &Type_wchar)
			strpcat(s, "wchar_t");
		else if(type == &Type_float)
			strpcat(s, "float");
		else if(type == &Type_double)
			strpcat(s, "double");
		else if(type == &Type_void)
			strpcat(s, "void");
		/* else if(type->is_null())
			strpcat(s, "<null>");  */
		else {
			sprintf(buf, "<unknown:%p/%#llx>",
				type->type(), type->data());
			strpcat(s, buf);
		}
	}
	return s;
}

/*
sz*
CCOut::fullscoped_string(Id id, Scope sc, sz *s)
{
	Scope parent = sc.parent();
	if(parent) {
		s = scoped_string(sc.pchid(), parent, s);
		strcat(s, "::");
	} else
		strcpy(s, "::");
	strcat(s, cstr(id));
	return s;
}
*/


sz*
CCOut::scoped_string(Scope sc, sz *s)
{
	assert(sc);
	assert(s);

	Scope parent = sc.parent();
	if(sc == scope()) 
		*s = '\0';
	else if(!parent) 
		strcpy(s, "::");
	else {
		Decl *d = sc.decl();
		Scope st = 0;
		csz *sn;
		if(!d)
			sn = "{";
		else if(!d->id)
			sn = "?";
		else if(d->id == ID_ANON)
			sn = "<anon>";
		else if(d->id == ID_FRIEND)
			sn = "<friend>";
		else {
			sn = cstr(d->id);
			if(Decl *nd = scope().tfind(d->id)) {
				type_t t = nd->ptype;
				if(Aggr *aggr = dcast_Aggr(t)) 
					st = aggr->scope();
			}
		}
		sz *sp = s;
		if(st != sc || _fullscope) 
			sp += strlen(scoped_string(parent, sp));
		strcpy(sp, sn);
		if(d && d->is_func && !_debugtypes)
			type_string(d->rtype, sp);
		strcat(sp, "::");
	}
	return s;
}


static bool
canfind(Decl *decl, const Scope inscope, bool withtag)
{
	Decl *d;
	d = inscope.tfind(decl->id, withtag);
	while(d && d != decl && !d->odeclared && !inscope.pchid())
		d = d->link;
	if(!d && inscope.parent())
		return canfind(decl, inscope.parent(), withtag);
	return d == decl || (d && d->scope == decl->scope);
}

sz*
CCOut::scoped_string(Decl *decl, sz *s, bool needtag)
{
	assert(decl);
	assert(s);

	Scope sc = decl->scope;
	if(_fullscope) {
		needtag = true;
		scoped_string(sc, s);
	} else if(canfind(decl, scope(), false)) {
		*s = '\0';
	} else {
		if(decl->tagged() && canfind(decl, scope(), true)) {
			*s = '\0';
			needtag = true;
		} else {
			if(decl->tagged() && !canfind(decl, sc, false))
				needtag = true;
			scoped_string(sc, s);
		}
	}
	{
		csz *ss = cstr(decl->id);
		while(*ss == ' ')
			++ss;
		strcat(s, ss);
	}
	if(needtag && decl->tagged()) {
		strpcat(s, " ");
		strpcat(s, TDecl::dtname[decl->dtype]);
	}
	return s;
}


void
CCOut::onl(int y)
{
	while(_nl < y) {
		if(_obuf) 
			strcat(_obuf, " ");
		else
			printf("\n");
		_x = 0;
		++_nl;
	}
}

void
CCOut::onltab(int x)
{
	onl();
	if(x < 0)
		x = _indent;
	if(x < _x) {
		if(!_obuf)
			printf("\n");
		++_nl;
		_x = 0;
	}
	if(x > _x && !_obuf)
		printf("%*s", x-_x, "");
	_x = x;
}


int
CCOut::oprintf(csz *fmt, ...)
{
	sz buf[MAXLINELEN];
	sz *b = buf;
	int n;
	if(_sectionlabel && !_obuf) {
		onl(2);
		csz *s = _sectionlabel;
		_sectionlabel = 0;
		oprintf("// %s", s);
		onl();
	}
	if(!_obuf && _x == 0)
		onltab();
	if(_obuf) 
		b = _obuf+strlen(_obuf);
	va_list ap;
	va_start(ap, fmt);
	n = vsprintf(b, fmt, ap);
	va_end(ap);
	if(n > 0 && !_obuf) {
		/* better splitting logic could go here */
		if(_wid && _x > _indent+1 && _x + n >= _wid) {
			onltab();
			oprintf(" ");
		}
		printf("%s", buf);
		_nl = 0;
		_x += n;
	}
	return n;
}


void
CCOut::printliteral(const type_t type, uint64 val)
{
	assert(type);

	csz *fmt;
	bool use64 = false;
	if(type == &Type_int) 
		fmt = "%d";
	else if(type == &Type_uint)
		fmt = "%uU";
	else if(type == &Type_long)
		fmt = "%ldL";
	else if(type == &Type_ulong)
		fmt = "%luUL";
	else if(type == &Type_long2) {
		fmt = "%lldLL"; use64 = true;
	} else if(type == &Type_ulong2) {
		fmt = "%lluULL"; use64 = true;
	} else if(type == &Type_char) {
		char ch = val;
		oprintf("%s", _clex.token_string(CLex::CHAR, &ch, 1));
		return;
	} else if(type == &Type_bool) {
		oprintf(val ? "true" : "false");
		return;
	} else if(type == &Type_Str) {
		oprintf("%s", _clex.token_string(CLex::STR, cstr((vStrTab::Id)val)));
		return;
	} else {
		sz buf[MAXTYPELEN];
		buf[0] = '\0';
		if((int64)val >= -1 && (int64)val <= 1)
			fmt = "((%s)%lld)";
		else
			fmt = "((%s)0x%llx)";
		oprintf(fmt, type_string(type, buf), val);
		return;
	}
	if(use64)
		oprintf(fmt, val);
	else
		oprintf(fmt, (uint32)val);
}


void
CCOut::printexprlist(ExprList exprlist)
{
	bool line = exprlist.fmt() == T(LINE);
	if(line) {
		rshift();
		onl();
	}
	for(Expr e = exprlist.first(); e; e++) {
		printexpr(e);
		if(e.next())
			oprintf(", ");
		if(line)
			onl();
	}
	if(line)
		lshift();
}

void
CCOut::printstmtlist(StmtList stmtlist)
{
	const Scope savescope = scope();
	if(stmtlist.scope())
		scope(stmtlist.scope());
	oprintf("{");
	rshift();
	for(Stmt s = stmtlist.first(); s; s++) {
		onl();
		printstmt(s);
	}
	lshift();
	onl();
	oprintf("}");
	scope(savescope);
}

void
CCOut::printdecllist(StmtList stmtlist)
{
	const Scope savescope = scope();
	bool first = true;
	if(stmtlist.scope())
		scope(stmtlist.scope());
	for(Stmt s = stmtlist.first(); s; s++) {
		assert(s.op() == T(DECL));
		Decl *d = s.left().decl();
		if(first) 
			define_sym(d, false);
		else {
			oprintf(", %s = ", cstr(d->id));
			printexpr(d->v.expr);	/* XXX - const? */
		}	
		d->odeclared = true;
		d->odefined = true;
		first = false;
	}
	scope(savescope);
}

void
CCOut::printctorinit(StmtList stmtlist)
{
	if(stmtlist.empty())
		return;
	const Scope savescope = scope();
	if(stmtlist.scope())
		scope(stmtlist.scope());
	rshift();
	onltab(_indent-2);
	oprintf(": ");
	for(Stmt s = stmtlist.first(); s; ) {
		sz buf[MAXIDLEN];
		assert(s.left().op() == T(VAL_ID));
		oprintf("%s", scoped_string(s.left().decl(), buf, false));
		oprintf("(");
		printexpr(s.right());
		oprintf(")");
		if(++s) {
			oprintf(",");
			onl();
		}
	}
	lshift();
	onl();
	scope(savescope);
}

void
CCOut::printstmt(Stmt stmt)
{
	if(!stmt)
		return;
	switch(stmt.op()) {
	case T(KW_IF):
		oprintf("if");
		printexpr(stmt.left(), true);
		printstmti(Stmt(stmt.mid()));
		if(stmt.right()) {
			if(stmt.mid().op() == T(STMTLIST))
				oprintf(" ");
			else
				onl();
			oprintf("else");
			if(stmt.right().op() == T(KW_IF)) {
				oprintf(" ");
				printstmt(Stmt(stmt.right()));
			} else
				printstmti(Stmt(stmt.right()));
		}
		break;
	case T(KW_DO):
		oprintf("do");
		if(stmt.mid().op() != T(STMTLIST)) {
			oprintf(" ");
			printstmt(Stmt(stmt.mid()));
		} else
			printstmti(Stmt(stmt.mid()));
		oprintf(" while");
		printexpr(stmt.right(), true);
		oprintf(";");
		break;
	case T(KW_WHILE):
		oprintf("while");
		printexpr(stmt.left(), true);
		printstmti(Stmt(stmt.mid()));
		break;
	case T(KW_SWITCH):
		oprintf("switch");
		printexpr(stmt.left(), true);
		printstmti(Stmt(stmt.mid()));
		break;
	case T(KW_FOR): {
		const Scope savescope = scope();
		Expr left = stmt.left();
		Expr forinit = left.left();
		Expr forcond = left.mid();
		if(forinit && forinit.op() == T(STMTLIST)) {
			StmtList stmtlist(forinit);
			if(stmtlist.scope())
				scope(stmtlist.scope());
		} else if(forcond && forcond.op() == T(STMTLIST)) {
			StmtList stmtlist(forcond);
			if(stmtlist.scope())
				scope(stmtlist.scope());
		}
		oprintf("for");
		printexpr(stmt.left(), true);
		printstmti(Stmt(stmt.mid()));
		scope(savescope);
		} break;
	case T(KW_RETURN):
		oprintf("return ");
		printexpr(stmt.left());
		oprintf(";");
		break;
	case T(KW_GOTO):
		oprintf("goto ");
		printexpr(stmt.left());
		oprintf(";");
		break;
	case T(KW_BREAK):
		oprintf("break;");
		break;
	case T(KW_CONTINUE):
		oprintf("continue;");
		break;
	case T(KW_DEFAULT):
	case T(KW_CASE):
	case T(COLON):
		onltab(_indent-_tabwid+1);
		if(stmt.op() == T(KW_DEFAULT))
			oprintf("default:");
		else {
			if(stmt.op() == T(KW_CASE))
				oprintf("case ");
			printexpr(stmt.left());
			oprintf(":");
		}
		if(stmt.mid()) {
			onl();
			printstmt(Stmt(stmt.mid()));
		}
		break;
	case T(KW_ASM):
		oprintf("asm(");
		printexpr(stmt.left());
		if(stmt.mid() || stmt.right()) 
			oprintf(" : ");
		if(stmt.mid())
			printexpr(stmt.mid());
		if(stmt.right()) {
			oprintf(" : ");
			printexpr(stmt.right());
		}
		oprintf(");");
		break;
	case T(STMTLIST):
		printstmtlist(StmtList(stmt));
		break;
	case T(CTORINIT):
		printctorinit(StmtList(stmt.left()));
		printstmtlist(StmtList(stmt.mid()));
		break;
	default:
		printexpr(Expr(stmt));
		oprintf(";");
	}
}

void
CCOut::printstmti(Stmt stmt)
{
	if(!stmt) {
		rshift();
		onl();
		oprintf(";");
		lshift();
		return;
	}
	bool tab = (stmt.op() != T(STMTLIST));
	if(tab) {
		rshift();
		onl();
	} else
		oprintf(" ");
	printstmt(stmt);
	if(tab) 
		lshift();
}



void
CCOut::printexpr(Expr expr, bool paren = false)
{
	if(!expr) 
		return;
	if(paren)
		oprintf("(");
	bool space = true;
	sz *fmt;
	type_t t;
	switch(expr.op()) {
	case T(STMTLIST):
		printdecllist(StmtList(expr));
		break;
	case T(EXPRLIST):
		printexprlist(ExprList(expr));
		break;
	case T(KW_FOR): 
		printexpr(expr.left());
		oprintf("; ");
		printexpr(expr.mid());
		oprintf("; ");
		printexpr(expr.right());
		break;
	case T(ARRAY):
		oprintf("{ ");
		printexprlist(ExprList(expr));
		oprintf(" }");
		break;
	case T(VAL_ID): {
		sz buf[MAXIDLEN];
		oprintf("%s", scoped_string(expr.decl(), buf));
		break; }
	case T(TOKENLIST):
		regurgitate(expr.tlist());
		break;
	case T(LITERAL):
		printliteral(expr.lit().type, expr.lit().val);
		break;
	case T(QMARK):
		oprintf("(");
		printexpr(expr.left(), true);
		oprintf("?");
		printexpr(expr.mid(), true);
		oprintf(":");
		printexpr(expr.right(), true);
		oprintf(")");
		break;
	case T(OP_PTRTO): case T(OP_MPTRTO):
		t = dcast_PtrTo(expr.left().rtype())->rtype();
		assert(t);
		goto printmember;
	case T(OP_DOT): case T(OP_MDOT):
		t = expr.left().rtype();
	    printmember:
		{
			while(Qualifier *qual = dcast_Qualifier(t))
				t = qual->rtype();
			Aggr *aggr = dcast_Aggr(t);
			assert(aggr);
			Expr left = expr.left();
			Token op = expr.op();
			int p = tokenprec(op, 0);
			int pleft = tokenprec(left.op(), -1);
			printexpr(left, pleft < p || !p);
			const Scope savescope = scope();
			scope(aggr->scope());
			oprintf("%s", _clex.token_string((LToken)op));
			printexpr(expr.right(), false);
			scope(savescope);
		}
		break;
	case T(OP_NEW):
		oprintf("new ");
		if(expr.right()) {
			oprintf("(");
			printexpr(expr.right());
			oprintf(") ");
		}
		{
			sz buf[MAXTYPELEN];
			buf[0] = '\0';
			type_string(expr.left().rtype(), buf);
			oprintf(strchr(buf, '(') ? "(%s)" : "%s", buf);
		}
		if(expr.mid()) {
			oprintf("(");
			printexpr(expr.mid());
			oprintf(")");
		}
		break;
	case T(OP_CAST): fmt = "(%s)"; goto printcast;
	case T(KW_CCAST): fmt = "const_cast<%s>"; goto printcast;
	case T(KW_RCAST): fmt = "reinterpret_cast<%s>"; goto printcast;
	case T(KW_DCAST): fmt = "dynamic_cast<%s>"; goto printcast;
	case T(KW_SCAST): fmt = "static_cast<%s>"; goto printcast;
	    printcast:
		{
			sz buf[MAXTYPELEN];
			buf[0] = '\0';
			type_string(expr.left().rtype(), buf);
			if(buf[0] == ':')
				strpcat(buf, " ");
			oprintf(fmt, buf);
			oprintf("(");
			printexpr(expr.right());
			oprintf(")");
		}
		break;
	case T(DECL): {
		Decl *d = expr.left().decl();
		if(d->defined)
			define_sym(d, false);
		else
			declare_sym(d, false);
		d->odeclared = true;
		d->odefined = true;
		break; }
	case T(ID):
		oprintf("%s", cstr(expr.id()));
		break;
	case T(OP_TSIZEOF):
		oprintf("sizeof(");
		printexpr(expr.right());
		oprintf(")");
		break;
	default: {
		Expr left = expr.left();
		Expr right = expr.right();
		int p = tokenprec(expr.op(), 0);
		int pleft = left ? tokenprec(left.op(), -1) : 0;
		int pright = right ? tokenprec(right.op(), 1) : 0;
		printexpr(left, pleft < p || !p);
		csz *s = 0, *e = 0;
		switch(Token op = expr.op()) {
		case T(OP_SIZEOF): s = "sizeof "; space = false; break;
		case T(OP_INCP): s = "++"; space = false; break;
		case T(OP_DECP): s = "--"; space = false; break;
		case T(OP_REF): s = "&"; space = false; break;
		case T(OP_PTR): s = "*"; space = false; break;
		case T(OP_UMINUS): s = " -"; space = false; break;
		case T(OP_UPLUS): s = " +"; space = false; break;
		case T(OP_INDEX): s = "["; e = "]"; space = false; break;
		case T(OP_COMMA): s = ", "; space = false; break;
		case T(OP_FUNC): break;
		case T(OP_ADD): case T(OP_SUB):
		case T(OP_MUL): case T(OP_DIV): case T(OP_MOD):
		case T(OP_AND): case T(OP_OR): case T(OP_XOR):
		case T(OP_NOT): case T(OP_LNOT):
		case T(OP_DOT): case T(OP_PTRTO):
		case T(OP_SCOPE): case T(OP_MDOT): case T(OP_MPTRTO):
		case T(OP_LSHIFT): case T(OP_RSHIFT):
		case T(OP_DEC): case T(OP_INC):
			space = false;
		default:
			s = _clex.token_string((LToken)op);
		}
		if(s)
			oprintf(space ?  (_x > _indent ? " %s " : "%s ")
					: "%s", s);
		printexpr(right, pright <= p || !p);
		if(e)
			oprintf("%s", e);
		}
	}
	if(paren)
		oprintf(")");
}


static bool
is_type(Decl *decl)
{
	if(decl->storage == Decl::sc_typedef)
		return true;
	if(decl->dtype == Decl::dt_enum) 
		return true;
	if(Decl::dtflags[decl->dtype] & Decl::DTF_SCOPE)
		return true;
	return false; 
}

static bool
can_declare(Decl *decl)
{
	if(decl->dtype == Decl::dt_enum) 
		return false;
	if(decl->storage == Decl::sc_typedef) 
		return decl->tagged();
	if(decl->is_func)
		return true;
	if(decl->storage == Decl::sc_extern)
		return true;
	if(decl->scope.parent()) {
		return decl->storage == Decl::sc_static;
	} else {
		return decl->storage == Decl::sc_default;
	}
}

static Decl* dependency(Expr expr, Scope outof = 0);
static Decl* dependency(type_t type, Scope outof, bool needdef);
static Decl* dependency(Decl *decl, Scope outof, bool needdef);

static Decl*
dependency(StmtList stmtlist, Scope outof)
{
	for(Stmt s = stmtlist.first(); s; s++) {
		if(Decl *d = dependency(Expr(s), outof))
			return d;
	}
	return 0;
}

static Decl*
dependency(ExprList exprlist, Scope outof)
{
	for(Expr e = exprlist.first(); e; e++) {
		if(Decl *d = dependency(e, outof))
			return d;
	}
	return 0;
}

static Decl*
dependency(Expr expr, Scope outof)
{
	Decl *d;
	if(!expr)
		return 0;
	switch(expr.op()) {
	case T(VAL_ID): 
		d = expr.decl();
		if(d->odeclared)
			return 0;
		if(subscope(outof, d->scope))
			return 0;
		d->oneeddecl = true;
		return d;
	case T(TOKENLIST):
		return 0;	/* XXX */
	case T(LITERAL):
		return 0;
	case T(ARRAY):
	case T(EXPRLIST):
		return dependency(ExprList(expr), outof);
	case T(STMTLIST):
		return dependency(StmtList(expr), outof);
	case T(ID):
	case T(TYPE):
		return 0;	/* XXX */
	case T(DECL):
		return dependency(expr.left().decl(), outof, false);
	case T(OP_CAST):
	case T(KW_CCAST):
	case T(KW_DCAST):
	case T(KW_RCAST):
	case T(KW_SCAST):
	case T(OP_NEW):
		if((d = dependency(expr.left().rtype(), outof, true)))
			return d;
		return dependency(expr.right(), outof);
	case T(CTORINIT):
		if(Decl *d = dependency(expr.left(), outof))
			return d;
		if(Decl *d = dependency(expr.right(), outof))
			return d;
		return 0;
	default: 
		if(Decl *d = dependency(expr.left(), outof))
			return d;
		if(Decl *d = dependency(expr.mid(), outof))
			return d;
		if(Decl *d = dependency(expr.right(), outof))
			return d;
		return 0;
	}
}


static Decl*
dependency(type_t type, Scope outof, bool needdef)
{
	if(!type)
		return 0;
	if(DeclRef *dref = dcast_DeclRef(type)) {
		Decl *decl = dref->decl();
		while(decl->converted)
			decl = decl->next;
		if(needdef) {
			if(!decl->odefined && !subscope(outof, decl->scope)) {
				decl->oneeddef = true;
				return decl;
			}
		} else {
			if(!decl->odeclared && !subscope(outof, decl->scope)) {
				decl->oneeddecl = true;
				return decl;
			}
		}
	} else if(Aggr *aggr = dcast_Aggr(type)) {
		if(Scope sc = aggr->scope()) {
			if(!outof)
				outof = sc;
			if(Decl *d = sc.get(ID_INHERIT)) {
				for(; d; d = d->link) {
					if(!d->i.decl->odefined) {
						d = d->i.decl;
						d->oneeddef = true;
						return d;
					}
				}
			}
			Decl *pd = sc.decl();
			for(Decl *d = pd->a.first; d; d = d->next) {
				if(d->id == ID_FRIEND)
					continue;
				if(Decl *dd = dependency(d->ptype, outof,
						!can_declare(d)))
					return dd;
			}
		}
	} else if(Array *array = dcast_Array(type)) {
		return dependency(array->rtype(), outof, needdef);
	} else if(PtrTo *ptr = dcast_PtrTo(type)) {
		return dependency(ptr->rtype(), outof, false);
	} else if(RefTo *ref = dcast_RefTo(type)) {
		return dependency(ref->rtype(), outof, false);
	} else if(Func *func = dcast_Func(type)) {
		if(Decl *d = dependency(func->rtype(), outof, needdef))
			return d;
		for(uint i=0; i<func->nparam(); i++) 
			if(Decl *d = dependency(func->ptype(i),
						outof, needdef)) 
				return d;
	} else if(Method *meth = dcast_Method(type)) {
		return dependency(meth->ftype(), outof, needdef);
	} else if(Qualifier *qual = dcast_Qualifier(type)) {
		return dependency(qual->rtype(), outof, needdef);
	}
	return 0;
}

static Decl*
dependency(Decl *decl, Scope outof, bool needdef)
{
	bool wasdefined = decl->odefined;
	bool wasdeclared = decl->odeclared;
	if(decl->storage == Decl::sc_typedef && !decl->tagged())
		needdef = false;
	if(wasdefined)
		return 0;
	// if it is to be defined, treat it as such temporarily
	// while scanning sub-dependencies:
	decl->odefined = decl->defined;
	decl->odeclared = true;
	Decl *d = dependency(decl->ptype, outof, needdef);
	if(!d && needdef && decl->initialized
			&& decl->storage != Decl::sc_constant) {
		if(Func *f = dcast_Func(decl->rtype)) {
			if(!outof)
				outof = f->scope();
		}
		d = dependency(Expr(decl->v.expr), outof);
	}
	// restore it to its previous state:
	decl->odefined = wasdefined;
	decl->odeclared = wasdeclared;
	return d;
}

Decl*
CCOut::has_dependency(Decl *decl, bool needdef)
{
	while(Decl *d = dependency(decl, 0, needdef)) {
		if(!d->nooutput(_outmask))
			return d;
		if(d->oneeddecl && !d->odeclared)
			d->odeclared = true;
		else if(d->oneeddef && !d->odefined && d->defined)
			d->odefined = true;
		else {
			sz b1[MAXIDLEN];
			sz b2[MAXIDLEN];
			_err.error("%s depends on %s",
				scoped_string(decl, b1),
				scoped_string(d, b2));
			INTERNAL_ERROR;
		}
	}
	return 0;
}


void
CCOut::print_storageclass(Decl *decl)
{
	switch(decl->storage) {
	case Decl::sc_auto:	oprintf("auto "); break;
	case Decl::sc_static:	oprintf("static "); break;
	case Decl::sc_extern:	oprintf("extern "); break;
	case Decl::sc_register:	oprintf("register "); break;
	case Decl::sc_typedef:	oprintf("typedef "); break;
	case Decl::sc_mutable:	oprintf("mutable "); break;
	case Decl::sc_friend:	oprintf("friend "); break;
	default: break;
	}
	if(decl->is_inline) {
		/* due to a strange gcc 2.7.2 bug, we need to make
		 * sure we don't print 'inline' when defining functions
		 * that return types that were disambiguated with the
		 * global '::' operator.  The following, for example,
		 * breaks with 2.7.2, but works with 2.8.0:
		 *	struct a {};
		 *	struct s { struct a {}; inline ::a f() const; };
		 *	inline ::a s::f() const { ::a x; return x; }
		 * removing the second 'inline' fixes the problem,
		 * so that's essentially what we're doing here.
		 */
		if(scope() == decl->scope)
			oprintf("inline "); 
		else
			oprintf("/*inline*/ ");
	}
	if(decl->is_explicit)
		oprintf("explicit "); 
	if(decl->is_virtual)
		oprintf("virtual "); 
}

void
CCOut::regurgitate(TokenList *t)
{
	assert(t);

	sz c[2];
	int plev = 0;
	Item item;
	LToken tok, prevtok = (LToken)T(NONE);
	bool first = true;
	while(t->next(&item)) {
		if(first && item.token == T(COLON)) {
			rshift();
			onltab(_indent-2); oprintf(": ");
			lshift();
			continue;
		}
		first = false;
		tok = (LToken)item.token;
		switch(prevtok) {
		case T(RBRACE):
			if((tok != (LToken)T(EOS))) {
				if(tok == (LToken)T(KW_ELSE))
					oprintf(" ");
				else
					goto newline;
			}
			break;
		case T(LBRACE):
			rshift();
			goto newline;
			break;
		case T(EOS):
		newline:
			if(plev > 0)
				oprintf(" ");
			else if(tok != (LToken)T(RBRACE))
				onl();
			break;
		default:
			oprintf("%s", _clex.token_spacing(prevtok, tok));
		}
		switch(item.token) {
		case T(NUM):
			oprintf(item.c.is_signed ? "%lld" : "%lluU", item.val);
			for(int i=0; i<item.c.is_long; i++)
				oprintf("L");
			break;
		case T(BOOL):
			oprintf("%s", _clex.token_string(tok, (bool)item.val));
			break;
		case T(CHAR): 
			c[0] = item.val;
			c[1] = '\0';
			oprintf("%s", _clex.token_string(tok, c, 1));
			break;
		case T(STR):
		case T(ID):
			oprintf("%s", _clex.token_string(tok, cstr(item.id)));
			break;
		case T(EOS):
			oprintf(";");
			break;
		case T(LBRACE):
			if(_indent == 0)
				onl();
			oprintf("{");
			break;
		case T(RBRACE):
			lshift();
			if(prevtok == (LToken)T(LBRACE))
				oprintf("}");
			else {
				onl();
				oprintf("}");
			}
			break;
		case T(LPAREN):
			plev++;
			goto dflt;
		case T(RPAREN):
			plev--;
			goto dflt;
		default:
		dflt:
			oprintf("%s", _clex.token_string(tok));
		}
		prevtok = tok;
	}
}

void
CCOut::print_access(Decl *decl)
{
	if(decl->storage == Decl::sc_friend)
		return;
	if(decl->access != _access) {
		onltab(_indent-_tabwid+1);
		oprintf("%s:", Decl::acname[decl->access]);
		onl();
		_access = decl->access;
	}
}

void
CCOut::define_aggr(Decl *decl)
{
	sz buf[MAXIDLEN];
	Aggr *aggr = (Aggr*)decl->ptype->ptr();
	Scope scope = aggr->scope();
	if(!scope)
		return;
	Id aid = aggr->name();
	if(aid && aid != decl->id)
		oprintf(" %s", cstr(aid));
	else {
		Scope scope = aggr->scope();
		if(Decl *d = scope.get(ID_INHERIT)) {
			oprintf(" : ");
			while(d) {
				Decl *bd = d->i.decl;
				if(d->access != (decl->dtype == TDecl::dt_class ? 
						TDecl::ac_private : TDecl::ac_public))
					oprintf("%s ", Decl::acname[d->access]);
				oprintf("%s", scoped_string(
					bd, buf, false));
				if((d = d->link))
					oprintf(", ");
			}
		}
		if(scope_empty(scope))
			oprintf(" {}");
		else {
			oprintf(" {");
			rshift();
			print_decls(scope, decl->dtype == Decl::dt_class
				? Decl::ac_private : Decl::ac_public); 
			lshift();	
			onl();
			oprintf("}");
		}
	}
}

void
CCOut::define_enum(Decl *decl)
{
	oprintf(" {");
	rshift();
	for(Decl *d = decl->a.first; d; d = d->next) {
		if(DeclRef *dref = dcast_DeclRef(d->ptype)) {
			Decl *d2 = dref->decl();
			if(d2 == decl) {
				onl();
				oprintf("%s = %lld,", cstr(d->id), (int64)d->c.val);
				d->odeclared = true;	
				d->odefined = true;
			}
		}
	}
	lshift();
	onl();
	oprintf("}");
}

void
CCOut::define_sym(Decl *decl, bool eos)
{
	sz buf[MAXTYPELEN+MAXIDLEN];

	if(interface()) {
		if(!decl->field && decl->access == Decl::ac_private)
			return;
		if(decl->storage == Decl::sc_static)
			return;
		if(decl->is_func) {
			if(!decl->is_inline)
				return;
		} else {
			if(decl->storage != Decl::sc_typedef)
				return;
		}
	}
	if(onlyinterface()) {
		if(decl->access == Decl::ac_private)
			return;
		if(decl->storage != Decl::sc_typedef)
			return;
	}

	if(scope().parent())
		print_access(decl);

	_curdecl = decl;

	if(!decl->defined) {
		oprintf("/* ");
		declare_sym(decl);
		oprintf(" */");
		return;
	}

	if(decl->anon) 
		strcpy(buf, TDecl::dtname[decl->dtype]);
	else
		strcpy(buf, scoped_string(decl, buf, true));
	const Scope savescope = scope();
	if(decl->is_func) {
		if(decl->storage != TDecl::sc_typedef
		 && decl->storage != TDecl::sc_constant
		 && _indent == 0)
			strpcat(buf, "\n");
	}
	if(decl->ptype->is_type(Type_Aggr)) {
		if(_indent == 0)
			onl(2);
		oprintf("%s", buf);
		define_aggr(decl);
	} else if(decl->dtype == Decl::dt_enum) {
		oprintf("%s", buf);
		define_enum(decl);
	} else {
		// if(decl->scope == savescope) 
		print_storageclass(decl);
		oprintf("%s", type_string(decl->ptype, buf));
	}
	scope(decl->scope);
	if(decl->initialized) {
		if(decl->is_func && !decl->is_purevirtual()) {
			Expr e = decl->v.expr;
			if(e.op() == T(STMTLIST) && StmtList(e).empty()) {
				oprintf(" {}");
				onl();
				scope(savescope);
				return;
			}
			onl();
			printstmt(decl->v.expr);
		} else {
			if(decl->storage == TDecl::sc_constant)
				oprintf(" = %lld", decl->c.val);
			else {
				if(Expr(decl->v.expr).op() == T(EXPRLIST)) {
					oprintf("(");
					printexpr(decl->v.expr);
					oprintf(")");
				} else {
					oprintf(" = ");
					printexpr(decl->v.expr);
				}
			}
			if(eos)
				oprintf(";");
		}
	} else if(eos)
		oprintf(";");
	scope(savescope);
}


void
CCOut::declare_sym(Decl *decl, bool eos)
{
	sz buf[MAXTYPELEN+MAXIDLEN];
	csz *ss;

	_curdecl = decl;

	if(interface()) {
		if(!decl->field && decl->access == Decl::ac_private)
			return;
		if(decl->storage == Decl::sc_static)
			return;
	}
	if(onlyinterface()) {
		if(decl->access == Decl::ac_private)
			return;
		if(decl->storage == Decl::sc_static)
			return;
	}
	if(scope().parent())
		print_access(decl);

	if(!decl->is_func && decl->storage != Decl::sc_typedef
			&& decl->storage != Decl::sc_extern
			&& !scope().parent()) {
		if(decl->storage == Decl::sc_default)
			oprintf("extern ");
		else
			oprintf("/* extern */ ");
	}

	if(!(Decl::dtflags[decl->dtype] & Decl::DTF_SCOPE)) {
		Decl *d = decl->scope.decl();
		if(d && dcast_Aggr(d->ptype)) {
			if(!decl->field && !decl->is_method
					&& decl->storage != Decl::sc_friend)
				oprintf("static ");
		}
		print_storageclass(decl);
	} 
	if(decl->id == ID_ANON) {
		if(DeclRef *dref = dcast_DeclRef(decl->ptype)) {
			if(dref->decl()->anon)
				define_sym(dref->decl(), eos);
			else {
				buf[0] = '\0';
				oprintf("%s", type_string(decl->ptype, buf));
				if(eos) {
					oprintf(";");
					onl();
				}
			}
		} else
			INTERNAL_ERROR;
		return;
	} else if(decl->id == ID_FRIEND) {
		ss = "";
	} else {
		// ss = cstr(decl->id);
		ss = scoped_string(decl, buf);
		while(*ss == ' ')
			++ss;
	}

	strcpy(buf, ss);
	if(Decl::dtflags[decl->dtype] & Decl::DTF_SCOPE)
		oprintf("%s %s", Decl::dtname[decl->dtype], buf);
	else 
		oprintf("%s", type_string(decl->ptype, buf));
	if(decl->bitfield)
		oprintf(":%d", decl->b.bsize);
	if(eos)
		oprintf(";");
	if(decl->storage == Decl::sc_static && !decl->defined)
		oprintf("\t/* undefined */");
	if(eos)
		onl();
}


void
CCOut::print_decls(const Scope sc, bool checkdep, int dtm)
{
	int nfail, ndec, ndef;
	bool failed = false;
	Decl *pd = sc.decl();
	Decl *lf = 0;
	do {
		nfail = ndec = ndef = 0;
		for(Decl *d = pd->a.first; d; d = d->next) {
			if(d->nooutput(_outmask) || d->odefined)
				continue;
			if(is_type(d)) {
				if(!(dtm&DTM_TYPE))
					continue;
			} else if(d->storage == Decl::sc_constant) {
				if(!(dtm&DTM_CONST))
					continue;
			} else {
				if(d->is_func) {
					if(!(dtm&DTM_FN))
						continue;
				} else {
					if(!(dtm&DTM_VAR))
						continue;
				}
				if(d->storage == Decl::sc_static) {
					if(!(dtm&DTM_LOC))
						continue;
				} else if(d->defined) {
					if(!(dtm&DTM_EXP))
						continue;
				} else {
					if(!(dtm&DTM_IMP))
						continue;
				}
			}
			bool dep = has_dependency(d, false);
			if(dep && checkdep && !failed) {
				if(!d->odeclared && d->oneeddecl
						&& !d->anon && can_declare(d)) {
					onl();
					declare_sym(d);
					d->odeclared = true;
					ndec++;
				}
				lf = d;
				++nfail;
			} else {
				onl();
				d->odeclared = true;
				++ndec;
				bool def = false;
				if(is_type(d)) 
					def = true;
				if(d->is_func && d->initialized) {
					if(d->is_purevirtual()) 
						def = true;
					if(d->is_inline && Expr(d->v.expr).op() == T(STMTLIST))
						if(StmtList(d->v.expr).empty()) 
							def = true;
				}
				if(d->storage == Decl::sc_constant)
					def = true;
				if(!d->defined)
					def = false;

				if(def) {
					define_sym(d);
					d->odefined = true;
					++ndef;
				} else if(!d->anon) 
					declare_sym(d);
			} 
		}
		if(nfail > 0 && ndec+ndef == 0) {
			sz b1[MAXIDLEN];
			sz b2[MAXIDLEN];
			onl();
			oprintf("/*** declaration dependency ordering failed"
						" (%s : %s) ***/",
				scoped_string(lf, b1),
				scoped_string(has_dependency(lf, false), b2));
			failed = true;
		}
	} while(nfail);
	onl();
}



void
CCOut::print_decls(const Scope sc, TDecl::Access acc)
{
	TDecl::Access saveacc = _access;
	const Scope savescope = scope();
	_access = acc;
	scope(sc);
	if(!scope().parent()) {
		sectionlabel("constants:");
		print_constants(sc);
		sectionlabel("types:");
		print_types(sc);
		sectionlabel(hdr() ? "external:" : "imports:");
		print_fn_imports(sc);
		print_var_imports(sc);
		sectionlabel(hdr() ? "local exports/inline:" : "exports:");
		print_fn_exports(sc);	
		print_var_exports(sc);
		sectionlabel("local:");
		print_fn_local(sc);	
		sectionlabel(0);
		onl(2);
	} else {
		print_constants(sc);
		print_types(sc);
		print_var_imports(sc);
		print_var_exports(sc);
		print_fn_imports(sc);
		print_fn_exports(sc);
	}
	_access = saveacc;
	scope(savescope);
	onl();
}



void
CCOut::print_defs(const Scope sc)
{
	int nfail, ndec, ndef;

	Decl *pd = sc.decl();

	//TDecl::Access saveacc = _access;
	//const Scope savescope = _scope;
	//_access = TDecl::ac_public;
	//_scope = sc;

	onl(2);

	do {
		nfail = ndec = ndef = 0;
		for(Decl *d = pd->a.first; d; d = d->next) {
			if(d->nooutput(_outmask) || !d->defined)
				continue;
			if(!d->odefined && !d->is_func) {
			    if(Decl *dn = has_dependency(d, true)) {
				if(!d->odeclared && d->oneeddecl) {
					onl();
					declare_sym(d);
					d->odeclared = true;
					ndec++;
				}
				char buf[MAXIDLEN];
				printf("/* needs `%s' */ ", scoped_string(dn, buf));
				declare_sym(d);
				nfail++;
			    } else {
				onl();
				define_sym(d);
				d->odefined = true;
				ndef++;
				d->odeclared = true;
				ndec++;
			    }
			}
		}
		if(nfail > 0 && ndec+ndef == 0) {
			onl();
		    	oprintf("/*** definition dependency"
				 	" ordering failed ***/");
			onl();
			break;
		}
	} while(nfail);
	for(Decl *d = pd->a.first; d; d = d->next) {
		if(Aggr *aggr = dcast_Aggr(d->ptype)) {
			Scope scope = aggr->scope();
			if(scope && !d->nooutput(_outmask))
				print_defs(scope);
		}
	}    
	for(Decl *d = pd->a.first; d; d = d->next) {
		if(d->nooutput(_outmask) || !d->defined)
			continue;
		if(!d->odefined) {
			if(d->is_func && !d->initialized)
				continue;
			onl(2);
			define_sym(d);
			d->odeclared = true;
			d->odefined = true;
		}
	}

	//_access = saveacc;
	//_scope = savescope;
	onl();
}


void
CCOut::print_reqs(const Scope sc)
{
	Decl *pd = sc.decl();

	sectionlabel("external declaration requirements:");
	for(Decl *d = pd->a.first; d; d = d->next) {
		if(!d->nooutput(_outmask))
			continue;
		if(!d->oneeddecl || d->oneeddef)
			continue;
		oprintf("//\t");
		declare_sym(d);
		onl();
	}

	sectionlabel("external definition requirements:");
	for(Decl *d = pd->a.first; d; d = d->next) {
		if(!d->nooutput(_outmask))
			continue;
		if(!d->oneeddef)
			continue;
		oprintf("//\t");
		declare_sym(d);
		onl();
	}
}


CCOut::CCOut(vErrorReport &err, const Scope scope, TDecl::Access access)
	: _err(err), _clex(_buf, sizeof _buf)
{
	_scope = scope;
	_access = access;
	_strtab = scope.strtab();
	_x = 0;
	_nl = 1;
	_tabwid = 4;
	_obuf = 0;
	_fullscope = false;
	_debugtypes = false;
	_wid = 0;
	_outmask = (1<<Decl::OT_FROMHDR)|(1<<Decl::OT_HDR)|(1<<Decl::OT_CODE)
			|(1<<Decl::OT_REPOS);
}

