/*  $Id: TokenList.cc,v 1.4 1998/08/22 03:35:16 shaggy Exp $
 *      Token list
 *      
 *      relative path: .//lib/cparse
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Libraries
 *        C/C++ Parsing classes
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is part of the Shag/OS distribution, and may be freely used and
 *  distributed by the terms of the ShagWare Non-profit Public License (SNPL),
 *  version 2, or, at your option, any newer official version of that License.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND,
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE, AND WILL NOT BE LIABLE FOR ANY DAMAGES.
 *  For more warranty details, see the ShagWare Non-profit Public License, which
 *  should have been received with this program, in a file called 'lic_spl2.txt'
 *  If this license is missing, please contact the author and describe how
 *  this software was obtained.  Email: shaggy@csh.rit.edu
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/*  
 *  $Log: TokenList.cc,v $
 *  Revision 1.4  1998/08/22 03:35:16  shaggy
 *  header update
 *
 *  Revision 1.3  1998/08/12 15:18:36  shaggy
 *  better typing; fixed some type coercions;
 *  cleanup for #include's, and fixed some constructor call bugs
 *
 *  Revision 1.2  1998/07/28 19:55:27  shaggy
 *  moved most of generic parsing from Deco into CAction
 *
 *  Revision 1.1  1998/04/11 21:49:28  shaggy
 *  added token saving (for regurgitation)
 *
 *
 */

#include <defines>
#include <inttypes.h>
#include <posix/stdarg.h>
#include <posix/string.h>
#include <vCAction>
#include "TokenList.hh"


TokenList::~TokenList()
{
	Item v;
	while(next(&v))
		;
}

int
TokenList::next(Item *r)
{	
	Node *n;
	if(!(n = _first))
		return 0;
	_first = n->next;
	*r = n->item;
	delete n;
	return r->token;
}

void
TokenList::append(Item_ v)
{
	Node *n = new Node;
	n->item = v;
	n->next = 0;
	if(_last) 
		_last->next = n;
	else 
		_first = n;
	_last = n;
}

void
TokenList::prepend(Item_ v)
{
	Node *n = new Node;
	n->item = v;
	n->next = _first;
	_first = n;
	if(!_last)
		_last = n;
}

void
TokenList::append_delete(TokenList *t)
{
	if(_last) 
		_last->next = t->_first;
	else 
		_first = _last = t->_first;
	if(t->_last)
		_last = t->_last;
	t->_first = t->_last = 0;
	delete t;
}

