/*  $Id: TokenList.hh,v 1.3 1998/08/22 03:35:16 shaggy Exp $
 *      Token list
 *      
 *      relative path: .//lib/cparse
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Libraries
 *        C/C++ Parsing classes
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is part of the Shag/OS distribution, and may be freely used and
 *  distributed by the terms of the ShagWare Non-profit Public License (SNPL),
 *  version 2, or, at your option, any newer official version of that License.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND,
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE, AND WILL NOT BE LIABLE FOR ANY DAMAGES.
 *  For more warranty details, see the ShagWare Non-profit Public License, which
 *  should have been received with this program, in a file called 'lic_spl2.txt'
 *  If this license is missing, please contact the author and describe how
 *  this software was obtained.  Email: shaggy@csh.rit.edu
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/*  
 *  $Log: TokenList.hh,v $
 *  Revision 1.3  1998/08/22 03:35:16  shaggy
 *  header update
 *
 *  Revision 1.2  1998/07/28 16:43:20  shaggy
 *  moved lots of Deco into generic CParse lib
 *  CAction split into vCAction and CAction
 *  printaction -> part of CAction
 *  ccint -> CRep (C Representation)
 *  ccout -> COut (C output)
 *
 *  Revision 1.1  1998/04/11 21:49:28  shaggy
 *  added token saving (for regurgitation)
 *
 *
 */

#include <vCAction>

class TokenList {
public:
	typedef vCAction::Item Item;
	typedef const vCAction::Item &Item_;
private:
	struct Node {
		Item	item;
		Node	*next;
	};
	Node *_first;
	Node *_last;
public:
	TokenList() { _first = _last = 0; }
	~TokenList();
	int next(Item *r);
	void append(Item_ v);
	void prepend(Item_ v);
	void append_delete(TokenList *t);
};

