/*  $Id: btypes.h,v 1.2 1998/08/22 03:35:28 shaggy Exp $
 *      basic type definitions for an Intel-based PC
 *      relative path: ./lib/m-32bit
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Libraries
 *        (m-32bit)
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is part of the Shag/OS distribution, and may be freely used and
 *  distributed by the terms of the ShagWare General Public License (SGPL),
 *  version 2, or, at your option, any newer official version of that License.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND,
 *  INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE, AND WILL NOT BE LIABLE FOR ANY DAMAGES.
 *  For more warranty details, see the ShagWare General Public License, which
 *  should have been received with this program, in a file called 'lic_spl2.txt'
 *  If this license is missing, please contact the author and describe how
 *  this software was obtained.  Email: shaggy@csh.rit.edu
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/*  $Log: btypes.h,v $
 *  Revision 1.2  1998/08/22 03:35:28  shaggy
 *  header update
 *
 *  Revision 1.1  1998/08/13 15:26:22  shaggy
 *  switching to using endianness and bus size instead of separate
 *  configurations per platform
 *
 *  Revision 1.1  1998/04/17 18:03:02  shaggy
 *  type definitions for sparc
 *
 *  Revision 1.1  1996/12/08 17:26:38  shaggy
 *  Initial revision
 *
 *      creation date: Dec 1994
 */
 

#ifndef ASM

typedef unsigned char		uint8;
typedef unsigned short int	uint16;
typedef unsigned int 		uint32;
typedef unsigned long long int	uint64;

typedef signed char		int8;
typedef signed short int	int16;
typedef signed int		int32;
typedef signed long long int	int64;


/* for these addressing types,	16 bits would limit to 64K max memory 
 *				(for small embedded systems)
 *				32 bits limits to 4Gb
 *				(for all other systems)
 *				64 bits is wasted for PC machines
 */
typedef uint32	vaddr_t;	/* virtual addresses (32) */
typedef int32	svaddr_t;	/* signed virtual addresses (32) */
typedef uint32	paddr_t;	/* physical addresses (16/32) */

/* for these page number types, 8 bits limits to 1Mb (for small machines)
 *				16 bits limits to 256Mb (most machines)
 *				32 bits limits to 16Tb (excessive)
 */
typedef uint16	vpage_t;	/* virtual page numbers (16/32) */
typedef uint16	ppage_t;	/* physical page numbers (8/16/32) */

typedef uint16	ref_t;		/* 64K max references */


#endif

