/*  $Id: macro.h,v 1.4 1998/08/22 03:34:45 shaggy Exp $
 *      relative path: ./lib
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Libraries
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is part of the Shag/OS distribution, and may be freely used and
 *  distributed by the terms of the ShagWare General Public License (SGPL),
 *  version 2, or, at your option, any newer official version of that License.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND,
 *  INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE, AND WILL NOT BE LIABLE FOR ANY DAMAGES.
 *  For more warranty details, see the ShagWare General Public License, which
 *  should have been received with this program, in a file called 'lic_spl2.txt'
 *  If this license is missing, please contact the author and describe how
 *  this software was obtained.  Email: shaggy@csh.rit.edu
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/*  $Log: macro.h,v $
 *  Revision 1.4  1998/08/22 03:34:45  shaggy
 *  header update
 *
 *  Revision 1.3  1997/06/21 12:23:52  shaggy
 *  header update
 *
 *  Revision 1.2  1997/01/21 05:16:28  shaggy
 *  header update
 *
 *  Revision 1.1  1996/12/20 18:13:06  shaggy
 *  Initial revision
 *
 *      creation date: Dec 1994
 */


#ifndef __GLOBAL__
#define __GLOBAL__ extern
#endif

#define bit(x)		(1 << (x))	

#define ctrl(c)		((c)-64)	

#define align(adr, n)		(((adr)+(n)-1) & ~((n)-1))
#define align_down(adr, n)	((adr) & ~((n)-1))
#define align_div(adr, n)	(((adr)+(n)-1)/(n))

#define is_pow2(n)	(!((n) & ((n)-1))

#define abs(x)		(((x) < 0) ? (-(x)) : (x))
#define min(x,y)	(((x) < (y)) ? (x) : (y))
#define max(x,y)	(((x) > (y)) ? (x) : (y))

#define QUOTE(n)	__quote_(n)
#define __quote_(x)	#x

/*
#define ADR_LEN(d)	&d, sizeof(d)
#define CSTR_LEN(t,v)	(t)(v), sizeof(v)-1
#define DSTR_LEN(t,v)	(t)(v), strlen(v)
*/

#define range_min(v,min)	 { if((v) < (min)) (v) = (min); }
#define range_max(v,max)	 { if((v) > (max)) (v) = (max); }
#define range_min_max(v,min,max) { if((v) < (min)) (v) = (min); \
				   if((v) > (max)) (v) = (max); }

/*
#define KMALLOC(type)	(type*)(kmalloc(sizeof(type)))
#define KFREE(x)	kfree(x);
#define MALLOC(type)	(type*)(malloc(sizeof(type)))
#define FREE(x)		free(x);

inline alignment functions:
static inline uint align(uint n, uint a = 4) { return ((n-1)&~(a-1))+a; }
static inline uint round(uint n, uint a = 4) { return n&~(a-1); }
*/

