/*  ctype.h                                                     (CRC:33bf560b)
 *      relative path: ./lib/posix
 *      creation date: 1992
 *      last modified: Sat Oct 26 15:09:19 1996
 *      header update: Fri Aug 21 22:54:53 1998
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Libraries
 *        Posix-compliant code
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is part of the Shag/OS distribution, and may be freely used and
 *  distributed by the terms of the ShagWare General Public License (SGPL),
 *  version 2, or, at your option, any newer official version of that License.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND,
 *  INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE, AND WILL NOT BE LIABLE FOR ANY DAMAGES.
 *  For more warranty details, see the ShagWare General Public License, which
 *  should have been received with this program, in a file called 'lic_spl2.txt'
 *  If this license is missing, please contact the author and describe how
 *  this software was obtained.  Email: shaggy@csh.rit.edu
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

#include <posix/posix.h>

#define isupper(c)	(((c) >= 'A') && ((c) <= 'Z'))
#define islower(c)	(((c) >= 'a') && ((c) <= 'z'))
#define isalpha(c)	(isupper(c) || islower(c))
#define isdigit(c)	(((c) >= '0') && ((c) <= '9'))
#define isalnum(c)	(isalpha(c) || isdigit(c))
#define isgraph(c)	(((c) >= 33) && ((c) <= 126))
#define isprint(c)	(((c) >= 32) && ((c) <= 126))
#define ispunct(c)	(isgraph(c) && !isalnum(c))
#define isspace(c)	((c) <= 32)
#define isxdigit(c)	(isdigit(c) || ((c) >= 'a' && (c) <= 'f') \
				|| ((c) >= 'A' && (c) <= 'F'))
#define toupper(c)	(islower(c)?((c)-'a'+'A'):(c))
#define tolower(c)	(isupper(c)?((c)-'A'+'a'):(c))
