/*  dirent.h                                                    (CRC:27ed4cac)
 *      relative path: ./lib/posix
 *      creation date: 1992
 *      last modified: Sat Oct 26 15:09:20 1996
 *      header update: Fri Aug 21 22:54:53 1998
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Libraries
 *        Posix-compliant code
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is part of the Shag/OS distribution, and may be freely used and
 *  distributed by the terms of the ShagWare General Public License (SGPL),
 *  version 2, or, at your option, any newer official version of that License.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND,
 *  INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE, AND WILL NOT BE LIABLE FOR ANY DAMAGES.
 *  For more warranty details, see the ShagWare General Public License, which
 *  should have been received with this program, in a file called 'lic_spl2.txt'
 *  If this license is missing, please contact the author and describe how
 *  this software was obtained.  Email: shaggy@csh.rit.edu
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

#include <posix/posix.h>
#include <posix/sys/types.h>
#include <posix/limits.h>

struct dirent {
	long		d_ino;
	off_t		d_off;
	ushort		d_reclen;
	char		d_name[NAME_MAX+1];
};

typedef struct {
	obj_t	dd;
	int	index;
} DIR;					

extern_C DIR *opendir(const char *name);
extern_C int closedir(DIR *dirp);
extern_C struct dirent *readdir(DIR *dirp);
extern_C void rewinddir(DIR *dirp);

