/*  stdlib.h                                                    (CRC:31cf22e8)
 *      relative path: ./lib/posix
 *      creation date: 1992
 *      last modified: Sat Feb  1 16:27:35 1997
 *      header update: Fri Aug 21 22:54:56 1998
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Libraries
 *        Posix-compliant code
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is part of the Shag/OS distribution, and may be freely used and
 *  distributed by the terms of the ShagWare General Public License (SGPL),
 *  version 2, or, at your option, any newer official version of that License.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND,
 *  INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE, AND WILL NOT BE LIABLE FOR ANY DAMAGES.
 *  For more warranty details, see the ShagWare General Public License, which
 *  should have been received with this program, in a file called 'lic_spl2.txt'
 *  If this license is missing, please contact the author and describe how
 *  this software was obtained.  Email: shaggy@csh.rit.edu
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

#include <posix/posix.h>
#include <posix/sys/types.h>

#define RAND_MAX	32767
extern_C int rnd(int max);
extern_C int rand(void);
extern_C void srand(ulong seed);

extern_C int atoi(char *str);
extern_C long atol(char *str);
extern_C ulong atoul(char *str);
extern_C long strtol(const char *nptr, char **endptr, int base);
extern_C ulong strtoul(const char *nptr, char **endptr, int base);

extern_C uchar bcd_encode(uchar val);
extern_C uchar bcd_decode(uchar val);

extern_C void abort(void);
extern_C void *malloc(size_t size);
extern_C void *calloc(size_t nelem, size_t size);
extern_C void *realloc(void *ptr, size_t size);
extern_C void free(void *ptr);
extern_C void exit(int status);
extern_C int atexit(void (*func)(void));

extern_C char *getenv(const char *name);


