/*  $Id: string.h,v 1.4 1998/08/22 03:35:36 shaggy Exp $
 *      relative path: ./lib/posix
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Libraries
 *        Posix-compliant code
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is part of the Shag/OS distribution, and may be freely used and
 *  distributed by the terms of the ShagWare General Public License (SGPL),
 *  version 2, or, at your option, any newer official version of that License.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND,
 *  INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE, AND WILL NOT BE LIABLE FOR ANY DAMAGES.
 *  For more warranty details, see the ShagWare General Public License, which
 *  should have been received with this program, in a file called 'lic_spl2.txt'
 *  If this license is missing, please contact the author and describe how
 *  this software was obtained.  Email: shaggy@csh.rit.edu
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/*  $Log: string.h,v $
 *  Revision 1.4  1998/08/22 03:35:36  shaggy
 *  header update
 *
 *  Revision 1.3  1997/06/21 12:24:06  shaggy
 *  header update
 *
 *  Revision 1.2  1997/01/21 05:02:23  shaggy
 *  fixed for inttypes.h
 *
 *  Revision 1.1  1996/12/08  19:40:34  shaggy
 *  Initial revision
 *
 *      creation date: 1992
 */

#include <posix/posix.h>
#include <posix/sys/types.h>
#include <posix/stddef.h> 


extern_C void *memchr(const void *s, int c, size_t n);
extern_C int memcmp(const void *s1, const void *s2, size_t n);
extern_C void *memcpy(void *s1, const void *s2, size_t n);
extern_C void *memmove(void *s1, const void *s2, size_t n);
extern_C void *memset(void *s, uint8 c, size_t n);
extern_C void *memset_w(void *s, uint16 c, size_t n);
extern_C void *memset_l(void *s, uint32 c, size_t n);
extern_C char *strcat(char *s1, const char *s2);
extern_C char *strchr(const char *s, int c);
extern_C int strcmp(const char *s1, const char *s2);
extern_C int strcoll(const char *s1, const char *s2);
extern_C char *strcpy(char *s1, const char *s2);
extern_C size_t strcspn(const char *s1, const char *s2);
extern_C char *strerror(ulong errnum);
extern_C size_t strlen(const char *s);
extern_C char *strncat(char *s1, const char *s2, size_t n);
extern_C int strncmp(const char *s1, const char *s2, size_t n);
extern_C char *strncpy(char *s1, const char *s2, size_t n);
extern_C char *strpbrk(const char *s1, const char *s2);
extern_C char *strrchr(const char *s, int c);
extern_C size_t strspn(const char *s1, const char *s2);
extern_C char *strstr(const char *s1, const char *s2);
extern_C char *strtok(char *s1, const char *s2);
extern_C size_t strxfrm(char *s1, const char *s2, size_t n);

