/*  $Id: strtok.cc,v 1.3 1998/08/22 03:35:36 shaggy Exp $
 *      
 *      strtok() string tokenizing function
 *      
 *      relative path: ./lib/posix
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Libraries
 *        Posix-compliant code
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is part of the Shag/OS distribution, and may be freely used and
 *  distributed by the terms of the ShagWare General Public License (SGPL),
 *  version 2, or, at your option, any newer official version of that License.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND,
 *  INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE, AND WILL NOT BE LIABLE FOR ANY DAMAGES.
 *  For more warranty details, see the ShagWare General Public License, which
 *  should have been received with this program, in a file called 'lic_spl2.txt'
 *  If this license is missing, please contact the author and describe how
 *  this software was obtained.  Email: shaggy@csh.rit.edu
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

//  $Log: strtok.cc,v $
//  Revision 1.3  1998/08/22 03:35:36  shaggy
//  header update
//
//  Revision 1.2  1997/06/21 12:24:15  shaggy
//  header update
//
//  Revision 1.1  1997/01/21 05:04:01  shaggy
//  Initial revision
//


#include <defines>
#include <posix/string.h>


extern "C" char * strtok(char *s, const char *delim)
{
	static char *sp	= 0;

	if(s)
		sp = s;
	while(*sp && strchr(delim, *sp))
		sp++;
	if(!*sp)
		return 0;
	char *first = sp;
	while(*sp && !strchr(delim, *sp))
		sp++;
	if(*sp)
		*sp++ = 0;
	return first;
}

