/*  time.h                                                      (CRC:8c15e6d4)
 *      relative path: ./lib/posix
 *      creation date: 1992
 *      last modified: Sat Oct 26 15:09:28 1996
 *      header update: Fri Aug 21 22:54:58 1998
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Libraries
 *        Posix-compliant code
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is part of the Shag/OS distribution, and may be freely used and
 *  distributed by the terms of the ShagWare General Public License (SGPL),
 *  version 2, or, at your option, any newer official version of that License.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND,
 *  INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE, AND WILL NOT BE LIABLE FOR ANY DAMAGES.
 *  For more warranty details, see the ShagWare General Public License, which
 *  should have been received with this program, in a file called 'lic_spl2.txt'
 *  If this license is missing, please contact the author and describe how
 *  this software was obtained.  Email: shaggy@csh.rit.edu
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

#include <posix/posix.h>
#include <posix/sys/types.h>
#include <sys/param.h>

#define CLK_TCK			HZ
#define CLOCKS_PER_SECOND	HZ

struct tm {
	uchar	tm_sec;
	uchar	tm_min;
	uchar	tm_hour;
	uchar	tm_mday;
	ushort	tm_yday;	/* since Jan 1 */
	uchar	tm_wday;	/* week day 0=sunday */
	uchar	tm_mon;		
	ushort	tm_year;	/* since 1900 */
	char	tm_isdst;	/* >0 = DST 0= standard <0=unknown */
}; 

extern_C struct tm *localtime(const time_t *timer);
extern_C time_t time(time_t *timer);

