/*  unistd.h                                                    (CRC:21b5492c)
 *      relative path: ./lib/posix
 *      creation date: 1992
 *      last modified: Sat Oct 26 15:09:25 1996
 *      header update: Fri Aug 21 22:54:58 1998
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Libraries
 *        Posix-compliant code
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is part of the Shag/OS distribution, and may be freely used and
 *  distributed by the terms of the ShagWare General Public License (SGPL),
 *  version 2, or, at your option, any newer official version of that License.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND,
 *  INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE, AND WILL NOT BE LIABLE FOR ANY DAMAGES.
 *  For more warranty details, see the ShagWare General Public License, which
 *  should have been received with this program, in a file called 'lic_spl2.txt'
 *  If this license is missing, please contact the author and describe how
 *  this software was obtained.  Email: shaggy@csh.rit.edu
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

#include <posix/posix.h>
#include <posix/sys/types.h>
#include <posix/stddef.h>

#define R_OK	4
#define W_OK	2
#define X_OK	1
#define F_OK	0
#define STDIN_FILENO	0
#define STDOUT_FILENO	1
#define STDERR_FILENO	2
#define _PC_CHOWN_RESTRICTED	XXX
#define _PC_MAX_CANNON		XXX
#define _PC_MAX_INPUT		XXX
#define _PC_NAME_MAX		XXX
#define _PC_NO_TRUNC		XXX
#define _PC_PATH_MAX		XXX
#define _PC_PIPE_BUF		XXX
#define _PC_VDISABLE		XXX
#define _POSIX_CHOWN_RESTRICTED	
#define _POSIX_JOB_CONTROL	
#define _POSIX_NO_TRUNC
#define _POSIX_SAVED_IDS
#define _POSIX_VDISABLE
#define _POSIX_VERSION
#define _SC_ARG_MAX		XXX
#define _SC_CHILD_MAX		XXX
#define _SC_CLK_TCK		XXX
#define _SC_JOB_CONTROL		XXX
#define _SC_NGROUPS_MAX		XXX
#define _SC_OPEN_MAX		XXX
#define _SC_SAVED_IDS		XXX
#define _SC_STREAM_MAX		XXX
#define _SC_TZNAME_MAX		XXX
#define _SC_VERSION		XXX	


extern_C ulong sleep(ulong sec);
extern_C void _exit(status_t status);
extern_C int read(int fildes, void *buf, ulong nbytes);
extern_C int write(int fildes, const void *buf, ulong nbytes);

