/*  $Id: vSymTab.hh,v 1.7 1998/08/22 03:35:41 shaggy Exp $
 *      Symbol Table support
 *      
 *      relative path: ./lib/symtab
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Libraries
 *        (symtab)
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is part of the Shag/OS distribution, and may be freely used and
 *  distributed by the terms of the ShagWare General Public License (SGPL),
 *  version 2, or, at your option, any newer official version of that License.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND,
 *  INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE, AND WILL NOT BE LIABLE FOR ANY DAMAGES.
 *  For more warranty details, see the ShagWare General Public License, which
 *  should have been received with this program, in a file called 'lic_spl2.txt'
 *  If this license is missing, please contact the author and describe how
 *  this software was obtained.  Email: shaggy@csh.rit.edu
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

//  $Log: vSymTab.hh,v $
//  Revision 1.7  1998/08/22 03:35:41  shaggy
//  header update
//
//  Revision 1.6  1998/07/30 04:40:33  shaggy
//  much more dtype and dclass work
//
//  Revision 1.5  1998/07/03 19:06:25  shaggy
//  changed scope semantics; fn name is available in scope now
//
//  Revision 1.4  1998/05/04 03:09:20  shaggy
//  support for ctors, dtors, conversion operators, operator overloading, etc
//
//  Revision 1.3  1998/04/22 12:02:05  shaggy
//  Changed ID to Id to be consistent with naming conventions
//
//  Revision 1.2  1998/01/12 04:12:48  shaggy
//  got dependencies working when re-generating code
//
//  Revision 1.1  1998/01/11 05:11:03  shaggy
//  Initial revision
//
//  Revision 1.1  1996/04/08  00:07:21  shaggy
//  Initial revision
//


#include <defines>
#include <types.h>
//#include <Object>

// just a linked-list for now, although this needs to be changed
// in the future for efficiency

class vSymTab {
public:
	typedef vStrTab::Id Id;
	typedef void *Val;

	virtual ~vSymTab() {}
	virtual bool get(Id id, Val &val) const = 0;
	virtual bool set(Id id, Val val) = 0;
	virtual bool add(Id id, Val val) = 0;
	virtual bool del(Id id) = 0;
	virtual vSymTab* parent() const = 0;
	virtual bool parent(vSymTab*) = 0;	
	virtual void* data() const = 0;
	virtual bool data(void*) = 0;	
	virtual vStrTab* strtab() const = 0;
	virtual Id index(uint n) const = 0;

	Val get(Id id) const { Val v; return get(id, v) ? v : 0; }
};
typedef const vSymTab &vSymTab_;

#if 0
extern obj_t Type_vSymTab;

class obj_vSymTab : public Object {
public:
};
#endif

