/*  $Id: deco.cc,v 1.136 1998/08/10 03:12:01 shaggy Exp $
 *      Dynamic Encapsulator of C++ Objects
 *      
 *      relative path: ./util/deco
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Utilities for compilation, configuration, and development
 *        Dynamic Encapsulator of C++ Objects
 *  
 *  Copyright (c) 1996,1997 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is part of the Shag/OS distribution, and may be freely used and
 *  distributed by the terms of the ShagWare General Public License (SGPL),
 *  version 2, or, at your option, any newer official version of that License.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND,
 *  INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE, AND WILL NOT BE LIABLE FOR ANY DAMAGES.
 *  For more warranty details, see the ShagWare General Public License, which
 *  should have been received with this program, in a file called 'lic_spl2.txt'
 *  If this license is missing, please contact the author and describe how
 *  this software was obtained.  Email: shaggy@csh.rit.edu
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

//  $Log: deco.cc,v $
//  Revision 1.136  1998/08/10 03:12:01  shaggy
//  deco 0.10
//
//  Revision 1.135  1998/08/09 21:49:57  shaggy
//  DECO *finally* converts all of my original testcases automatically
//
//  Revision 1.134  1998/08/09 03:57:35  shaggy
//  lots of work on output dependency checking
//
//  Revision 1.133  1998/08/03 15:00:16  shaggy
//  conversion operators, constructor conversions, default params
//
//  Revision 1.132  1998/08/03 11:56:22  shaggy
//  deco 0.9
//
//  Revision 1.131  1998/08/03 04:11:34  shaggy
//  deco can *finally* generate code which binds a type to a class
//
//  Revision 1.130  1998/08/03 00:13:00  shaggy
//  tons of work-- friends, class scope fixes, tons of bugfixes,
//  lots more cleanup, more DC++ work, etc
//
//  Revision 1.129  1998/08/01 21:02:09  shaggy
//  much more cleanup; many bugfixes; DC++ progress
//
//  Revision 1.128  1998/08/01 14:56:48  shaggy
//  about to restructure deco
//
//  Revision 1.127  1998/08/01 04:42:03  shaggy
//  must sleep
//
//  Revision 1.126  1998/07/31 23:44:28  shaggy
//  running out of time
//
//  Revision 1.125  1998/07/31 04:15:27  shaggy
//  need sleep
//
//  Revision 1.124  1998/07/31 02:03:12  shaggy
//  better
//
//  Revision 1.123  1998/07/30 22:27:20  shaggy
//  broken
//
//  Revision 1.122  1998/07/30 04:40:34  shaggy
//  much more dtype and dclass work
//
//  Revision 1.121  1998/07/29 03:35:13  shaggy
//  dtype support nearly complete, initial dclass support
//
//  Revision 1.120  1998/07/28 19:55:28  shaggy
//  moved most of generic parsing from Deco into CAction
//
//  Revision 1.119  1998/07/28 16:43:24  shaggy
//  moved lots of Deco into generic CParse lib
//  CAction split into vCAction and CAction
//  printaction -> part of CAction
//  ccint -> CRep (C Representation)
//  ccout -> COut (C output)
//
//  Revision 1.118  1998/07/28 04:46:02  shaggy
//  more dtype work
//
//  Revision 1.117  1998/07/28 01:24:24  shaggy
//  initial support for implementation specifiers
//
//  Revision 1.116  1998/07/26 17:34:45  shaggy
//  deco 0.8 release
//
//  Revision 1.115  1998/07/25 22:32:55  shaggy
//  improved arg parsing
//
//  Revision 1.114  1998/07/22 14:52:34  shaggy
//  some namespace support
//
//  Revision 1.113  1998/07/21 14:57:29  shaggy
//  trying to get dtype conversion working right
//
//  Revision 1.112  1998/07/20 23:22:27  shaggy
//  *** empty log message ***
//
//  Revision 1.111  1998/07/20 17:51:47  shaggy
//  added bitfield support
//
//  Revision 1.110  1998/07/20 14:59:37  shaggy
//  more dtype conv work
//
//  Revision 1.109  1998/07/19 22:33:37  shaggy
//  part 2 of major overhaul (needed for type-safty and to start
//  being more consistent)
//
//  Revision 1.108  1998/07/19 06:46:47  shaggy
//  1st stage of Item cleanup
//
//  Revision 1.107  1998/07/18 17:55:16  shaggy
//  cleaned up arg parsing
//
//  Revision 1.106  1998/07/17 18:55:24  shaggy
//  fixed cpp support; added some parsing extensions
//
//  Revision 1.105  1998/07/17 15:00:08  shaggy
//  fixed ptr indirection (arrays, fns, etc)
//
//  Revision 1.104  1998/07/16 23:21:44  shaggy
//  more anon struct/union support
//
//  Revision 1.103  1998/07/14 14:55:39  shaggy
//  fixing MPTRTO and PtrTo(Method) for const
//
//  Revision 1.102  1998/07/12 20:51:50  shaggy
//  deco 0.7 pre-release
//
//  Revision 1.101  1998/07/12 19:01:26  shaggy
//  many more cvqual fixes
//
//  Revision 1.100  1998/07/12 03:58:49  shaggy
//  lots of const fixes, -frealtype option, -dT option; better debugging
//
//  Revision 1.99  1998/07/11 23:06:52  shaggy
//  fixed labels and goto
//
//  Revision 1.98  1998/07/11 19:03:04  shaggy
//  declarations in for() work now (even multiple decls)
//
//  Revision 1.97  1998/07/09 04:53:30  shaggy
//  more fn matching fixes
//
//  Revision 1.96  1998/07/08 21:45:04  shaggy
//  lots of enhancements for function call matching
//
//  Revision 1.95  1998/07/08 13:42:43  shaggy
//  started adding proper function calls
//
//  Revision 1.94  1998/07/07 13:41:42  shaggy
//  enum cleanup, and can define types inside functions now
//
//  Revision 1.93  1998/07/07 02:51:15  shaggy
//  more fixes for declaration ordering
//
//  Revision 1.92  1998/07/06 22:49:43  shaggy
//  reworked symtab, output ordering, etc
//
//  Revision 1.91  1998/07/06 13:39:09  shaggy
//  many more changes/fixes for first pre-release
//
//  Revision 1.90  1998/07/06 05:01:28  shaggy
//  prep for pre-release
//
//  Revision 1.89  1998/07/05 20:32:57  shaggy
//  tons of bugfixes, enhancements and parser improvements
//
//  Revision 1.88  1998/07/05 02:47:39  shaggy
//  tons of bug fixes
//
//  Revision 1.87  1998/07/04 20:39:01  shaggy
//  lots of bug fixes; fn, aggr, etc improvements, new/delete
//
//  Revision 1.86  1998/07/04 01:23:31  shaggy
//  anonymous unions work now
//
//  Revision 1.85  1998/07/03 19:06:26  shaggy
//  changed scope semantics; fn name is available in scope now
//
//  Revision 1.84  1998/07/03 16:53:53  shaggy
//  new Scope wrapper class, and dcast_XXX functions eliminate lots of casts
//
//  Revision 1.83  1998/07/02 13:25:53  shaggy
//  public/private/protected works for inheritance
//
//  Revision 1.82  1998/07/01 13:14:32  shaggy
//  handles default code for dtype member fns
//
//  Revision 1.81  1998/06/30 18:19:02  shaggy
//  more fixes for member pointers
//
//  Revision 1.80  1998/06/30 15:38:38  shaggy
//  better support for member fns and member fn ptrs
//
//  Revision 1.79  1998/06/30 13:23:33  shaggy
//  fcall fixes for d++ conv
//
//  Revision 1.78  1998/06/30 12:22:32  shaggy
//  many fixes for "this"
//
//  Revision 1.77  1998/06/29 14:14:18  shaggy
//  more DECO conversions, support for 'this', etc
//
//  Revision 1.76  1998/06/29 01:36:56  shaggy
//  fixed inline attr, output of pure virtuals, etc...
//
//  Revision 1.75  1998/06/07 18:09:05  shaggy
//  added types to Expr()'s, and fixed output of members (. and ->)
//
//  Revision 1.74  1998/06/07 15:45:13  shaggy
//  realtype() works, and . and -> now work
//
//  Revision 1.73  1998/06/04 13:40:39  shaggy
//  more fixes
//
//  Revision 1.72  1998/06/04 02:28:10  shaggy
//  various config updates
//
//  Revision 1.71  1998/06/03 13:39:14  shaggy
//  function re-parsing almost works (for within classes)
//
//  Revision 1.70  1998/06/02 14:50:43  shaggy
//  in the midst of more full parsing updates
//
//  Revision 1.69  1998/06/01 13:29:00  shaggy
//  switchable code save/parse
//
//  Revision 1.68  1998/06/01 02:10:36  shaggy
//  more code parsing working
//
//  Revision 1.67  1998/05/26 21:34:17  shaggy
//  C/C++/DC++ header formats now supported
//  header output includes external requirements
//
//  Revision 1.66  1998/05/26 16:40:52  shaggy
//  fixed and cleaned up config
//
//  Revision 1.65  1998/05/26 13:40:15  shaggy
//  many more fixes
//
//  Revision 1.64  1998/05/26 05:02:55  shaggy
//  parameter scoping works correctly
//  most basic C/C++ statements now work
//
//  Revision 1.63  1998/05/26 01:39:47  shaggy
//  params almost working right
//
//  Revision 1.62  1998/05/25 23:28:46  shaggy
//  major rework of func/param info
//
//  Revision 1.61  1998/05/25 20:08:42  shaggy
//  more bugfixes
//
//  Revision 1.60  1998/05/25 04:22:15  shaggy
//  enough for tonight
//
//  Revision 1.59  1998/05/24 23:39:34  shaggy
//  various bug fixes and code cleanup
//
//  Revision 1.58  1998/05/24 18:42:01  shaggy
//  improved regression testing
//  proper scoping for initializers
//  decls available for their initializer
//
//  Revision 1.57  1998/05/24 01:41:43  shaggy
//  internal support for most statements
//
//  Revision 1.56  1998/05/20 14:41:25  shaggy
//  better code output
//
//  Revision 1.55  1998/05/19 14:55:37  shaggy
//  a bit closer to generating code (stmtlists work)
//
//  Revision 1.54  1998/05/18 13:22:37  shaggy
//  more decl changes
//
//  Revision 1.53  1998/05/18 05:24:29  shaggy
//  more cleanup of declaration support functions
//
//  Revision 1.52  1998/05/17 23:14:59  shaggy
//  expressions, expression lists, etc
//
//  Revision 1.51  1998/05/16 23:30:45  shaggy
//  added CTOR_ID and some rules to help fix ctor ambiguity problem
//  output turned off for #include'ed files
//  better error checking, and ability to list locations
//  of symbol declaration and definition
//
//  Revision 1.50  1998/05/15 07:03:38  shaggy
//  dependency ordering fixed; constructor initializers; lots of bug fixes, etc
//
//  Revision 1.49  1998/05/15 00:17:28  shaggy
//  ctor initializers work, and enums are fixed so declarations
//  in an enum can be immediately re-used
//
//  Revision 1.48  1998/05/14 18:02:05  shaggy
//  fixed constant handling, enums, function cv tags, etc
//
//  Revision 1.47  1998/05/14 05:08:43  shaggy
//  inheritence works and lots of bugs fixed
//
//  Revision 1.46  1998/05/13 21:39:37  shaggy
//  switched to dtype/ptype/rtype
//
//  Revision 1.45  1998/05/13 21:02:50  shaggy
//  deinitions/initializations work better now
//
//  Revision 1.44  1998/05/13 00:21:36  shaggy
//  fixed enums (mostly)
//
//  Revision 1.43  1998/05/12 22:40:26  shaggy
//  scoping FINALLY works right (or seems to)
//
//  Revision 1.42  1998/05/12 20:14:10  shaggy
//  scoping works except for output with nested dependencies
//
//  Revision 1.41  1998/05/12 15:53:22  shaggy
//  scoping and class tags almost work
//
//  Revision 1.39  1998/05/10 18:53:42  shaggy
//  just about ready to start fixing scoping
//
//  Revision 1.38  1998/05/10 00:03:33  shaggy
//  string concatenation works, and comments are being
//  added to get ready to fix scoping
//
//  Revision 1.37  1998/05/08 13:03:24  shaggy
//  fixed const/volatile
//
//  Revision 1.36  1998/05/07 14:46:40  shaggy
//  const/volatile partially working
//
//  Revision 1.35  1998/05/05 13:00:42  shaggy
//  better function parameter matching
//
//  Revision 1.34  1998/05/04 04:39:50  shaggy
//  first stage of function overloading
//
//  Revision 1.33  1998/05/04 03:09:21  shaggy
//  support for ctors, dtors, conversion operators, operator overloading, etc
//
//  Revision 1.32  1998/05/03 17:07:30  shaggy
//  more improvements to make internal declarations easier
//
//  Revision 1.31  1998/05/03 02:47:08  shaggy
//  added inheritence to parser
//
//  Revision 1.30  1998/04/27 04:36:49  shaggy
//  started auto-generation of code
//
//  Revision 1.29  1998/04/26 15:21:23  shaggy
//  better implicit int handling
//
//  Revision 1.28  1998/04/26 14:58:52  shaggy
//  fixed to output standard C++ types (instead of int32,etc)
//
//  Revision 1.27  1998/04/26 14:29:27  shaggy
//  better error output
//
//  Revision 1.26  1998/04/26 14:07:03  shaggy
//  better error handling
//
//  Revision 1.25  1998/04/23 20:11:41  shaggy
//  more changes for Solaris
//
//  Revision 1.24  1998/04/23 13:47:51  shaggy
//  changes to make enums and constants work better
//
//  Revision 1.23  1998/04/23 12:32:57  shaggy
//  more portability fixes
//
//  Revision 1.22  1998/04/22 13:06:40  shaggy
//  better enum handling
//
//  Revision 1.21  1998/04/22 12:17:51  shaggy
//  changed ID to Id for consistency
//
//  Revision 1.20  1998/04/17 18:02:04  shaggy
//  more stuff to make it build under Solaris
//
//  Revision 1.19  1998/04/16 13:35:33  shaggy
//  access control
//
//  Revision 1.18  1998/04/15 14:47:58  shaggy
//  array output works
//
//  Revision 1.17  1998/04/15 13:39:57  shaggy
//  added types to constants
//
//  Revision 1.16  1998/04/14 03:57:09  shaggy
//  forward reference support
//
//  Revision 1.15  1998/04/13 01:30:23  shaggy
//  even better C++ output
//
//  Revision 1.14  1998/04/12 18:38:08  shaggy
//  improved code output
//
//  Revision 1.13  1998/04/12 03:19:35  shaggy
//  got function output working
//
//  Revision 1.12  1998/04/11 21:48:42  shaggy
//  added some simple regurgitation
//
//  Revision 1.11  1998/04/11 01:47:41  shaggy
//  deco uses cpp
//  tests fixed for dc++
//  dc++ grammar fixed
//
//  Revision 1.10  1998/04/07 13:38:20  shaggy
//  fixed up enums some more
//
//  Revision 1.9  1998/04/06 14:27:43  shaggy
//  lots more changes, and added some tests
//
//  Revision 1.8  1998/03/23 14:17:50  shaggy
//  more updates
//
//  Revision 1.7  1998/02/11 04:33:44  shaggy
//  fixed to handle joining type lists
//
//  Revision 1.6  1998/02/09 00:51:57  shaggy
//  *** empty log message ***
//
//  Revision 1.5  1998/02/08 23:41:58  shaggy
//  fixed dependency ordering of output
//
//  Revision 1.4  1998/02/08 19:07:05  shaggy
//  about to start splitting up everything
//
//  Revision 1.3  1998/01/24 15:41:17  shaggy
//  old style of pointing to decls
//
//  Revision 1.2  1998/01/12 04:12:48  shaggy
//  got dependencies working when re-generating code
//
//  Revision 1.1  1998/01/11 05:06:33  shaggy
//  Initial revision
//
//  Revision 1.10  1997/12/09 16:41:20  shaggy
//  param decls fixed
//
//  Revision 1.9  1997/12/09 15:23:05  shaggy
//  *** empty log message ***
//
//  Revision 1.8  1997/12/08 03:50:56  shaggy
//  *** empty log message ***
//
//  Revision 1.7  1996/11/29  18:51:25  shaggy
//  last checkin before removing unnecessary 'List' class
//
//  Revision 1.6  1996/11/23  17:22:39  shaggy
//  last checkin before switching to virtual functions
//
//  Revision 1.5  1996/10/19  21:47:53  shaggy
//  modified to handle new token location
//
//  Revision 1.4  1996/10/19  16:41:24  shaggy
//  supports abstract parameter declarations
//
//  Revision 1.3  1996/10/18  16:37:19  shaggy
//  basic type declarations (including functions) work
//
//  Revision 1.2  1996/10/18  00:53:16  shaggy
//  added ptrs, arrays, basic types
//
//  Revision 1.1  1996/10/06  20:33:57  shaggy
//  Initial revision
//
//      last modified: Fri May 24 00:51:49 1996
//      creation date: Mon Mar  4 00:35:59 1996


#define deco_VER_MAJOR	0
#define deco_VER_MINOR	10
#define deco_VER_PATCH	0
#define deco_VER_STR	"0.10"
#define deco_VER_DATE	"August 09, 1998"
#define deco_VER_NDATE	"08/09/98"

// #pragma Make Config_Needed += local
#pragma Make Includes_Banned += -nostdinc -nostdinc++
#pragma Make Flags_Banned += -static

#define DEBUG
#define CACTION_DEBUG

#define USE_STDLIB

#include <sys/types.h>
#include <defines>
#include <unistd.h>
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <fcntl.h>
#include <posix/assert.h>

#include <CObj>
#include <CLex>
#include <StrTab>
#include <SymTab>
#include <ParsePath>
#include <vCAction>
#include <CParse>
#include <CRep>
#include <COut>
#include <CAction>


bool debugaction = false;


#define INTERNAL_ERROR  { internal_error(__FILE__, __LINE__, __FUNCTION__); \
			  for(;;); }

#include "decoconf.h"


// XXX - ideas:
//	- extend Item structure by making it a class that can
//	  be derived from and have methods added to
//	- extend Token by putting base definition in a file that can
//	  be included and then have more entries added to
//	- make sure specific/generic print routines are available for it 
//	  too

// XXX - at some point, any knowledge specific to certain data
// types should be removed from DECO, since it is supposed to be 
// a generic C++ pre-processor that generates code that can compile
// on any architecture. 


// Need to clean up use of Item by providing a local
// Item class that has a separate structure for each token ID,
// so that casting won't be necessary and the expected layout for
// each token is clear and can be checked for errors


// lexical shortcuts:
typedef vStrTab::Id Id;



class Deco : public CAction {
private:
	int _input_fd;
	const int _bufsize = 4096;
	char _buf[_bufsize];

	Id _id_instance, _id_dtobj, _id_dcobj, _id_dataclass;
	Id _id_dbind, _id_dcbind, _id_dcheck;
	Id _id_o, _id_btrp;
	Id _id_D_Type, _id_D_Class;
	Id _id__objp;
	Id _id__itabp;
	Id _id__itable;
	Id _id_this_ref;
	Id _id_this_r;
	Id _id_this_w;
	Id _id_this_rw;
	Id _id_btr;
	Id _id_copy;
	Id _id_share;

	// declarations from dcobj.hh:
	Decl *_d_BTRef;
	Decl *_d_bt__DCBind;
	Decl *_d_bt__this_r;
	Decl *_d_bt__this_w;
	Decl *_d_bt__this_rw;
	Decl *_d_bt__this_ref;
	Decl *_d_Obj;
	Decl *_d_obj__init_alloc;
	Decl *_d_obj__init_ref;
	Decl *_d_obj__this_r;
	Decl *_d_obj__this_w;
	Decl *_d_obj__this_rw;
	Decl *_d_obj__this_ref;

	Decl *_d_D_Class;
	Decl *_d_D_Class_dcobj;
	Decl *_d_D_Type;
	Decl *_d_D_Type_dcobj;

	bool _dcxx_initialized;

	Decl* declfind(csz *name, Scope sc = 0);
	bool dcxx_init();

public:
	Deco(CLex &clp, vStrTab &strtab, vSymTab &symtab);

	bool open_input(csz *fname = 0, csz *cpp = 0);
	void close_input();
	void get_input(bool split_token);
	void abort_exit();
	void internal_error_exit();
	void veprintf(csz *fmt, va_list args);

	void dcxx_to_cxx();
	void dcxx_to_cxx(Scope);
	Decl* cxx_of_dtype(Decl *);
	Decl* cxx_of_dclass(Decl *);
	Decl* cxx_of_decl(Decl *);
	void dimpl_to_cxx(Decl *ddi, Decl *dc);
	void dclassdimpl_to_cxx(Decl *ddi, Decl *dc, Decl *ddat);
	void dtype_mfn_to_cxx(Decl *, Scope, int n);
	void gen_dbind(Decl *dc, Decl *ditab, type_t ti);
	void gen_dcbind(Decl *dc, Decl *dci, Decl *ditab, Decl *ddcheck,
								type_t ti);
	void gen_binder(Decl *dc, Decl *dci, Decl *ditab, type_t ti);

	Decl* newmethod(Id id, Scope sc, type_t rt, bool is_const = false,
						int nargs = 0, Param * = 0);
	Expr expr_mfnadr(type_t newtype, Decl *d);
	ExprList copyargs(Func *f);

	void predefine();

	action EndAggr;
};


Deco::Deco(CLex &clp, vStrTab &strtab, vSymTab &symtab)
	 : CAction(clp, strtab, symtab)
{
	_dcxx_initialized = false;
}


void
Deco::EndAggr(Item *r, Item_ agsc, Item_ scope, Item_)
{
    PRINT_ACTION(r, agsc, scope, none);
	CAction::EndAggr(r, agsc, scope, none);
	Decl *d = uAggrId(r).decl;
	switch(d->dtype) {
//	case Decl::dt_dtype:
//		cxx_of_dtype(d);
//	case Decl::dt_dclass:
//		cxx_of_dclass(d);
	default: ;
	}	
}


/////////////////////////////////////////////////////////////////////////////
// code re-writing

static Expr
expr_rewrite(Expr e, Expr (*rwf)(Expr, Expr), Expr p)
{
	Expr ne;
	if(!e)
		return e;
	// printf("eee=%p, %d, (%p, %p, %p) %p\n", (ExprNode*)e, e.op(), (ExprNode*)e.left(), (ExprNode*)e.mid(), (ExprNode*)e.right(), (ExprNode*)e.next());
	switch(e.op()) {
	case T(VAL_ID):
	case T(TOKENLIST):
	case T(LITERAL):
	case T(ID):
		ne = e;
		break;
	case T(EXPRLIST):
	case T(STMTLIST): {
		Expr eleft = expr_rewrite(e.left(), rwf, p);
		if(e.left().is(eleft))
			ne = e;
		else {
			Expr i = eleft;
			while(i.next())
				i = i.next();
			ne = Expr(e.op(), eleft, e.mid(), i);
		}
		} break;
	default: {
		Expr eleft = expr_rewrite(e.left(), rwf, p);
		Expr emid = expr_rewrite(e.mid(), rwf, p);
		Expr eright = expr_rewrite(e.right(), rwf, p);
		if(e.left().is(eleft) && e.mid().is(emid)
				&& e.right().is(eright))
			ne = e;
		else {
			ne = Expr(e.op(), eleft, emid, eright);
			ne.set_rtype(e.rtype());
		}}
	}
	Expr erw = rwf(ne, p);
	Expr enext = expr_rewrite(e.next(), rwf, p);
	if(!erw.next().is(enext)) {
		if(ne.is(e) || !ne.is(erw))
			ne = erw.dup();
		ne += enext;
	} else
		ne = erw;
	return ne;
}



/////////////////////////////////////////////////////////////////////////////
// DC++ to C++ conversions

// a lot of the following functions are rather grotesque
// hopefully, they will get trimmed down once better support functionality
// exists, since there's a lot of redundant code here
// The code here also employs "brute force" far too often.
// Something more elegant, but functionally equivalent, needs to replace it.
//
// Believe it or not, it's actually getting better already... 
// You should have seen it before some of this stuff got split
// into separate functions...

static Expr
rewrite_id_expr(Expr e, Expr p)
{
	if(e.op() == T(VAL_ID) && e.decl() == p.decl()) 
		return p.next();
	else
		return e;
}

static ExprList
elist()
{
	return ExprList();
}

static ExprList
elist(Expr e1)
{
	return ExprList() += e1;
}

static ExprList
elist(Expr e1, Expr e2)
{
	return (ExprList() += e1) += e2;
}

static ExprList
elist(Expr e1, Expr e2, Expr e3)
{
	return ((ExprList() += e1) += e2) += e3;
}

ExprList
Deco::copyargs(Func *f)
{
	ExprList p;
	for(uint i=0; i<f->nparam(); i++) {
		Decl *pd = param_decl(f, i);
		if(!pd || !pd->id) {
			sz buf[10];
			sprintf(buf, "_a%d_", i);
			Id id = strid(buf);
			if(pd)
				declrename(pd, id);
			else {
				Param np;
				np.type = f->ptype(i);
				np.name = id;
				np.defval.token = NONE;
				pd = addparam(i, f->scope(), np);
			}
		}
		p += Expr(pd);
	}
	return p;
}


// some little naming conventions, to try to keep things
// from getting too confusing:
// (yes, this borders on hungarian notation in some ways,
// which I personally can't stand, but given the size and
// complexity of some of these functions, I figured this
// would help avoid a bunch of errors-- of course, the better
// solution would be to break this up into enough smaller
// pieces so that one and two letter names would be sufficient)
//
//	d_XXX		Decl* for XXX
//	t_XXX		type_t for XXX
//	s_XXX		scope owned by XXX (*not* parent scope)
//	ps_XXX		parent scope for XXX
//	id_XXX		vStrTab::Id of XXX
//	f_XXX		Func* for XXX
//	m_XXX		Method* for XXX
//	e_XXX		Expr
//	el_XXX		Expression List
//	sl_XXX		Statement List
//	XXX_c		refers to class being constucted from dtype/dclass
//	XXX_dt		refers to dynamic type being converted
//	XXX_dc		refers to dynamic class being converted
//	XXX_dat		refers to dataclass (inside of dclass)
//	XXX_m		refers to current method
//	XXX_di		refers to dynamic implementation subclass
//	XXX_ci		refers to implementation subclass (converted)
//	XXX_dti		refers to dynamic type being implemented
//	XXX_cti		refers to class of dtype being implemented (converted)
//	XXX_itab	refers to itable[]
//	XXX_YYY		refers to YYY
//
// The usual convention applies about prefixing an identifier with _
// to show that it's a field.  Also, for local vars with limited
// scope, it's reasonable to drop the _ in the middle.

Decl*
Deco::newmethod(Id id, Scope s, type_t rt, bool is_const = false, int np, Param *param)
{
	type_t ptype[8];
	Scope pscope = newscope(s, 0);
	for(int i=0; i<np; i++) {
		ptype[i] = param[i].type;
		addparam(i, pscope, param[i]);
	}
	type_t psig = type_psig(np, ptype);
	type_t ot = s.decl()->rtype;
	if(is_const)
		ot = type_const(ot);
	Decl *d = newdecl(id, s, type_method(ot, type_func(rt, psig, pscope)));
	addthis(d);
	d->f.pscope = pscope;
	assert(d->is_func);
	assert(d->is_method);
	assert(!d->field);
	return d;
}


// return an expression that gets the address of a method function
// and converts it to the specified type
Expr
Deco::expr_mfnadr(type_t newtype, Decl *d)
{
	Expr emptr = Expr(OP_REF, Expr(d));

	Decl *dl = d->scope.uget(d->id)->link;
	if(dl && !dl->tagged())
		emptr = Expr(KW_SCAST, emptr, type_ptrto(d->rtype));
	return Expr(OP_CAST, emptr, newtype);
}


void
Deco::gen_dcbind(Decl *dc, Decl *dci, Decl *ditab, Decl *ddcheck, type_t ti)
{
	Param param[2];
	param[0].clear();
	param[0].defval = NONE;
	param[1].clear();
	param[1].defval = NONE;
	Scope sc = getaggrscope(dc);

	// gen: bool c::dcbind(::ti*) const
	// {
	//	btrp->_itabp = ti::_itable;
	//	btrp->_objp = const_cast<c*>(this);
	//	if(static_cast<ti*>(btrp)->dcheck())
	//		return true;
	//	else {
	//		btrp->_itabp = 0;
	//		btrp->_objp = 0;
	//		return false;
	//	};
	param[0].name = _id_btrp;
	param[0].type = type_ptrto(ti);
	Decl *ddcbind = newmethod(_id_dcbind, sc, &Type_bool, true, 1, param);
	StmtList sl(ddcbind->f.pscope);
	Decl *dbtrp = Scope(ddcbind->f.pscope).get(_id_btrp);
	Decl *dobjp = getaggrscope(_d_BTRef).ufind(_id__objp);
	Decl *ditabp = getaggrscope(_d_BTRef).ufind(_id__itabp);
	assert(dbtrp);
	assert(dobjp);
	assert(ditabp);
	sl += Stmt(Expr(OP_ASN, Expr(OP_PTRTO, Expr(dbtrp), Expr(ditabp)),
		Expr(ditab)));
	sl += Stmt(Expr(OP_ASN, Expr(OP_PTRTO, Expr(dbtrp), Expr(dobjp)),
		Expr(KW_RCAST, Expr(KW_CCAST,
			getthis(ddcbind), type_ptrto(type_declref(dc))),
				type_ptrto(type_declref(_d_Obj)))));
	Expr ec = ExprCall(Expr(OP_PTRTO,
			Expr(KW_RCAST, dbtrp, type_ptrto(type_declref(dci))),
						ddcheck),
			ExprList());
	StmtList slelse(ddcbind->f.pscope);
	sl += StmtIfElse(ec, StmtReturn(Lit(&Type_bool, 1)), Stmt(slelse));
	slelse += Stmt(Expr(OP_ASN, Expr(OP_PTRTO, Expr(dbtrp), Expr(ditabp)),
		Lit(&Type_int, 0)));
	slelse += Stmt(Expr(OP_ASN, Expr(OP_PTRTO, Expr(dbtrp), Expr(dobjp)),
		Lit(&Type_int, 0)));
	slelse += StmtReturn(Lit(&Type_bool, 0));
	ddcbind->set_val(sl);

	// gen: ti c::dcbind(::ti&) const return btr; { dcbind(&btr); } 
	// gen: ti c::dcbind(::ti&) const {::ti btr; dcbind(&btr); return btr;}
	param[0].name = 0;
	param[0].type = type_refto(ti);
	Decl *ddcbind2 = newmethod(_id_dcbind, sc, ti, true, 1, param);
	StmtList sl2(ddcbind2->f.pscope);
	Decl *d = newdecl(_id_btr, ddcbind2->f.pscope, ti);
	sl2 += Stmt(ExprDecl(d));
	sl2 += StmtCall(ddcbind, elist(Expr(OP_REF, d)));
	sl2 += StmtReturn(d);
	ddcbind2->set_inline().set_val(sl2);
}

void
Deco::gen_dbind(Decl *dc, Decl *ditab, type_t ti)
{
	Param param[2];
	param[0].clear();
	param[0].defval = NONE;
	param[1].clear();
	param[1].defval = NONE;
	Scope sc = getaggrscope(dc);

	// gen: void dbind(ti *btrp) const 
	//	{ btrp->_objp = const_cast<c*>(this);
	// 	  btrp->_itabp = ti::_itable; }
	param[0].name = _id_btrp;
	param[0].type = type_ptrto(ti);
	Decl *ddbind = newmethod(_id_dbind, sc, &Type_void, true, 1, param);
	StmtList sl3(ddbind->f.pscope);
	Decl *dbtrp = Scope(ddbind->f.pscope).get(_id_btrp);
	Decl *dobjp = getaggrscope(_d_BTRef).ufind(_id__objp);
	Decl *ditabp = getaggrscope(_d_BTRef).ufind(_id__itabp);
	assert(dbtrp);
	assert(dobjp);
	assert(ditabp);
	sl3 += Stmt(Expr(OP_ASN, Expr(OP_PTRTO, Expr(dbtrp), Expr(dobjp)),
		Expr(KW_RCAST, Expr(KW_CCAST,
			getthis(ddbind), type_ptrto(type_declref(dc))),
				type_ptrto(type_declref(_d_Obj)))));
	sl3 += Stmt(Expr(OP_ASN, Expr(OP_PTRTO, Expr(dbtrp), Expr(ditabp)),
		Expr(ditab)));
	ddbind->set_val(sl3);

	// gen: operator ti() const return btr; { dbind(&btr); }
	// gen: operator ti() const { ti btr; dbind(&btr); return btr; }
	Decl *dconv;
	{
		sz buf[MAXIDLEN];
		buf[0] = '\0';
		Scope savescope = ccout.scope();
		ccout.scope(sc);
		type_string(ti, buf);
		ccout.scope(savescope);
		strpcat(buf, "operator ");
		dconv = newmethod(strid(buf), sc, 0, true);
	}
	StmtList sl2(dconv->f.pscope);
	Decl *d = newdecl(_id_btr, dconv->f.pscope, ti);
	sl2 += Stmt(ExprDecl(d));
	sl2 += StmtCall(ddbind, elist(Expr(OP_REF, d)));
	sl2 += StmtReturn(d);
	dconv->set_inline().set_val(sl2);
}


void
Deco::gen_binder(Decl *dc, Decl *dci, Decl *ditab, type_t ti)
{
	Scope sci = getaggrscope(dci);
	Decl *ddcheck = sci.uget(_id_dcheck);
	if(ddcheck)
		gen_dcbind(dc, dci, ditab, ddcheck, ti);
	else
		gen_dbind(dc, ditab, ti);
}


void
Deco::dimpl_to_cxx(Decl *ddi, Decl *dc)
{
	Decl *dci = forwref(Decl::dt_class, ddi->id, getaggrscope(dc));
	Scope sci = newaggrscope(dci);

	// gen: : public dti;
	inherit(dci, ddi->i.decl, TDecl::ac_public);

	// gen: private: inline ci() {}
	newmethod(ddi->id, sci, 0)->set_inline().set_val(StmtList())
				.set_access(Decl::ac_private);
	
	// gen: private: static void *_itable[];
	Decl *ditab = newdecl(_id__itable, sci, type_array(type_ptrto(&Type_void), NPOS));
	ditab->set_access(Decl::ac_private);

	// gen: private: friend class c;
	newdecl(ID_FRIEND, sci, type_declref(dc))->storage = Decl::sc_friend;

	// gen: c * this_ref() const { return static_cast<c*>(_this_ref()); }
	type_t rt = type_ptrto(type_declref(dc));
	Decl *dthisr = newmethod(_id_this_ref, sci, rt, true);
	StmtList sl;
	sl += StmtReturn(Expr(KW_RCAST, ExprCall(Expr(_d_bt__this_ref),
							ExprList()), rt));
	Expr ethiscall = ExprCall(Expr(dthisr), ExprList())
			.set_rtype(realtype(rt));
	dthisr->set_inline().set_val(sl);

	// gen: ti c::dcbind(::ti&) const return btr; { dcbind(&btr); } 
	// gen: ti c::dcbind(::ti&) const {::ti btr; dcbind(&btr); return btr;}
	
	for(Decl *dm = ddi->a.first; dm; dm = dm->next) {
		Decl *d = new Decl;
		*d = *dm;
		if(d->is_method) {
			Method *meth = dcast_Method(d->rtype);
			Func *func = dcast_Func(meth->ftype());
			Scope scf = func->scope();
			scf.parent(sci);
			d->v.expr = expr_rewrite(d->v.expr, rewrite_id_expr,
					Expr(getthis(d)) += ethiscall);
		}
		d->where = -1;
		d->link = 0;
		d->next = 0;
		d->scope = sci;
		decladd(d);
		chaindecl(d);
	}

	// gen: static void * c::ci::_itable[] = \
	//		{ 0, static_cast<void*>(fn), ... }
	ExprList eitab(ARRAY, LINE);
	eitab += Expr(Lit(&Type_int, 0));
	for(Decl *dtm = ddi->i.decl->a.first; dtm; dtm = dtm->next) {
		if(!dtm->is_method)
			continue;
		Decl *d = sci.uget(dtm->id);
		if(!d || d->scope != sci) {
			sz buf[MAXIDLEN];
			sprintf(buf, "default__%s", cstr(dtm->id));
			d = getaggrscope(ddi->i.decl->next).uget(strid(buf));
		}
		if(!d)
			error("can't find definition for %s", cstr(dtm->id));
		eitab += expr_mfnadr(type_ptrto(&Type_void), d);
	}
	ditab->set_val(eitab);

	// XXX - loop through type and add fns
	// (should perhaps use "struct itable" to provide ptr types?)

	gen_binder(dc, dci, ditab, type_declref(ddi->i.decl));

	dci->defined = true;
}

void
Deco::dclassdimpl_to_cxx(Decl *ddi, Decl *dc, Decl *ddat)
{
	Param param[2];
	param[0].clear();
	param[0].defval = NONE;
	param[1].clear();
	param[1].defval = NONE;

	Decl *dci = forwref(Decl::dt_class, ddi->id, getaggrscope(dc));
	Scope sci = newaggrscope(dci);
	// Scope sc = getaggrscope(dc);

	// gen: : public dti;
	inherit(dci, ddi->i.decl, TDecl::ac_public);

	// gen: private: inline ci() {}
	newmethod(ddi->id, sci, 0)->set_inline().set_val(StmtList())
				.set_access(Decl::ac_private);
	
	// gen: private: static void *_itable[];
	Decl *ditab = newdecl(_id__itable, sci, type_array(type_ptrto(&Type_void), NPOS));
	ditab->set_access(Decl::ac_private);

	// gen: private: friend class c;
	newdecl(ID_FRIEND, sci, type_declref(dc))->storage = Decl::sc_friend;

	// gen: dat * this_rw() const { return static_cast<dat*>(_this_rw()); }
	type_t rt = type_ptrto(type_declref(ddat));
	Decl *dthisrw = newmethod(_id_this_rw, sci, rt, true);
	StmtList sl;
	sl += StmtReturn(Expr(KW_RCAST, ExprCall(Expr(_d_bt__this_rw),
							ExprList()), rt));
	Expr ethiscall = ExprCall(Expr(dthisrw), ExprList())
			.set_rtype(realtype(rt));
	dthisrw->set_inline().set_val(sl);

	for(Decl *dm = ddi->a.first; dm; dm = dm->next) {
		Decl *d = new Decl;
		*d = *dm;
		if(d->is_method) {
			if(!d->initialized)
				continue;
			Method *meth = dcast_Method(d->rtype);
			Func *func = dcast_Func(meth->ftype());
			Scope scf = func->scope();
			scf.parent(sci);
			if(Expr(d->v.expr).op() == VAL_ID) {
				Decl *df = Expr(d->v.expr).decl();
				assert(df);
				ExprList elp = copyargs(func);
				Expr ect = ExprCall(Expr(dthisrw), ExprList())
							.set_rtype(type_ptrto(ddat->rtype));
				Expr e = ExprCall(Expr(OP_PTRTO, ect, Expr(df)), elp);
				StmtList sl(scf);
				if(func->rtype() && func->rtype() != &Type_void)
					sl += StmtReturn(e);
				else
					sl += Stmt(e);
				d->v.expr = sl;
			} else 
				d->v.expr = expr_rewrite(d->v.expr, rewrite_id_expr,
					Expr(getthis(d)) += ethiscall);
		}
		d->where = -1;
		d->link = 0;
		d->next = 0;
		d->scope = sci;
		decladd(d);
		chaindecl(d);
	}

	// gen: static void * c::ci::_itable[] = \
	//		{ 0, static_cast<void*>(fn), ... }
	ExprList eitab(ARRAY, LINE);
	eitab += Expr(Lit(&Type_int, 0));
	for(Decl *dtm = ddi->i.decl->a.first; dtm; dtm = dtm->next) {
		if(!dtm->is_method)
			continue;
		Decl *d = sci.uget(dtm->id);
		if(!d || d->scope != sci) {
			sz buf[MAXIDLEN];
			sprintf(buf, "default__%s", cstr(dtm->id));
			d = getaggrscope(ddi->i.decl->next).uget(strid(buf));
		}
		if(!d)
			error("can't find definition for %s", cstr(dtm->id));
		eitab += expr_mfnadr(type_ptrto(&Type_void), d);
	}
	ditab->set_val(eitab);
	
	// XXX - loop through type and add fns
	// (should perhaps use "struct itable" to provide ptr types?)

	gen_binder(dc, dci, ditab, type_declref(ddi->i.decl));

	dci->defined = true;
}

void
Deco::dtype_mfn_to_cxx(Decl *dm, Scope sc, int n)
{
	Decl *d = new Decl;
	*d = *dm;
	d->scope = sc;
	d->link = 0;
	d->next = 0;
	decladd(d);
	chaindecl(d);
	if(dm->initialized) {
		sz buf[MAXIDLEN];
		sprintf(buf, "default__%s", cstr(d->id));
		Decl *dn = new Decl;
		*dn = *d;
		dn->id = strid(buf);
		dn->where = -1;
		dn->link = 0;
		dn->next = 0;
		decladd(dn);
		chaindecl(dn);
	}
	Method *m = dcast_Method(d->rtype);
	assert(m);
	Func *f = dcast_Func(m->ftype());
	assert(f);
	d->initialized = true;
	StmtList sl(f->scope());
	ExprList elp = copyargs(f);
	Expr e = Expr(OP_INDEX, sc.uget(_id__itabp),
				Lit(&Type_int, n));
	e = Expr(KW_RCAST, e, Expr(type_ptrto(d->ptype)));
	e = Expr(OP_MPTRTO, Expr(getthis(d)), e);
	e = ExprCall(e, elp);
	if(f->rtype() == &Type_void)
		sl += Stmt(e);
	else
		sl += StmtReturn(e);
	d->set_inline().set_val(sl);
}

Decl*
Deco::cxx_of_dtype(Decl *ddt)
{
	// printf("converting %s (%d)\n", cstr(ddt->id), ddt->converted);
	if(ddt->converted)
		return ddt->next;

	Decl *d;

	Id idc = ddt->id;
	Scope psc = ddt->scope;
	unchaindecl(ddt);
	ddt->converted = true;
	Decl *dc = forwref(Decl::dt_class, idc, psc);
	assert(dc);
	ddt->next = dc;
	dc->otype = ddt->otype;
	if(!ddt->defined)
		return dc;
	if(!dcxx_init()) {
		error("must include <dcobj> to define dynamic type '%s'", cstr(idc));
		return 0;
	}
	
	Scope sc = newaggrscope(dc);
	// type_t tdc = dc->rtype;
	// type_t tcdc = type_const(tdc);

	// gen: : public BTRef;
	inherit(dc, _d_BTRef, TDecl::ac_public);

	// gen:  static const D_Type dtobj;
	if(!_d_D_Type) {
		Decl *d = global().tget(_id_D_Type);
		if(!d || d->dtype != Decl::dt_dclass) {
			error("`dclass D_Type' not declared");
			return 0;
		}
		if(d->converted)
			d = d->next;
		else
			d = cxx_of_dclass(d);
		_d_D_Type = d;
	}
	Decl *ddtobj = newdecl(_id_dtobj, sc,
				type_const(type_declref(_d_D_Type)));
	if(!_d_D_Type_dcobj) {
		Scope s = getaggrscope(_d_D_Type);
		if(!s) {
			error("`dclass D_Type' not defined");
			return 0;
		}
		if(!(_d_D_Type_dcobj = s.uget(_id_dcobj))) {
			error("`D_Type::dcobj' not declared");
			return 0;
		}
	}
	ddtobj->set_val(elist(_d_D_Type_dcobj, Lit(&Type_int, 0)));

	Param param[2];
	param[0].clear();
	param[0].defval = NONE;
	param[1].clear();
	param[1].defval = NONE;

	// member fns and implementation fns
	int n = 0;
	for(Decl *dm = ddt->a.first; dm; dm = dm->next) {
		if(dm->dtype == Decl::dt_dimpl) {
			dimpl_to_cxx(dm, dc);
		} else if(dm->is_method)
			dtype_mfn_to_cxx(dm, sc, ++n);
	}

	// gen: inline c(Obj &o, _DCBind) : BTRef(dtobj, &o) {}
	param[0].type = type_refto(type_declref(_d_Obj));
	param[0].name = _id_o;
	param[1].type = type_declref(_d_bt__DCBind);
	param[1].name = 0;
	d = newmethod(idc, sc, 0, false, 2, param);
	StmtList slctor(d->f.pscope);
	slctor += StmtCall(Expr(_d_BTRef), elist(Expr(ddtobj),
			Expr(OP_REF, Expr(Scope(d->f.pscope).uget(_id_o)))));
	d->set_inline().set_val(ExprCtor(slctor, StmtList()));

	// gen: inline c() : BTRef(dtobj) { _objp = 0; }
	d = newmethod(idc, sc, 0);
	slctor = StmtList(d->f.pscope);
	StmtList sl(d->f.pscope);
	slctor += StmtCall(Expr(_d_BTRef), elist(Expr(ddtobj)));
	Decl *dobjp = sc.ufind(_id__objp);
	sl += Stmt(Expr(OP_ASN, Expr(dobjp), Lit(&Type_int, 0)));
	d->set_inline().set_val(ExprCtor(slctor, sl));
	
	// gen: class instance : Obj {};
	d = forwref(Decl::dt_class, _id_instance, sc);
	newaggrscope(d);
	inherit(d, _d_Obj, TDecl::ac_public);
	d->defined = true;

	dc->defined = true;
	return dc;
}


Decl*
Deco::cxx_of_dclass(Decl *ddc)
{
	// printf("converting dclass %s (%d)\n", cstr(ddc->id), ddc->converted);
	if(ddc->converted)
		return ddc->next;

	Decl *d;
	Param param[2];
	param[0].clear();
	param[0].defval = NONE;
	param[1].clear();
	param[1].defval = NONE;

	Id idc = ddc->id;
	Scope psc = ddc->scope;
	unchaindecl(ddc);
	ddc->converted = true;
	Decl *dc = forwref(Decl::dt_class, idc, psc);
	assert(dc);
	ddc->next = dc;
	dc->otype = ddc->otype;
	if(!ddc->defined)
		return dc;
	if(!dcxx_init()) {
		error("must include <dcobj> to define dynamic class '%s'", cstr(idc));
		return 0;
	}
	
	Scope sc = newaggrscope(dc);
	type_t tdc = dc->rtype;
	type_t tconstdc = type_const(tdc);

	// gen: : public Obj;
	inherit(dc, _d_Obj, TDecl::ac_public);

	// gen:  static const D_Class dcobj;
	if(!_d_D_Class) {
		Decl *d = global().tget(_id_D_Class);
		if(!d || d->dtype != Decl::dt_dclass) {
			error("`dclass D_Class' not declared");
			return 0;
		}
		if(d->converted)
			d = d->next;
		else
			d = cxx_of_dclass(d);
		_d_D_Class = d;
	}
	Decl *ddcobj = newdecl(_id_dcobj, sc,
			type_const(type_declref(_d_D_Class)));
	ddcobj->otype = ddc->otype;
	if(!_d_D_Class_dcobj) {
		Scope s = getaggrscope(_d_D_Class);
		if(!s) {
			error("`dclass D_Class' not defined");
			return 0;
		}
		if(!(_d_D_Class_dcobj = s.uget(_id_dcobj))) {
			error("`D_Class::dcobj' not declared");
			return 0;
		}
	}
	ddcobj->set_val(elist(_d_D_Class_dcobj, Lit(&Type_int, 0)));

	// gen: class dataclass : bases { newmembers; }
	Decl *ddat = forwref(Decl::dt_class, _id_dataclass, sc);
	Scope sdat = newaggrscope(ddat);
	Scope sdc = getaggrscope(ddc);
	int nbase = 0;
	Decl *dbase = 0;
	bool simple = true;
	for(Decl *dbi = sdc.get(ID_INHERIT); dbi; dbi = dbi->link) {
		Decl *db = dbi->i.decl;
		// XXX - check for dclass inheritance
		// error for dtype inheritance
		inherit(ddat, db, TDecl::ac_public);
		++nbase;
		dbase = db;
	}

	// transfer constructors from dc to c
	// transfer fields from dc to dat
	for(Decl *dm = ddc->a.first; dm; dm = dm->next) {
		if(dm->dtype == Decl::dt_dimpl) {
			dclassdimpl_to_cxx(dm, dc, ddat);
		} else if(dm->is_method) {
			d = new Decl;
			*d = *dm;
			d->where = -1;
			d->link = 0;
			d->next = 0;
			d->scope = sc;
			decladd(d);
			chaindecl(d);
		} else {
			d = new Decl;
			*d = *dm;
			d->where = -1;
			d->link = 0;
			d->next = 0;
			d->scope = sdat;
			decladd(d);
			chaindecl(d);
			simple = false;
		}
	}
	if(simple && nbase == 0)
		warning("implementation has no local data");
	if(nbase != 1)
		simple = false;

	if(simple) {
		// gen: dataclass(const base &copy) : base(copy) {}
		param[0].name = _id_copy;
		param[0].type = type_refto(type_const(dbase->rtype));
		d = newmethod(_id_dataclass, sdat, 0, false, 1, param);
		StmtList slctor(d->f.pscope);
		slctor += StmtCall(Expr(dbase),
			elist(Scope(d->f.pscope).uget(_id_copy)));
		d->set_inline().set_val(ExprCtor(slctor, StmtList()));

		// copy other constructors 
		for(Decl *dm = dbase->a.first; dm; dm = dm->next) {
			if(dm->is_method) {
				Method *meth = dcast_Method(dm->rtype);
				Func *f = dcast_Func(meth->ftype());
				if(f->rtype())
					continue;
				d = new Decl;
				*d = *dm;
				d->id = _id_dataclass;
				d->scope = sdat;
				d->where = -1;
				d->link = 0;
				d->next = 0;
				ExprList p = copyargs(f);
				StmtList slctor(f->scope());
				slctor += StmtCall(Expr(dbase), p);
				d->set_inline().set_val(ExprCtor(slctor,
							StmtList()));
				decladd(d);
				chaindecl(d);
			} 
		}

		// gen: dc(base *share) { _init_ref(dcobj, share); }
		param[0].name = _id_share;
		param[0].type = type_ptrto(dbase->rtype);
		d = newmethod(idc, sc, 0, false, 1, param);
		StmtList sl(d->f.pscope);
		sl += StmtCall(_d_obj__init_ref,
			elist(ddcobj, Scope(d->f.pscope).get(_id_share)));
		d->set_inline().set_val(sl);
	}
	ddat->defined = true;

	// copy dataclass constructors to dclass
	for(Decl *dm = ddat->a.first; dm; dm = dm->next) {
		if(dm->is_method) {
			Method *meth = dcast_Method(dm->rtype);
			Func *f = dcast_Func(meth->ftype());
			if(f->rtype())
				continue;
			d = new Decl;
			*d = *dm;
			d->id = idc;
			d->scope = sc;
			d->where = -1;
			d->link = 0;
			d->next = 0;
			ExprList elp = copyargs(f);
			StmtList sl(f->scope());
			Expr ea = ExprCall(_d_obj__init_alloc, 
				elist(ddcobj, Expr(OP_TSIZEOF, ddat)));
			sl += Stmt(Expr(OP_NEW, Expr(ddat->rtype), Expr(elp), ea));
			d->set_inline().set_val(sl);
			decladd(d);
			chaindecl(d);
		}
	}	

	// gen: const dataclass* this_r() const
	//	{ return static_cast<const dataclass*>(_this_r()); }
	Scope pscope = newscope(sc, 0);
	type_t psig = type_psig(0, 0);
	type_t rt = type_ptrto(type_const(type_declref(ddat)));
	StmtList s;
	newdecl(_id_this_r, sc, type_method(tconstdc,
					type_func(rt, psig, pscope)))
		->set_inline().set_val(s);
	s += StmtReturn(Expr(KW_RCAST, ExprCall(Expr(_d_obj__this_r),
							ExprList()), rt));

	// gen: dataclass* this_rw() { return static_cast<dataclass*>(_this_rw()); }
	pscope = newscope(sc, 0);
	psig = type_psig(0, 0);
	rt = type_ptrto(type_declref(ddat));
	StmtList s2;
	newdecl(_id_this_rw, sc, type_method(tdc, type_func(rt, psig, pscope)))
		->set_inline().set_val(s2);
	s2 += StmtReturn(Expr(KW_RCAST, ExprCall(Expr(_d_obj__this_rw),
							ExprList()), rt));

	dc->defined = true;
	return dc;
}

Decl*
Deco::cxx_of_decl(Decl *d)
{
	switch(d->dtype) {
	case Decl::dt_dtype:
		return cxx_of_dtype(d);
	case Decl::dt_dclass:
		return cxx_of_dclass(d);
	/*
	case Decl::dt_default: {
		type_t pt = d->ptype;
		type_t npt = cxxtype(pt);
		if(pt != npt) {
			d->ptype = npt;
			d->rtype = realtype(npt);
		}
		} break; */
	default:
		return 0;
	}
}

void
Deco::dcxx_to_cxx(Scope sc)
{
	if(Decl *ds = sc.decl()) {
		for(Decl *dn, *d = ds->a.first; d; d = dn) {
			dn = d->next;
			cxx_of_decl(d);
		}
	} else 
		for(int n=0; Id id = sc.index(n); n++) 
			cxx_of_decl(sc.get(id));
}


void
Deco::dcxx_to_cxx()
{
	for(ScopeList sl = _allscopes; Scope s = sl.head(); sl = sl.tail())
		dcxx_to_cxx(s);
}


void
Deco::predefine()
{
	if(!dcxx())
		return;

	_id_instance = strid("instance");
	_id_dtobj = strid("dtobj");
	_id_dcobj = strid("dcobj");
	_id_dataclass = strid("dataclass");
	_id_dbind = strid("dbind");
	_id_dcheck = strid("dcheck");
	_id_dcbind = strid("dcbind");
	_id_o = strid("o");
	_id_btrp = strid("btrp");
	_id__objp = strid("_objp");
	_id__itabp = strid("_itabp");
	_id__itable = strid("_itable");
	_id_D_Type = strid("D_Type");
	_id_D_Class = strid("D_Class");
	_id_this_ref = strid("this_ref");
	_id_this_r = strid("this_r");
	_id_this_w = strid("this_w");
	_id_this_rw = strid("this_rw");
	_id_btr = strid("btr");
	_id_copy = strid("copy");
	_id_share = strid("share");
/*
	forwref(Decl::dt_class, (_id_BTRef = strid("BTRef")));
	Decl *d = forwref(Decl::dt_class, (_id_Obj = strid("Obj")));
	((Aggr*)d->rtype->ptr())->set_scope(new SymTab(d->scope, d));
	forwref(Decl::dt_class, (_id__DCBind = strid("_DCBind")));
	forwref(Decl::dt_class, (_id_D_Type = strid("D_Type")));
	forwref(Decl::dt_class, (_id_D_Class = strid("D_Class")));
*/
}

Decl*
Deco::declfind(csz *name, Scope sc)
{
	if(!sc)
		sc = global();
	Decl *d = sc.ufind(strid(name));
	if(!d) {
		error("`%s' not declared", name);
		_dcxx_initialized = false;
	}
	return d;
}

bool
Deco::dcxx_init()
{
	if(_dcxx_initialized)
		return true;
	if(!declfind("__dcobj__"))
		return false;

	_dcxx_initialized = true;
	_d_BTRef = declfind("BTRef");
	Scope scbt = get_symtab(_d_BTRef);
	_d_bt__DCBind = declfind("_DCBind", scbt);
	_d_bt__this_r = declfind("_this_r", scbt);
	_d_bt__this_w = declfind("_this_w", scbt);
	_d_bt__this_rw = declfind("_this_rw", scbt);
	_d_bt__this_ref = declfind("_this_ref", scbt);

	_d_Obj = declfind("Obj");
	Scope scobj = get_symtab(_d_Obj);
	_d_obj__init_alloc = declfind("_init_alloc", scobj);
	_d_obj__init_ref = declfind("_init_ref", scobj);
	_d_obj__this_r = declfind("_this_r", scobj);
	_d_obj__this_w = declfind("_this_w", scobj);
	_d_obj__this_rw = declfind("_this_rw", scobj);

	_d_D_Class = 0;
	_d_D_Class_dcobj = 0;
	_d_D_Type = 0;
	_d_D_Type_dcobj = 0;

	if(!_dcxx_initialized)
		abort("fatal error in include file <dcobj>");
	return true;
}

/////////////////////////////////////////////////////////////////////////////
// I/O functionality

void
Deco::veprintf(csz *fmt, va_list args)
{
	vfprintf(stderr, fmt, args);
}



void
Deco::abort_exit()
{
	exit(1);
}


void
Deco::internal_error_exit()
{
	mprintf("", "Please send a full bug report to `shaggy@csh.rit.edu'");
	mprintf("", "(please read the BUGS file first for details)");
	exit(2);
}


bool
Deco::open_input(csz *fname, csz *cpp)
{
	_input_fd = fname ? open(fname, O_RDONLY) : 0;
	if(_input_fd >= 0 && cpp) {
		sz c[1024];
		sprintf(c, "%s %s", cpp, fname ? fname : "-");
		FILE *f = popen(c, "r");
		_input_fd = fileno(f);
	}
	_clex.source(fname ? fname : "");
	return _input_fd >= 0;
}


void
Deco::close_input()
{
	if(_input_fd)
		close(_input_fd);
}


void
Deco::get_input(bool split_token)
{
	if(isatty(_input_fd) && !split_token) 
		write(1, (complete() ? "> " : "? "), 2);
	int n = read(_input_fd, _buf, _bufsize);
	if(n <= 0)
		_clex.set_eof();
	else
		_clex.set_src(_buf, n);
}
 

int
main(int argc, sz **argv)
{
	char strbuf[4096];
	char bufbuf[4096];
	char namebuf[1024];
	sz cppopt[1024];
	bool stop_occ = false;
	bool stop_cpp = false;
	bool nolang = true;
	bool dumpscopes = false;
	bool dumpscopes0 = false;
	csz *cpp = DECOCPP " " DECODEFINES " " DECOINCLUDES;
//	csz *cxx = DECOCXX;
	int rv = 0;
	int nfiles = 0;

	cppopt[0] = '\0';
	
	CLex lex(strbuf, sizeof(strbuf));
	lex.set_buf(bufbuf, sizeof(bufbuf));
	lex.set_name(namebuf, sizeof(namebuf));
	lex.parse_keywords();
	lex.parse_space(false).parse_indent(false);
//	lex.parse_cpp();
//	lex.parse_eol();
//	lex.parse_indent();

	/* XXX - main loop needs restructuring.... */

	StrTab strtab;
	SymTab symtab(&strtab);
	Decl gdecl;
	gdecl.clear();
	Scope(&symtab).decl(&gdecl);
	Deco deco(lex, strtab, symtab);
	CParse cparse(lex, deco);

	int argnum = 0;
	while(++argnum < argc) {
		csz *a = argv[argnum];

		if(a[0] == '-' && a[1]) {	// it's an option

			// Overall Options
			if(strcmp(a, "-x") == 0) {
				a = argv[++argnum];
				if(!a) {
					fprintf(stderr, "deco: missing arg\n");
					exit(1);
				}
				nolang = false;
				if(strcmp(a, "c") == 0)
					deco.parse_c();
				else if(strcmp(a, "c-hdr") == 0)
					deco.parse_h();
				else if(strcmp(a, "c-header") == 0)
					deco.parse_h();
				else if(strcmp(a, "c++") == 0)
					deco.parse_cxx();
				else if(strcmp(a, "c++hdr") == 0)
					deco.parse_hxx();
				else if(strcmp(a, "dc++") == 0)
					deco.parse_dcxx();
				else if(strcmp(a, "dc++hdr") == 0)
					deco.parse_dhxx();
				else if(strcmp(a, "none") == 0)
					nolang = true;
				else {
					fprintf(stderr,
					    "deco: unknown language `%s'\n",
						a);
					exit(1);
				}	
			}
			// -S
			else if(strcmp(a, "-E") == 0)
				stop_cpp = true;
			else if(strcmp(a, "-mcc") == 0)
				stop_occ = true;
			// -OC
			// -c
			else if(strcmp(a, "-np") == 0)
				cpp = 0;
			// -o
			else if(strcmp(a, "-v") == 0) {
				printf("deco " deco_VER_STR " ("
					deco_VER_DATE ")\n");
				return 0;
			}

			// Preprocessor Options
			else if(strncmp(a, "-I", 2) == 0
			     || strncmp(a, "-i", 2) == 0
			     || strncmp(a, "-D", 2) == 0
			     || strncmp(a, "-U", 2) == 0
			     || strncmp(a, "-A", 2) == 0
			     || strncmp(a, "-M", 2) == 0
			     || strncmp(a, "-nostdinc", 9) == 0
			     || strncmp(a, "-undef", 6) == 0
			     || strcmp(a, "-C") == 0
			     || strcmp(a, "-P") == 0
			     || strcmp(a, "-H") == 0
			     || strcmp(a, "-dM") == 0
			     || strcmp(a, "-dD") == 0
			     || strcmp(a, "-dN") == 0)
				sprintf(cppopt+strlen(cppopt), " %s", a);

			// Language and Parsing Options
			else if(strcmp(a, "-fsavecode") == 0)
				cparse.savecode(true);
			else if(strcmp(a, "-finclevel=") == 0)
				deco.inclevel(atoi(a+11));

			// Formatting Options
			else if(strcmp(a, "-ffullscope") == 0)
				deco.ccout.fullscope();
			else if(strcmp(a, "-frealtypes") == 0)
				deco.realtypes();
			else if(strncmp(a, "-fwidth=", 8) == 0) 
				deco.ccout.width(atoi(a+8));

			// Warning Options
			else if(strcmp(a, "-w") == 0)
				deco.nowarnings();
			else if(strcmp(a, "-fsyntax-only") == 0)
				deco.nooutput(true);
			else if(strcmp(a, "-Wall") == 0) {
				// all of what warnings?
			}
			else if(strcmp(a, "-Werror") == 0)
				deco.warnerr();

			// Debugging Options
			// -g
			else if(strcmp(a, "-dy") == 0)
				cparse.yydebug(true);
			else if(strcmp(a, "-dA") == 0)
				debugaction = true;
			else if(strcmp(a, "-dT") == 0)
				deco.ccout.debugtypes();
			else if(strcmp(a, "-dC") == 0) 
				cparse.debug(true);
			else if(strcmp(a, "-dS") == 0)
				dumpscopes = true;
			else if(strcmp(a, "-dS0") == 0)
				dumpscopes0 = true;
			else if(strcmp(a, "-da") == 0) {
				cparse.yydebug(true);
				debugaction = true;
				deco.ccout.debugtypes();
				cparse.debug(true);
				dumpscopes = true;
			}
			else if(strcmp(a, "-ddef") == 0)
				deco._notedef = true;
			else if(strcmp(a, "-ddecl") == 0)
				deco._notedecl = true;
			// -save-temps

			// Code Generation Options

			// Optimization Options
		
			else
				fprintf(stderr,
					"deco: unknown option `%s'\n", a);
			continue;
		}

		++nfiles;
		csz *fname = strcmp(a, "-") == 0 ? 0 : a;
		if(nolang) {
		    deco.parse_dcxx();
		    if(fname) {
			ParsePath p(fname);
			csz *ext = p.get_ext(".");
			if(ext) {
				if(strcmp(ext, "c") == 0) 
					deco.parse_c();
				else if(strcmp(ext, "cc") == 0
						|| strcmp(ext, "C") == 0
						|| strcmp(ext, "c++") == 0
						|| strcmp(ext, "cxx") == 0)
					deco.parse_cxx();
				else if(strcmp(ext, "dh") == 0)
					deco.parse_dhxx();
				else if(strcmp(ext, "hh") == 0
						|| strcmp(ext, "H") == 0)
					deco.parse_hxx();
				else if(strcmp(ext, "h") == 0)
					deco.parse_h();
			}
		    }
		}
		sz cppbuf[4096];
		if(cpp) 
			sprintf(cppbuf, "%s%s%s%s", cpp, 
				" -D__dcplusplus ",
				deco.hdr() ? " -D__dcplusplus_hdr" : "",
				cppopt);
		if(!deco.open_input(fname, cpp ? cppbuf : 0)) {
			perror(fname ? fname : "stdin" );
			break;
		}
		if(stop_cpp) {
			while(!lex.eof()) {
				while(!lex.is_empty()) {
					printf("%c", lex.get_char());
					lex.next_char();
				} 
				deco.get_input(false);
			}
			continue;
		}
		deco.predefine();
		if(!cparse.parse()) 
			deco.mprintf("", "cannot recover from previous errors");
		if(dumpscopes0)
			deco.dump_scopes();
		if(deco.errors() == 0 && deco.dcxx())
			deco.dcxx_to_cxx();
		if(deco.warnings() > 0)
			deco.mprintf("", "%d warning%s",
				deco.warnings(), deco.warnings() == 1 ? "" : "s");
		if(dumpscopes)
			deco.dump_scopes();
		if(deco.errors() > 0) {
			deco.mprintf("", "%d error%s",
				deco.errors(), deco.errors() == 1 ? "" : "s");
			rv = 1;
		} else if (!deco.nooutput()) {
			if(deco.hdr())
				deco.ccout.outmask(
					(1<<Decl::OT_HDR)|(1<<Decl::OT_CODE));
			else
				deco.ccout.outmask((1<<Decl::OT_FROMHDR)|
					(1<<Decl::OT_HDR)|(1<<Decl::OT_CODE));
			deco.ccout.oprintf("// this file was auto-generated"
				" by deco " deco_VER_STR " from the command:");
			deco.ccout.onl();
			deco.ccout.oprintf("//\t");
			for(int i=0; i<argc; i++)
				deco.ccout.oprintf("%s ", argv[i]);
			deco.ccout.onl(2); 
			deco.print_syms();
		}
		deco.close_input();
	}
	if(!nfiles) {
		fprintf(stderr, "deco: nothing to do\n");
		exit(1);
	} 
	return rv;
}

