
%{
int yyerror(const char *str);
int yylex(int *yylval);
int yydebug = 1;
//#define YYPDEBUG
%}

%token IF ELSE
%token NUM
%token CODE
%token EOS


%%

start: amb;

amb: 
	  IF expr code EOS
	| IF expr code ELSE code EOS
	;

expr: 
	  NUM
		{ /* somehow modifies tokens that follow */ }
	;

code: CODE | code CODE;

%%

struct { int tok; int val; } inp[] = {
	IF,0, NUM,3, CODE,0, CODE,0, CODE,0, ELSE,0, CODE,0, EOS,0
};
int ntok = sizeof(inp)/sizeof(*inp);
int tnum = 0;

int
yyerror(const char *str)
{
	printf("yyerror: %s\n", str);
}

int
yylex(int *yylval)
{
	if(tnum < ntok) {
		*yylval = inp[tnum].val;
		return inp[tnum++].tok;
	} else
		return 0;
}

main()
{
	yyparse();
}

