/*  CParse.tab.cc                                               (CRC:ef977d74)
 *      relative path: ./lib/cparse/mg
 *      creation date: Fri Aug 21 21:56:27 1998
 *      last modified: Fri Aug 21 23:00:18 1998
 *      header update: Fri Aug 21 23:01:07 1998
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Libraries
 *        C/C++ Parsing classes
 *         (mg)
 *  
 *  Copyright (c) 1996,1997 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is part of the Shag/OS distribution, and may be freely used and
 *  distributed by the terms of the ShagWare General Public License (SGPL),
 *  version 2, or, at your option, any newer official version of that License.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND,
 *  INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE, AND WILL NOT BE LIABLE FOR ANY DAMAGES.
 *  For more warranty details, see the ShagWare General Public License, which
 *  should have been received with this program, in a file called 'lic_spl2.txt'
 *  If this license is missing, please contact the author and describe how
 *  this software was obtained.  Email: shaggy@csh.rit.edu
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/* this file was auto-generated by shacc 0.5 from the command:
 *	../.././bin/shacc -e -t -o CParse.tab.cc -h CParse.tab.h CParse.y 
 */
#line 454 "CParse.y"
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

#pragma Make Exclusive

#include <defines>
#include <inttypes.h>
#include <posix/stdarg.h>
#include <posix/string.h>
#include "ActionStack.h"
#include <TokenList>

#define IMPLEMENTATION_CParse
#include "CParse.hh"


#define YYSTYPE CParse::Item


#define yyassert(c)	{ if(!(c)) INTERNAL_ERROR; }
#define yyerror 	_caction->error
#define yywarning 	_caction->warning

#define YYCLASS		CParse
#define YYPARSE		_do_parse
#define YYLEX		_peekahead_lex
#define YYDEBUGFLAG	_yydebug
#define YYEPRINTF	_caction->eprintf
#define YYPARSE_VARS	\
	ActionStack actionstack(_caction);

//#define YYPDEBUG


// XXX - eventually, all of the constant strings (for errors/warnings)
// should be removed and replaced with error ID's
// that can be passed to CAction where they can have defaults
// and overrides.  This will also aid internationalization.
// The position specifier needs to be added to printf for this
// to entirely work correctly.



#define swap_items(a,b)	{ Item tmp = a; a = b; b = tmp; }


#define eval_decl(r, a, t) \
	{ actionstack.pop_lifo(&(r), (a), decl_actions, (t)); }
#define eval_pdecl(r, a, t) \
	{ actionstack.pop_lifo(&(r), (a), pdecl_actions, (t)); }

#define declSym(r, s, d) \
	{ actionstack.push(&(r), none, ACTION_Decl, T(TBC), (d), (s)); }
#define declSym2(r, a, s, d) \
	{ actionstack.push(&(r), (a), ACTION_Decl, T(TBC), (d), (s)); }
#define defineSym(r, s, v) \
	{ actionstack.push(&(r), none, ACTION_Define, (s), (v), \
						none); }
#define declPtr(r, op, d) \
	{ actionstack.push(&(r), (d), ACTION_Ptr, (op), T(TBC)); }
#define declArray(r, d, i) \
	{ actionstack.push(&(r), (d), ACTION_Array, T(TBC), i, 0); }
#define declFunc(r, d, p, c) \
	{ actionstack.push(&(r), (d), ACTION_Func, T(TBC), (p), (c)); }
#define declInit(r, d, v) \
	{ actionstack.push(&(r), (d), ACTION_Init, T(TBC), (p)); }
#define buildParamList(r, l, i) \
	{ actionstack.push(&(r), none, ACTION_BuildList, (l), (i)); }
#define buildDeclList(r, l, i) \
	{ actionstack.push(&(r), none, ACTION_None, (l), (i)); }

#define declInherit(r, t, b) \
	{ actionstack.push(&(r), none, ACTION_Inherit, T(TBC), (t), (b)); }
#define setAttr(r, d, a, v) \
	{ actionstack.push(&(r), (d), ACTION_SetAttr, T(TBC), (a), (v)); }


#define UNSUPPORTED yyerror("unsupported syntax (%d)", __LINE__);
#define NOSCOPE(s) if(s.scope) yyerror("scope not allowed");



enum ActionIndex {
	ACTION_None = 0,
	ACTION_Decl,
	ACTION_Define,
	ACTION_Ptr,
	ACTION_Array,
	ACTION_Func,
	ACTION_BuildList,
	ACTION_Inherit,
	ACTION_SetAttr,
};


static const vCAction::Action decl_actions[] = {
	0,		/* none */
	&A(DeclSym),	/* declarator */
	&A(Define),	/* define initial value */
	&A(DeclPtr),	/* pointer (*) or reference (&) declaration */
	&A(DeclArray),	/* array declaration ([n]) */
	&A(DeclFunc),	/* function declaration */
	&A(BuildParamList), /* parameter list (,) */
	&A(Inherit),	/* inherit from a base class */
	&A(SetAttr),	/* set attributes */
};

static const vCAction::Action pdecl_actions[] = {
	0,		/* none */
	&A(DeclParam),	/* declarator */
	&A(DefParam),	/* default value */
	&A(DeclPtr),	/* pointer (*) or reference (&) declaration */
	&A(DeclArray),	/* array declaration ([n]) */
	&A(DeclFunc),	/* function declaration */
	&A(BuildParamList), /* parameter list (,) */
	0,		/* none */
	0,		/* none */
};


/* Note: when defining parameter lists, the current scope,
	which is used for each parameter, can either be some arbitrary
	undefined scope, for arbitrary declarations,
	or the scope of the function, for the header on the definition */

/* Need a 'kill_scope' to get rid of unneeded scopes later, and
   reference counts should probably be used on all items so
   that those items referenced in a scope which are still needed 
   will be available */


#define curscope	_current_scope
#define savescope_new(s,f,t,i)	{ s = _current_scope; \
		do3(_current_scope, f, t, i, s); }
#define savescope_newlocal(s)	{ s = _current_scope; \
		do3(_current_scope, NewLocal, none, none, s); }
#define savescope_newfunc(s,d)	{ s = _current_scope; \
		do2(_current_scope, FuncScope, d, s); }
#define savescope_set(s, n)	{ s = _current_scope; _current_scope = n; }
#define savescope_swap(s)	{ Item t = s; s = _current_scope; _current_scope = t; }
#define savescope(s)		{ s = _current_scope; }
#define getscope_restore(g, r)	savescope_set(g, r)
#define restorescope(s) { _current_scope = s; }


#define YYDEBUG 1

typedef signed char yys8;
typedef unsigned char yyu8;
typedef short yys16;
typedef unsigned short yyu16;
typedef int yys32;
typedef unsigned int yyu32;

#ifndef YYSTYPE
#	define	YYSTYPE	int
#endif

typedef yys16 YYTTYPE;
typedef yyu16 YYRTYPE;
/* Parser code for shacc
 *
 * possible #define's:
 *	YYLEX		- lexer function [yylex]
 *	YYPARSE		- parser function [yyparse]
 *	YYDEBUGFLAG	- debugging flag [yydebug]
 *	YYERROR		- error reporting function [yyerror]
 *	YYEPRINTF	- error printf [yyeprintf]
 *	YYCLASS		- class name to encapsulate parser in
 *	YYLEX_PARAM	- parameter for lexer function
 *	YYPARSE_PARAM	- parameter for parser function
 *	YYPARSE_VARS	- local variables for parsing
 */

/* Note:  I really hate excessive #ifdef's and #define's like the following,
 * so if anyone has a much cleaner solution to the problem of keeping this
 * one source file compatible with many different variations, and still
 * allowing default values, please let me know...
 * (keep in mind that this code needs to work for both C and C++ as well)
 */
#ifndef YYDEBUG
#	ifdef YYPDEBUG
#		error The '-t' flag is required if YYPDEBUG is defined
#	else
#		define YYDEBUG 0
#	endif
#endif
#ifndef YYDEBUGFLAG
#	define YYDEBUGFLAG	yydebug
#endif
#ifndef YYLEX
#	define	YYLEX	yylex
#endif
#ifndef	YYPARSE
#	define	YYPARSE	yyparse
#endif
#ifndef YYMALLOC
#	define	YYMALLOC	malloc
#	include <stdlib.h>
#endif
#ifndef YYFREE
#	define YYFREE		free
#endif
#ifndef YYEPRINTF
#	define	YYEPRINTF	printf
#	include <stdio.h>
#endif
#ifndef YYERROR
#	define	YYERROR		yyerror
#endif
#ifndef YYINTERR_
#	define	YYINTERR_(f,n)	YYERROR("internal parser error (" \
					## f ## ":" ## YYQUOTE(n) ## ")\n")
#endif
#ifndef YYINTERR
#	define	YYINTERR	YYINTERR_("shacc.c.parser", __LINE__)
#endif
#ifdef YYIMPURE
#	define YYLEXCALL YYLEX()
#else
#	ifdef YYLEX_PARAM
#		define YYLEXCALL YYLEX(&yylval, YYLEX_PARAM)
#	else
#		define YYLEXCALL YYLEX(&yylval)
#	endif
#endif
#ifdef YYCLASS
#	define YYYYCLASS	yy##YYCLASS
#	define YYPREFIX		YYYYCLASS::
#	define YYSTATIC
#else
#	define YYPREFIX
#	define YYSTATIC		static
#endif
#ifdef YYPARSE_PARAM
#	define YYPARSEPARAMS	void *YYPARSE_PARAM
#	define YYPARSEPARAM	YYPARSE_PARAM
#else
#	define YYPARSEPARAMS
#	define YYPARSEPARAM
#endif
#ifndef YYPARSE_VARS
#	define YYPARSE_VARS	
#endif

#ifdef YYYACC
#	if YYDEBUG
		int	YYDEBUGFLAG;
#	endif
#endif


#define YYQUOTE(x)	#x

/* temporary -- for debugging this parser code */
//#define YYPDEBUG
#ifdef YYPDEBUG
#	define DBG(x)	x
#else
#	define DBG(x)
#endif


enum {
	YYNRULES = 536,
	YYNNONTERMS = 191,
	YYNTOKENS = 453,
	YYNSYMS = 931,
	YYINITDEPTH = 1000,
#line 106 "/u4/shaggy/u2/src/sos/util/shacc/shacc.c.parser"
};

enum YYToken {
	/* $ = 0 */
	/* error = 1 */
	/* ? = 2 */
	ID = 257,
	NUM = 258,
	CHAR = 259,
	FLOAT = 260,
	STR = 261,
	CSTR = 262,
	BOOL = 263,
	BACKSTR = 264,
	ANGSTR = 265,
	LINE = 266,
	SPACE = 267,
	EOL = 268,
	CPP = 269,
	CPP_JOIN = 270,
	CPP_DEFINED = 271,
	CPP_DEFINE = 272,
	CPP_UNDEF = 273,
	CPP_IF = 274,
	CPP_IFDEF = 275,
	CPP_IFNDEF = 276,
	CPP_ENDIF = 277,
	CPP_ELIF = 278,
	CPP_INCLUDE = 279,
	CPP_PRAGMA = 280,
	CPP_ASSERT = 281,
	CPP_UNASSERT = 282,
	CPP_LINE = 283,
	CPP_ERROR = 284,
	CPP_WARNING = 285,
	CPP_IDENT = 286,
	CPP__FILE = 287,
	CPP__LINE = 288,
	CPP__DATE = 289,
	CPP__TIME = 290,
	CPP__STDC = 291,
	CPP__STDCVER = 292,
	EOS = 293,
	COLON = 294,
	COMMA = 295,
	QMARK = 296,
	POUND = 297,
	LBRACE = 298,
	RBRACE = 299,
	LBRACK = 300,
	RBRACK = 301,
	LPAREN = 302,
	RPAREN = 303,
	QLINE = 304,
	DOTDOT = 305,
	AT = 306,
	BSLASH = 307,
	OP_ADD = 308,
	OP_SUB = 309,
	OP_MUL = 310,
	OP_DIV = 311,
	OP_MOD = 312,
	OP_NOT = 313,
	OP_AND = 314,
	OP_OR = 315,
	OP_XOR = 316,
	OP_LNOT = 317,
	OP_LAND = 318,
	OP_LOR = 319,
	OP_LXOR = 320,
	OP_LSS = 321,
	OP_GTR = 322,
	OP_LEQ = 323,
	OP_GEQ = 324,
	OP_EQU = 325,
	OP_NEQ = 326,
	OP_INC = 327,
	OP_DEC = 328,
	OP_LSHIFT = 329,
	OP_RSHIFT = 330,
	OP_ASN = 331,
	OP_ASNADD = 332,
	OP_ASNSUB = 333,
	OP_ASNMUL = 334,
	OP_ASNDIV = 335,
	OP_ASNMOD = 336,
	OP_ASNAND = 337,
	OP_ASNOR = 338,
	OP_ASNXOR = 339,
	OP_ASNLSHIFT = 340,
	OP_ASNRSHIFT = 341,
	OP_DOT = 342,
	OP_PTRTO = 343,
	OP_SCOPE = 344,
	ELIPSIS = 345,
	OP_MDOT = 346,
	OP_MPTRTO = 347,
	OP_CONDASN = 348,
	KW_ATTRIBUTE = 349,
	KW_CONST = 350,
	KW_VOLATILE = 351,
	KW_AUTO = 352,
	KW_STATIC = 353,
	KW_EXTERN = 354,
	KW_REGISTER = 355,
	KW_LONG = 356,
	KW_SHORT = 357,
	KW_SIGNED = 358,
	KW_UNSIGNED = 359,
	KW_INT = 360,
	KW_CHAR = 361,
	KW_FLOAT = 362,
	KW_DOUBLE = 363,
	KW_VOID = 364,
	KW_IF = 365,
	KW_ELSE = 366,
	KW_DO = 367,
	KW_WHILE = 368,
	KW_FOR = 369,
	KW_SWITCH = 370,
	KW_CASE = 371,
	KW_DEFAULT = 372,
	KW_BREAK = 373,
	KW_CONTINUE = 374,
	KW_GOTO = 375,
	KW_RETURN = 376,
	KW_ENUM = 377,
	KW_UNION = 378,
	KW_STRUCT = 379,
	KW_TYPEDEF = 380,
	OP_SIZEOF = 381,
	KW__FUNC = 382,
	KW__PFUNC = 383,
	KW_OPERATOR = 384,
	KW_CLASS = 385,
	KW_THIS = 386,
	KW_TYPEID = 387,
	KW_TYPENAME = 388,
	KW_NAMESPACE = 389,
	KW_USING = 390,
	KW_TEMPLATE = 391,
	KW_PUBLIC = 392,
	KW_PRIVATE = 393,
	KW_PROTECTED = 394,
	KW_FRIEND = 395,
	KW_VIRTUAL = 396,
	KW_MUTABLE = 397,
	KW_EXPLICIT = 398,
	KW_BOOL = 399,
	KW_TRUE = 400,
	KW_FALSE = 401,
	KW_WCHAR = 402,
	KW_THROW = 403,
	KW_CATCH = 404,
	KW_TRY = 405,
	KW_SCAST = 406,
	KW_DCAST = 407,
	KW_CCAST = 408,
	KW_RCAST = 409,
	KW_INLINE = 410,
	KW_ASM = 411,
	OP_TYPEOF = 412,
	OP_NEW = 413,
	OP_DELETE = 414,
	OP_NEWA = 415,
	OP_DELETEA = 416,
	KW_DYNAMIC = 417,
	VAL_ID = 418,
	AGGR_ID = 419,
	ENUM_ID = 420,
	TYPE_ID = 421,
	CTOR_ID = 422,
	DTOR_ID = 423,
	OPER_ID = 424,
	CONV_ID = 425,
	NSPACE_ID = 426,
	ASPACE_ID = 427,
	TPLATE_ID = 428,
	SCOPE = 429,
	TOKENLIST = 430,
	OP_REF = 431,
	OP_PTR = 432,
	OP_MPTR = 433,
	OP_UMINUS = 434,
	OP_UPLUS = 435,
	OP_INCP = 436,
	OP_DECP = 437,
	OP_TSIZEOF = 438,
	OP_COMMA = 439,
	OP_FUNC = 440,
	OP_INDEX = 441,
	OP_CAST = 442,
	KW_DCLASS = 443,
	KW_DTYPE = 444,
	NEXT_INSN = 445,
	BACKPATCH = 446,
	ACTION = 447,
	TBC = 448,
	LBRACE_SAVE = 449,
	COLON_SAVE = 450,
	PARSE_COMPOUND = 451,
	DEFINE = 452,
	YYLASTTOKEN = 452,
#line 110 "/u4/shaggy/u2/src/sos/util/shacc/shacc.c.parser"
};

/* future: Maybe YYRedNode can be a union'ed case of YYNode?  use x = -1 
	to signal it's a reduction (for GC purposes) */

typedef struct YYNode YYNode;
struct YYNode {
	const YYNode *a; /* active/reduction link */
	const YYNode *s; /* substitution link */
	const YYNode *p; /* previous link */
	YYRTYPE r;	/* rule # */
	yys16 c;	/* reduction chain */
	yys16 c1;	/* 1st reduction */
	yyu8 x;		/* offset into rule */
	yyu8 rp;	/* reduction precedence */

	/* for GC */
	yyu8 rc;	/* reference count */
	yyu8 mark;
	YYNode *np;
	YYNode *pp;
};


typedef struct YYRedNode YYRedNode;
struct YYRedNode {
	YYRTYPE r;	/* rule # */
	yyu16 sp;	/* yydvsa stack pointer */
	yys16 p;	/* previous reduction */
#if YYDEBUG
	YYTTYPE	nt;	/* non-terminal to reduce to */
#endif
};


typedef struct YY YY;
struct YY {
	YYRedNode *rstk;
	YYSTYPE *vsa;		/* semantic value stack */
	YYSTYPE *dvsa;		/* deferred semantic value stack */
	int rsp;
	YYSTYPE *vsp;
	int dsp;		/* deferred stack pointer */
	int dsrp;		/* deferred stack read pointer */
	const YYNode *anp;	/* list of active states (non reduceable) */
	const YYNode *rnp;	/* list of reduceable active states */
	YYNode *free;		/* free list for node allocator */
	void *alloc;		/* allocated memory list */
	// char errstr[80];	/* error string */
	const YYNode *nts[YYNNONTERMS];	/* non-terminal substitutions */
};



typedef struct YYRule YYRule;
struct YYRule {
	yyu16	sym;		/* first symbol */
	yyu8	ns;		/* number of symbols */
	yyu8	skip;		/* number of rules to skip for next */
	yyu8	srp;		/* shift/reduce rule precedence */
	yyu8	rrp:6;		/* reduce/reduce rule precedence */
	yyu8	uniq:1;		/* reduction must be unique */
	yyu8	hasact:1;	/* has action */
};


enum {
	YYTOKEOF=0, YYTOKERROR=1, YYTOKUNDEF=2,
};


static YYRule yyrule[] = {
	/* 0 */ {	0,	2,	0,	0,	0,	0,0 },
	/* 1 */ {	2,	1,	1,	0,	0,	0,0 },
	/* 2 */ {	3,	2,	0,	0,	0,	0,1 },
	/* 3 */ {	5,	3,	0,	0,	0,	0,1 },
	/* 4 */ {	0,	0,	0,	0,	0,	0,1 },
	/* 5 */ {	8,	1,	1,	0,	0,	0,0 },
	/* 6 */ {	9,	1,	0,	0,	0,	0,0 },
	/* 7 */ {	10,	1,	1,	0,	1,	1,1 },
	/* 8 */ {	11,	3,	1,	0,	2,	1,1 },
	/* 9 */ {	14,	1,	1,	0,	0,	0,0 },
	/* 10 */ {	15,	1,	1,	0,	0,	0,0 },
	/* 11 */ {	16,	1,	1,	0,	0,	0,0 },
	/* 12 */ {	17,	2,	1,	0,	0,	0,0 },
	/* 13 */ {	19,	6,	0,	0,	0,	0,1 },
	/* 14 */ {	0,	0,	0,	0,	0,	0,1 },
	/* 15 */ {	25,	1,	1,	0,	0,	0,0 },
	/* 16 */ {	26,	1,	0,	0,	0,	0,0 },
	/* 17 */ {	27,	1,	1,	0,	0,	0,0 },
	/* 18 */ {	28,	1,	1,	0,	0,	0,0 },
	/* 19 */ {	29,	1,	1,	0,	0,	0,0 },
	/* 20 */ {	30,	1,	0,	0,	0,	0,0 },
	/* 21 */ {	31,	1,	1,	0,	0,	0,0 },
	/* 22 */ {	32,	1,	1,	0,	0,	0,0 },
	/* 23 */ {	33,	1,	1,	0,	0,	0,0 },
	/* 24 */ {	34,	1,	1,	0,	0,	0,0 },
	/* 25 */ {	35,	1,	0,	0,	0,	0,0 },
	/* 26 */ {	36,	3,	1,	0,	1,	0,0 },
	/* 27 */ {	39,	2,	0,	0,	2,	0,1 },
	/* 28 */ {	41,	1,	1,	0,	0,	0,0 },
	/* 29 */ {	42,	1,	1,	0,	0,	0,0 },
	/* 30 */ {	43,	1,	1,	0,	0,	0,0 },
	/* 31 */ {	44,	1,	1,	0,	0,	0,0 },
	/* 32 */ {	45,	1,	0,	0,	0,	0,0 },
	/* 33 */ {	46,	1,	1,	0,	0,	0,1 },
	/* 34 */ {	47,	2,	0,	0,	0,	0,1 },
	/* 35 */ {	49,	1,	1,	0,	0,	0,0 },
	/* 36 */ {	50,	1,	1,	0,	0,	0,1 },
	/* 37 */ {	51,	2,	1,	0,	0,	0,1 },
	/* 38 */ {	53,	2,	1,	0,	0,	0,1 },
	/* 39 */ {	55,	3,	0,	0,	0,	0,1 },
	/* 40 */ {	58,	1,	1,	0,	0,	0,0 },
	/* 41 */ {	59,	1,	0,	0,	0,	0,0 },
	/* 42 */ {	60,	1,	1,	0,	0,	0,0 },
	/* 43 */ {	61,	1,	1,	0,	0,	0,0 },
	/* 44 */ {	62,	1,	1,	0,	0,	0,0 },
	/* 45 */ {	63,	1,	1,	0,	0,	0,0 },
	/* 46 */ {	64,	1,	0,	0,	0,	0,0 },
	/* 47 */ {	65,	1,	1,	0,	0,	0,0 },
	/* 48 */ {	66,	1,	1,	0,	0,	0,0 },
	/* 49 */ {	67,	1,	0,	0,	0,	0,0 },
	/* 50 */ {	68,	1,	1,	0,	0,	0,0 },
	/* 51 */ {	69,	1,	1,	0,	0,	0,0 },
	/* 52 */ {	70,	1,	1,	0,	0,	0,0 },
	/* 53 */ {	71,	1,	1,	0,	0,	0,0 },
	/* 54 */ {	72,	1,	0,	0,	0,	0,0 },
	/* 55 */ {	73,	1,	1,	0,	0,	0,0 },
	/* 56 */ {	74,	1,	1,	0,	0,	0,0 },
	/* 57 */ {	75,	1,	1,	0,	0,	0,0 },
	/* 58 */ {	76,	1,	1,	0,	0,	0,0 },
	/* 59 */ {	77,	1,	1,	0,	0,	0,0 },
	/* 60 */ {	78,	1,	1,	0,	0,	0,0 },
	/* 61 */ {	79,	1,	1,	0,	0,	0,0 },
	/* 62 */ {	80,	1,	1,	0,	0,	0,0 },
	/* 63 */ {	81,	1,	1,	0,	0,	0,0 },
	/* 64 */ {	82,	1,	1,	0,	0,	0,0 },
	/* 65 */ {	83,	1,	0,	0,	0,	0,0 },
	/* 66 */ {	84,	1,	1,	0,	0,	0,0 },
	/* 67 */ {	85,	1,	1,	0,	0,	0,0 },
	/* 68 */ {	86,	1,	0,	0,	0,	0,0 },
	/* 69 */ {	87,	2,	1,	0,	0,	0,1 },
	/* 70 */ {	89,	2,	0,	0,	0,	0,1 },
	/* 71 */ {	91,	7,	0,	0,	0,	1,1 },
	/* 72 */ {	0,	0,	0,	0,	0,	0,1 },
	/* 73 */ {	98,	1,	1,	0,	0,	0,0 },
	/* 74 */ {	99,	3,	0,	0,	0,	0,0 },
	/* 75 */ {	102,	1,	1,	0,	0,	0,0 },
	/* 76 */ {	103,	1,	0,	0,	0,	0,0 },
	/* 77 */ {	104,	1,	1,	0,	0,	0,1 },
	/* 78 */ {	105,	3,	0,	0,	0,	0,1 },
	/* 79 */ {	108,	1,	1,	0,	0,	0,0 },
	/* 80 */ {	109,	1,	0,	0,	0,	0,0 },
	/* 81 */ {	110,	1,	1,	0,	0,	0,0 },
	/* 82 */ {	111,	1,	0,	0,	0,	0,0 },
	/* 83 */ {	112,	6,	0,	0,	0,	1,1 },
	/* 84 */ {	0,	0,	0,	0,	0,	0,1 },
	/* 85 */ {	118,	6,	0,	0,	0,	1,1 },
	/* 86 */ {	0,	0,	0,	0,	0,	0,1 },
	/* 87 */ {	124,	5,	0,	0,	0,	1,1 },
	/* 88 */ {	0,	0,	0,	0,	0,	0,1 },
	/* 89 */ {	129,	1,	0,	0,	0,	0,0 },
	/* 90 */ {	130,	5,	0,	0,	0,	1,1 },
	/* 91 */ {	135,	4,	1,	0,	0,	1,1 },
	/* 92 */ {	139,	3,	1,	0,	0,	1,1 },
	/* 93 */ {	142,	4,	0,	0,	0,	1,1 },
	/* 94 */ {	146,	4,	0,	0,	0,	1,1 },
	/* 95 */ {	150,	5,	0,	0,	0,	1,1 },
	/* 96 */ {	155,	5,	1,	0,	0,	0,0 },
	/* 97 */ {	160,	3,	0,	0,	0,	0,0 },
	/* 98 */ {	163,	0,	0,	0,	0,	0,1 },
	/* 99 */ {	163,	4,	1,	0,	0,	0,1 },
	/* 100 */ {	167,	4,	0,	0,	0,	0,1 },
	/* 101 */ {	171,	2,	1,	0,	0,	0,1 },
	/* 102 */ {	173,	2,	0,	0,	0,	0,1 },
	/* 103 */ {	175,	1,	1,	0,	0,	0,0 },
	/* 104 */ {	176,	1,	0,	0,	0,	0,0 },
	/* 105 */ {	177,	2,	1,	0,	0,	0,1 },
	/* 106 */ {	179,	4,	2,	0,	0,	0,1 },
	/* 107 */ {	0,	0,	0,	0,	0,	0,1 },
	/* 108 */ {	183,	5,	0,	0,	0,	0,1 },
	/* 109 */ {	0,	0,	0,	0,	0,	0,1 },
	/* 110 */ {	188,	1,	1,	0,	0,	0,0 },
	/* 111 */ {	189,	2,	0,	0,	0,	0,1 },
	/* 112 */ {	191,	1,	1,	0,	0,	0,0 },
	/* 113 */ {	192,	5,	1,	0,	0,	0,1 },
	/* 114 */ {	197,	4,	1,	0,	0,	0,1 },
	/* 115 */ {	201,	3,	1,	0,	0,	0,1 },
	/* 116 */ {	204,	3,	0,	0,	0,	0,1 },
	/* 117 */ {	207,	1,	0,	0,	0,	0,1 },
	/* 118 */ {	208,	5,	0,	0,	0,	0,1 },
	/* 119 */ {	213,	1,	1,	0,	1,	0,0 },
	/* 120 */ {	214,	1,	0,	0,	2,	0,0 },
	/* 121 */ {	215,	2,	1,	0,	0,	0,1 },
	/* 122 */ {	217,	1,	1,	0,	0,	0,1 },
	/* 123 */ {	218,	3,	0,	0,	0,	0,1 },
	/* 124 */ {	221,	2,	0,	0,	0,	0,1 },
	/* 125 */ {	223,	1,	1,	0,	0,	0,0 },
	/* 126 */ {	224,	1,	0,	0,	0,	0,0 },
	/* 127 */ {	225,	1,	1,	0,	0,	0,0 },
	/* 128 */ {	226,	1,	0,	0,	0,	0,0 },
	/* 129 */ {	227,	1,	0,	0,	0,	0,1 },
	/* 130 */ {	228,	2,	0,	0,	0,	0,1 },
	/* 131 */ {	230,	1,	1,	0,	0,	0,1 },
	/* 132 */ {	231,	2,	0,	0,	0,	0,1 },
	/* 133 */ {	233,	3,	1,	0,	0,	0,1 },
	/* 134 */ {	236,	1,	0,	0,	0,	0,0 },
	/* 135 */ {	237,	2,	1,	0,	0,	0,1 },
	/* 136 */ {	239,	1,	0,	0,	0,	0,0 },
	/* 137 */ {	240,	1,	1,	0,	0,	0,0 },
	/* 138 */ {	241,	1,	0,	0,	0,	0,0 },
	/* 139 */ {	242,	4,	1,	0,	0,	0,1 },
	/* 140 */ {	246,	5,	1,	0,	0,	0,1 },
	/* 141 */ {	251,	3,	0,	0,	0,	0,1 },
	/* 142 */ {	254,	0,	1,	0,	0,	0,1 },
	/* 143 */ {	254,	1,	1,	0,	0,	0,0 },
	/* 144 */ {	255,	3,	1,	0,	0,	0,1 },
	/* 145 */ {	258,	1,	0,	0,	0,	0,1 },
	/* 146 */ {	259,	1,	1,	0,	0,	0,1 },
	/* 147 */ {	260,	3,	0,	0,	0,	0,1 },
	/* 148 */ {	263,	4,	1,	0,	1,	0,1 },
	/* 149 */ {	267,	2,	1,	0,	1,	0,1 },
	/* 150 */ {	269,	4,	1,	0,	2,	0,1 },
	/* 151 */ {	273,	2,	0,	0,	2,	0,1 },
	/* 152 */ {	275,	1,	0,	0,	0,	0,1 },
	/* 153 */ {	276,	6,	0,	0,	0,	0,1 },
	/* 154 */ {	0,	0,	0,	0,	0,	0,1 },
	/* 155 */ {	282,	2,	2,	0,	0,	0,1 },
	/* 156 */ {	0,	0,	0,	0,	0,	0,1 },
	/* 157 */ {	284,	1,	0,	0,	0,	0,0 },
	/* 158 */ {	285,	2,	1,	0,	0,	0,1 },
	/* 159 */ {	287,	3,	0,	0,	0,	0,1 },
	/* 160 */ {	290,	1,	1,	0,	0,	0,0 },
	/* 161 */ {	291,	4,	0,	0,	0,	1,1 },
	/* 162 */ {	295,	0,	1,	0,	0,	0,0 },
	/* 163 */ {	295,	1,	0,	0,	0,	0,0 },
	/* 164 */ {	296,	2,	1,	0,	0,	0,0 },
	/* 165 */ {	298,	1,	0,	0,	0,	0,0 },
	/* 166 */ {	299,	2,	1,	0,	0,	0,1 },
	/* 167 */ {	301,	5,	1,	0,	0,	0,1 },
	/* 168 */ {	306,	4,	0,	0,	0,	0,1 },
	/* 169 */ {	310,	0,	1,	0,	0,	0,1 },
	/* 170 */ {	310,	1,	0,	0,	0,	0,0 },
	/* 171 */ {	311,	7,	0,	0,	0,	1,1 },
	/* 172 */ {	0,	0,	0,	0,	0,	0,1 },
	/* 173 */ {	318,	1,	1,	0,	0,	0,0 },
	/* 174 */ {	319,	1,	1,	0,	0,	0,0 },
	/* 175 */ {	320,	1,	1,	0,	0,	0,0 },
	/* 176 */ {	321,	2,	1,	0,	0,	0,1 },
	/* 177 */ {	323,	3,	1,	0,	0,	0,1 },
	/* 178 */ {	326,	1,	1,	0,	0,	0,0 },
	/* 179 */ {	327,	1,	0,	0,	0,	0,0 },
	/* 180 */ {	328,	2,	1,	0,	0,	0,0 },
	/* 181 */ {	330,	4,	2,	0,	0,	0,0 },
	/* 182 */ {	0,	0,	0,	0,	0,	0,1 },
	/* 183 */ {	334,	4,	2,	0,	0,	0,0 },
	/* 184 */ {	0,	0,	0,	0,	0,	0,1 },
	/* 185 */ {	338,	5,	0,	0,	0,	0,0 },
	/* 186 */ {	0,	0,	0,	0,	0,	0,1 },
	/* 187 */ {	343,	1,	1,	0,	0,	0,0 },
	/* 188 */ {	344,	1,	0,	0,	0,	0,0 },
	/* 189 */ {	345,	1,	1,	0,	0,	1,0 },
	/* 190 */ {	346,	3,	1,	0,	1,	1,1 },
	/* 191 */ {	349,	3,	1,	0,	2,	1,1 },
	/* 192 */ {	352,	2,	1,	0,	3,	1,1 },
	/* 193 */ {	354,	2,	1,	0,	4,	1,1 },
	/* 194 */ {	356,	1,	1,	0,	0,	0,1 },
	/* 195 */ {	357,	1,	0,	0,	0,	0,0 },
	/* 196 */ {	358,	2,	1,	0,	0,	0,0 },
	/* 197 */ {	360,	4,	0,	0,	0,	0,1 },
	/* 198 */ {	364,	1,	1,	0,	0,	0,0 },
	/* 199 */ {	365,	3,	1,	0,	0,	0,1 },
	/* 200 */ {	368,	2,	1,	0,	0,	0,1 },
	/* 201 */ {	370,	3,	0,	0,	0,	0,1 },
	/* 202 */ {	373,	1,	1,	0,	0,	0,0 },
	/* 203 */ {	374,	2,	0,	0,	0,	0,1 },
	/* 204 */ {	376,	1,	1,	0,	0,	0,0 },
	/* 205 */ {	377,	3,	0,	0,	0,	0,1 },
	/* 206 */ {	380,	1,	1,	0,	0,	0,1 },
	/* 207 */ {	381,	2,	1,	0,	0,	0,1 },
	/* 208 */ {	383,	3,	1,	0,	0,	0,1 },
	/* 209 */ {	386,	2,	1,	0,	0,	0,1 },
	/* 210 */ {	388,	3,	0,	0,	0,	0,1 },
	/* 211 */ {	391,	1,	1,	0,	0,	0,0 },
	/* 212 */ {	392,	1,	1,	0,	0,	0,0 },
	/* 213 */ {	393,	1,	0,	0,	0,	0,0 },
	/* 214 */ {	394,	2,	1,	0,	0,	0,1 },
	/* 215 */ {	396,	3,	0,	0,	0,	0,1 },
	/* 216 */ {	399,	2,	0,	0,	0,	0,1 },
	/* 217 */ {	401,	2,	0,	0,	0,	0,1 },
	/* 218 */ {	403,	1,	1,	0,	0,	0,0 },
	/* 219 */ {	404,	1,	0,	0,	0,	0,0 },
	/* 220 */ {	405,	3,	2,	0,	0,	0,1 },
	/* 221 */ {	0,	0,	0,	0,	0,	0,1 },
	/* 222 */ {	408,	3,	0,	0,	0,	0,1 },
	/* 223 */ {	0,	0,	0,	0,	0,	0,1 },
	/* 224 */ {	411,	1,	1,	0,	0,	0,0 },
	/* 225 */ {	412,	1,	0,	0,	0,	0,0 },
	/* 226 */ {	413,	1,	1,	0,	0,	0,0 },
	/* 227 */ {	414,	3,	0,	0,	0,	0,1 },
	/* 228 */ {	417,	1,	1,	0,	0,	0,1 },
	/* 229 */ {	418,	3,	0,	0,	0,	0,1 },
	/* 230 */ {	421,	4,	0,	0,	0,	0,1 },
	/* 231 */ {	425,	4,	0,	0,	0,	0,1 },
	/* 232 */ {	429,	2,	1,	0,	0,	0,1 },
	/* 233 */ {	431,	3,	0,	0,	0,	0,1 },
	/* 234 */ {	434,	1,	1,	0,	0,	0,0 },
	/* 235 */ {	435,	1,	1,	0,	0,	0,0 },
	/* 236 */ {	436,	1,	1,	0,	0,	0,0 },
	/* 237 */ {	437,	1,	1,	0,	0,	0,0 },
	/* 238 */ {	438,	1,	1,	0,	0,	0,0 },
	/* 239 */ {	439,	1,	1,	0,	0,	0,0 },
	/* 240 */ {	440,	1,	1,	0,	0,	0,0 },
	/* 241 */ {	441,	1,	1,	0,	0,	0,0 },
	/* 242 */ {	442,	1,	1,	0,	0,	0,0 },
	/* 243 */ {	443,	1,	1,	0,	0,	0,0 },
	/* 244 */ {	444,	1,	1,	0,	0,	0,0 },
	/* 245 */ {	445,	1,	1,	0,	0,	0,0 },
	/* 246 */ {	446,	1,	1,	0,	0,	0,0 },
	/* 247 */ {	447,	1,	1,	0,	0,	0,0 },
	/* 248 */ {	448,	1,	1,	0,	0,	0,0 },
	/* 249 */ {	449,	1,	1,	0,	0,	0,0 },
	/* 250 */ {	450,	1,	1,	0,	0,	0,0 },
	/* 251 */ {	451,	1,	1,	0,	0,	0,0 },
	/* 252 */ {	452,	1,	1,	0,	0,	0,0 },
	/* 253 */ {	453,	1,	1,	0,	0,	0,0 },
	/* 254 */ {	454,	1,	1,	0,	0,	0,0 },
	/* 255 */ {	455,	1,	1,	0,	0,	0,0 },
	/* 256 */ {	456,	1,	1,	0,	0,	0,0 },
	/* 257 */ {	457,	1,	1,	0,	0,	0,0 },
	/* 258 */ {	458,	1,	1,	0,	0,	0,0 },
	/* 259 */ {	459,	1,	1,	0,	0,	0,0 },
	/* 260 */ {	460,	1,	1,	0,	0,	0,0 },
	/* 261 */ {	461,	1,	1,	0,	0,	0,0 },
	/* 262 */ {	462,	1,	1,	0,	0,	0,0 },
	/* 263 */ {	463,	1,	1,	0,	0,	0,0 },
	/* 264 */ {	464,	1,	1,	0,	0,	0,0 },
	/* 265 */ {	465,	1,	1,	0,	0,	0,0 },
	/* 266 */ {	466,	1,	1,	0,	0,	0,0 },
	/* 267 */ {	467,	1,	1,	0,	0,	0,0 },
	/* 268 */ {	468,	1,	1,	0,	0,	0,0 },
	/* 269 */ {	469,	1,	1,	0,	0,	0,0 },
	/* 270 */ {	470,	1,	1,	0,	0,	0,0 },
	/* 271 */ {	471,	1,	1,	0,	0,	0,0 },
	/* 272 */ {	472,	1,	1,	0,	0,	0,0 },
	/* 273 */ {	473,	1,	0,	0,	0,	0,0 },
	/* 274 */ {	474,	1,	1,	0,	0,	0,0 },
	/* 275 */ {	475,	2,	1,	0,	0,	0,1 },
	/* 276 */ {	477,	2,	0,	0,	0,	0,1 },
	/* 277 */ {	479,	1,	1,	0,	0,	0,0 },
	/* 278 */ {	480,	1,	1,	0,	0,	0,0 },
	/* 279 */ {	481,	1,	1,	0,	0,	0,0 },
	/* 280 */ {	482,	1,	1,	0,	0,	0,0 },
	/* 281 */ {	483,	1,	0,	0,	0,	0,0 },
	/* 282 */ {	484,	1,	1,	0,	0,	0,1 },
	/* 283 */ {	485,	1,	1,	0,	0,	0,1 },
	/* 284 */ {	486,	3,	1,	0,	0,	0,1 },
	/* 285 */ {	489,	1,	0,	0,	0,	0,1 },
	/* 286 */ {	490,	1,	0,	0,	0,	0,0 },
	/* 287 */ {	491,	1,	0,	0,	0,	0,0 },
	/* 288 */ {	492,	1,	1,	0,	0,	0,0 },
	/* 289 */ {	493,	1,	1,	0,	0,	0,0 },
	/* 290 */ {	494,	1,	1,	0,	0,	0,0 },
	/* 291 */ {	495,	1,	0,	0,	0,	0,1 },
	/* 292 */ {	496,	1,	1,	0,	0,	0,0 },
	/* 293 */ {	497,	1,	1,	0,	0,	0,1 },
	/* 294 */ {	498,	1,	1,	0,	0,	0,0 },
	/* 295 */ {	499,	1,	1,	0,	0,	0,0 },
	/* 296 */ {	500,	1,	0,	0,	0,	0,1 },
	/* 297 */ {	501,	1,	1,	0,	0,	0,0 },
	/* 298 */ {	502,	4,	1,	0,	0,	0,1 },
	/* 299 */ {	506,	4,	1,	0,	0,	0,1 },
	/* 300 */ {	510,	4,	1,	0,	0,	0,1 },
	/* 301 */ {	514,	4,	1,	0,	0,	0,1 },
	/* 302 */ {	518,	3,	1,	0,	0,	0,1 },
	/* 303 */ {	521,	3,	1,	0,	0,	0,1 },
	/* 304 */ {	524,	3,	1,	0,	0,	0,1 },
	/* 305 */ {	527,	3,	1,	0,	0,	0,1 },
	/* 306 */ {	530,	2,	1,	0,	0,	0,1 },
	/* 307 */ {	532,	2,	1,	0,	0,	0,1 },
	/* 308 */ {	534,	7,	1,	0,	0,	0,1 },
	/* 309 */ {	541,	4,	1,	0,	0,	0,1 },
	/* 310 */ {	545,	4,	0,	0,	0,	0,1 },
	/* 311 */ {	549,	1,	1,	0,	0,	0,0 },
	/* 312 */ {	550,	1,	1,	0,	0,	0,0 },
	/* 313 */ {	551,	1,	1,	0,	0,	0,0 },
	/* 314 */ {	552,	1,	0,	0,	0,	0,0 },
	/* 315 */ {	553,	1,	1,	0,	0,	0,1 },
	/* 316 */ {	554,	3,	0,	0,	0,	0,1 },
	/* 317 */ {	557,	0,	1,	0,	0,	0,1 },
	/* 318 */ {	557,	1,	0,	0,	0,	0,0 },
	/* 319 */ {	558,	1,	0,	0,	0,	0,1 },
	/* 320 */ {	559,	1,	1,	0,	0,	0,0 },
	/* 321 */ {	560,	2,	1,	0,	0,	0,1 },
	/* 322 */ {	562,	2,	1,	0,	0,	0,1 },
	/* 323 */ {	564,	2,	1,	0,	0,	0,1 },
	/* 324 */ {	566,	2,	1,	0,	0,	0,1 },
	/* 325 */ {	568,	4,	1,	0,	0,	0,1 },
	/* 326 */ {	572,	1,	1,	0,	0,	0,0 },
	/* 327 */ {	573,	1,	0,	0,	0,	0,0 },
	/* 328 */ {	574,	1,	1,	0,	0,	0,1 },
	/* 329 */ {	575,	1,	1,	0,	0,	0,1 },
	/* 330 */ {	576,	1,	1,	0,	0,	0,1 },
	/* 331 */ {	577,	1,	1,	0,	0,	0,1 },
	/* 332 */ {	578,	1,	1,	0,	0,	0,0 },
	/* 333 */ {	579,	1,	0,	0,	0,	0,0 },
	/* 334 */ {	580,	4,	1,	0,	0,	0,1 },
	/* 335 */ {	584,	6,	0,	0,	0,	0,1 },
	/* 336 */ {	590,	3,	0,	0,	0,	0,1 },
	/* 337 */ {	593,	1,	1,	0,	0,	0,0 },
	/* 338 */ {	594,	1,	0,	0,	0,	0,0 },
	/* 339 */ {	595,	2,	0,	0,	0,	0,1 },
	/* 340 */ {	597,	2,	1,	0,	0,	0,1 },
	/* 341 */ {	599,	1,	0,	0,	0,	0,0 },
	/* 342 */ {	600,	1,	1,	0,	0,	0,0 },
	/* 343 */ {	601,	1,	0,	0,	0,	0,0 },
	/* 344 */ {	602,	3,	1,	0,	0,	0,1 },
	/* 345 */ {	605,	4,	0,	0,	0,	0,1 },
	/* 346 */ {	609,	3,	0,	0,	0,	0,1 },
	/* 347 */ {	612,	1,	1,	0,	0,	0,0 },
	/* 348 */ {	613,	1,	0,	0,	0,	0,0 },
	/* 349 */ {	614,	2,	1,	0,	0,	0,1 },
	/* 350 */ {	616,	2,	0,	0,	0,	0,1 },
	/* 351 */ {	618,	1,	1,	0,	0,	0,0 },
	/* 352 */ {	619,	4,	1,	0,	0,	0,1 },
	/* 353 */ {	623,	7,	0,	0,	0,	1,1 },
	/* 354 */ {	630,	1,	1,	0,	0,	0,0 },
	/* 355 */ {	631,	3,	1,	0,	0,	0,1 },
	/* 356 */ {	634,	3,	0,	0,	0,	0,1 },
	/* 357 */ {	637,	1,	1,	0,	0,	0,0 },
	/* 358 */ {	638,	3,	1,	0,	0,	0,1 },
	/* 359 */ {	641,	3,	1,	0,	0,	0,1 },
	/* 360 */ {	644,	3,	0,	0,	0,	0,1 },
	/* 361 */ {	647,	1,	1,	0,	0,	0,0 },
	/* 362 */ {	648,	3,	1,	0,	0,	0,1 },
	/* 363 */ {	651,	3,	0,	0,	0,	0,1 },
	/* 364 */ {	654,	1,	1,	0,	0,	0,0 },
	/* 365 */ {	655,	3,	1,	0,	0,	0,1 },
	/* 366 */ {	658,	3,	0,	0,	0,	0,1 },
	/* 367 */ {	661,	1,	1,	0,	0,	0,0 },
	/* 368 */ {	662,	3,	1,	0,	0,	0,1 },
	/* 369 */ {	665,	3,	1,	0,	0,	0,1 },
	/* 370 */ {	668,	3,	1,	0,	0,	0,1 },
	/* 371 */ {	671,	3,	0,	0,	0,	0,1 },
	/* 372 */ {	674,	1,	1,	0,	0,	0,0 },
	/* 373 */ {	675,	3,	1,	0,	0,	0,1 },
	/* 374 */ {	678,	3,	0,	0,	0,	0,1 },
	/* 375 */ {	681,	1,	1,	0,	0,	0,0 },
	/* 376 */ {	682,	3,	0,	0,	0,	0,1 },
	/* 377 */ {	685,	1,	1,	0,	0,	0,0 },
	/* 378 */ {	686,	3,	0,	0,	0,	0,1 },
	/* 379 */ {	689,	1,	1,	0,	0,	0,0 },
	/* 380 */ {	690,	3,	0,	0,	0,	0,1 },
	/* 381 */ {	693,	1,	1,	0,	0,	0,0 },
	/* 382 */ {	694,	3,	0,	0,	0,	0,1 },
	/* 383 */ {	697,	1,	1,	0,	0,	0,0 },
	/* 384 */ {	698,	3,	0,	0,	0,	0,1 },
	/* 385 */ {	701,	1,	1,	0,	0,	0,0 },
	/* 386 */ {	702,	5,	0,	0,	0,	0,1 },
	/* 387 */ {	707,	1,	1,	0,	0,	0,0 },
	/* 388 */ {	708,	3,	0,	0,	0,	0,1 },
	/* 389 */ {	711,	1,	1,	0,	0,	0,0 },
	/* 390 */ {	712,	1,	1,	0,	0,	0,0 },
	/* 391 */ {	713,	1,	1,	0,	0,	0,0 },
	/* 392 */ {	714,	1,	1,	0,	0,	0,0 },
	/* 393 */ {	715,	1,	1,	0,	0,	0,0 },
	/* 394 */ {	716,	1,	1,	0,	0,	0,0 },
	/* 395 */ {	717,	1,	1,	0,	0,	0,0 },
	/* 396 */ {	718,	1,	1,	0,	0,	0,0 },
	/* 397 */ {	719,	1,	1,	0,	0,	0,0 },
	/* 398 */ {	720,	1,	1,	0,	0,	0,0 },
	/* 399 */ {	721,	1,	1,	0,	0,	0,0 },
	/* 400 */ {	722,	1,	0,	0,	0,	0,0 },
	/* 401 */ {	723,	1,	1,	0,	0,	0,0 },
	/* 402 */ {	724,	3,	0,	0,	0,	0,1 },
	/* 403 */ {	727,	1,	1,	0,	0,	0,0 },
	/* 404 */ {	728,	1,	0,	0,	0,	0,0 },
	/* 405 */ {	729,	1,	0,	0,	0,	0,0 },
	/* 406 */ {	730,	1,	1,	0,	0,	0,0 },
	/* 407 */ {	731,	1,	0,	0,	0,	0,0 },
	/* 408 */ {	732,	1,	1,	0,	0,	0,0 },
	/* 409 */ {	733,	1,	1,	0,	0,	0,0 },
	/* 410 */ {	734,	1,	1,	0,	0,	0,0 },
	/* 411 */ {	735,	1,	1,	0,	0,	0,0 },
	/* 412 */ {	736,	1,	1,	0,	0,	0,0 },
	/* 413 */ {	737,	1,	1,	0,	0,	0,0 },
	/* 414 */ {	738,	1,	0,	0,	0,	0,0 },
	/* 415 */ {	739,	2,	0,	0,	0,	0,1 },
	/* 416 */ {	741,	0,	0,	0,	0,	0,1 },
	/* 417 */ {	741,	1,	1,	0,	0,	0,0 },
	/* 418 */ {	742,	7,	0,	0,	0,	0,1 },
	/* 419 */ {	749,	5,	1,	0,	0,	0,1 },
	/* 420 */ {	754,	7,	0,	0,	0,	0,1 },
	/* 421 */ {	761,	6,	0,	0,	0,	0,1 },
	/* 422 */ {	0,	0,	0,	0,	0,	0,1 },
	/* 423 */ {	767,	3,	1,	0,	0,	0,1 },
	/* 424 */ {	770,	4,	1,	0,	0,	0,1 },
	/* 425 */ {	774,	3,	0,	0,	0,	0,1 },
	/* 426 */ {	777,	2,	0,	0,	0,	1,0 },
	/* 427 */ {	779,	4,	0,	0,	0,	1,1 },
	/* 428 */ {	0,	0,	0,	0,	0,	0,1 },
	/* 429 */ {	783,	0,	1,	0,	0,	0,0 },
	/* 430 */ {	783,	2,	0,	0,	0,	0,1 },
	/* 431 */ {	785,	1,	1,	0,	0,	0,0 },
	/* 432 */ {	786,	4,	1,	0,	0,	0,1 },
	/* 433 */ {	790,	4,	0,	0,	0,	0,1 },
	/* 434 */ {	794,	1,	1,	0,	0,	0,0 },
	/* 435 */ {	795,	1,	0,	0,	0,	0,0 },
	/* 436 */ {	796,	6,	2,	0,	0,	0,1 },
	/* 437 */ {	0,	0,	0,	0,	0,	0,1 },
	/* 438 */ {	802,	7,	1,	0,	0,	1,1 },
	/* 439 */ {	809,	9,	0,	0,	0,	0,1 },
	/* 440 */ {	0,	0,	0,	0,	0,	0,1 },
	/* 441 */ {	818,	1,	1,	0,	0,	0,0 },
	/* 442 */ {	819,	2,	0,	0,	0,	1,1 },
	/* 443 */ {	0,	0,	0,	0,	0,	0,1 },
	/* 444 */ {	821,	2,	1,	0,	0,	1,1 },
	/* 445 */ {	823,	2,	1,	0,	0,	1,1 },
	/* 446 */ {	825,	3,	1,	0,	0,	1,1 },
	/* 447 */ {	828,	3,	0,	0,	0,	1,1 },
	/* 448 */ {	831,	1,	0,	0,	0,	0,1 },
	/* 449 */ {	832,	1,	0,	0,	0,	0,0 },
	/* 450 */ {	833,	1,	1,	0,	0,	0,0 },
	/* 451 */ {	834,	1,	0,	0,	0,	0,0 },
	/* 452 */ {	835,	1,	0,	0,	0,	0,0 },
	/* 453 */ {	836,	1,	0,	0,	0,	0,0 },
	/* 454 */ {	837,	1,	0,	0,	0,	0,0 },
	/* 455 */ {	838,	1,	0,	0,	0,	0,0 },
	/* 456 */ {	839,	1,	0,	0,	0,	0,0 },
	/* 457 */ {	840,	1,	1,	0,	0,	0,0 },
	/* 458 */ {	841,	1,	1,	0,	0,	0,0 },
	/* 459 */ {	842,	1,	1,	0,	0,	0,0 },
	/* 460 */ {	843,	1,	1,	0,	0,	0,0 },
	/* 461 */ {	844,	1,	1,	0,	0,	0,0 },
	/* 462 */ {	845,	1,	1,	0,	0,	0,0 },
	/* 463 */ {	846,	1,	1,	0,	0,	0,0 },
	/* 464 */ {	847,	1,	0,	0,	0,	0,0 },
	/* 465 */ {	848,	1,	1,	0,	0,	0,0 },
	/* 466 */ {	849,	1,	0,	0,	0,	0,0 },
	/* 467 */ {	850,	0,	0,	0,	0,	0,1 },
	/* 468 */ {	850,	1,	1,	0,	0,	0,0 },
	/* 469 */ {	851,	1,	0,	0,	0,	0,1 },
	/* 470 */ {	852,	1,	1,	0,	0,	0,0 },
	/* 471 */ {	853,	1,	0,	0,	0,	0,1 },
	/* 472 */ {	854,	0,	1,	0,	0,	0,0 },
	/* 473 */ {	854,	1,	0,	0,	0,	0,0 },
	/* 474 */ {	855,	4,	0,	0,	0,	1,1 },
	/* 475 */ {	0,	0,	0,	0,	0,	0,1 },
	/* 476 */ {	859,	2,	1,	0,	0,	0,1 },
	/* 477 */ {	861,	2,	0,	0,	0,	0,1 },
	/* 478 */ {	863,	0,	1,	0,	0,	0,1 },
	/* 479 */ {	863,	1,	0,	0,	0,	0,0 },
	/* 480 */ {	864,	3,	1,	0,	0,	1,1 },
	/* 481 */ {	867,	3,	1,	0,	0,	0,1 },
	/* 482 */ {	870,	3,	0,	0,	0,	0,1 },
	/* 483 */ {	873,	1,	1,	0,	0,	0,0 },
	/* 484 */ {	874,	1,	1,	0,	0,	0,0 },
	/* 485 */ {	875,	1,	1,	0,	0,	0,0 },
	/* 486 */ {	876,	1,	1,	0,	0,	0,0 },
	/* 487 */ {	877,	1,	1,	0,	0,	0,0 },
	/* 488 */ {	878,	1,	1,	0,	0,	0,0 },
	/* 489 */ {	879,	1,	1,	0,	0,	0,0 },
	/* 490 */ {	880,	1,	1,	0,	0,	0,0 },
	/* 491 */ {	881,	1,	1,	0,	0,	0,0 },
	/* 492 */ {	882,	1,	1,	0,	0,	0,0 },
	/* 493 */ {	883,	1,	1,	0,	0,	0,0 },
	/* 494 */ {	884,	1,	1,	0,	0,	0,0 },
	/* 495 */ {	885,	1,	1,	0,	0,	0,0 },
	/* 496 */ {	886,	1,	1,	0,	0,	0,0 },
	/* 497 */ {	887,	1,	1,	0,	0,	0,0 },
	/* 498 */ {	888,	1,	1,	0,	0,	0,0 },
	/* 499 */ {	889,	1,	1,	0,	0,	0,0 },
	/* 500 */ {	890,	1,	1,	0,	0,	0,0 },
	/* 501 */ {	891,	1,	1,	0,	0,	0,0 },
	/* 502 */ {	892,	1,	1,	0,	0,	0,0 },
	/* 503 */ {	893,	1,	1,	0,	0,	0,0 },
	/* 504 */ {	894,	1,	1,	0,	0,	0,0 },
	/* 505 */ {	895,	1,	1,	0,	0,	0,0 },
	/* 506 */ {	896,	1,	1,	0,	0,	0,0 },
	/* 507 */ {	897,	1,	1,	0,	0,	0,0 },
	/* 508 */ {	898,	1,	1,	0,	0,	0,0 },
	/* 509 */ {	899,	1,	1,	0,	0,	0,0 },
	/* 510 */ {	900,	1,	1,	0,	0,	0,0 },
	/* 511 */ {	901,	1,	1,	0,	0,	0,0 },
	/* 512 */ {	902,	1,	1,	0,	0,	0,0 },
	/* 513 */ {	903,	1,	1,	0,	0,	0,0 },
	/* 514 */ {	904,	1,	1,	0,	0,	0,0 },
	/* 515 */ {	905,	1,	1,	0,	0,	0,0 },
	/* 516 */ {	906,	1,	1,	0,	0,	0,0 },
	/* 517 */ {	907,	1,	1,	0,	0,	0,0 },
	/* 518 */ {	908,	1,	1,	0,	0,	0,0 },
	/* 519 */ {	909,	1,	1,	0,	0,	0,0 },
	/* 520 */ {	910,	1,	1,	0,	0,	0,0 },
	/* 521 */ {	911,	1,	1,	0,	0,	0,0 },
	/* 522 */ {	912,	1,	1,	0,	0,	0,0 },
	/* 523 */ {	913,	1,	1,	0,	0,	0,0 },
	/* 524 */ {	914,	1,	1,	0,	0,	0,0 },
	/* 525 */ {	915,	1,	1,	0,	0,	0,0 },
	/* 526 */ {	916,	1,	1,	0,	0,	0,0 },
	/* 527 */ {	917,	1,	1,	0,	0,	0,0 },
	/* 528 */ {	918,	1,	1,	0,	0,	0,0 },
	/* 529 */ {	919,	1,	1,	0,	0,	0,0 },
	/* 530 */ {	920,	1,	1,	0,	0,	0,0 },
	/* 531 */ {	921,	1,	1,	0,	0,	0,1 },
	/* 532 */ {	922,	1,	0,	0,	0,	0,0 },
	/* 533 */ {	923,	6,	0,	0,	0,	0,1 },
	/* 534 */ {	929,	1,	1,	0,	0,	0,0 },
	/* 535 */ {	930,	1,	0,	0,	0,	0,0 },
#line 183 "/u4/shaggy/u2/src/sos/util/shacc/shacc.c.parser"
};

static YYTTYPE yysym[] = {
	/* 0 */ 	-1,	0,	-2,	451,	-3,	-2,
	/* 6 */ 	-5,	-6,	-7,	-4,	-8,	-7,
	/* 12 */ 	-9,	293,	-10,	-11,	-12,	-12,
	/* 18 */ 	293,	452,	-13,	-14,	-15,	-16,
	/* 24 */ 	-17,	-18,	422,	419,	426,	427,
	/* 30 */ 	429,	-19,	-20,	-21,	-22,	-23,
	/* 36 */ 	-24,	-9,	293,	-24,	293,	-26,
	/* 42 */ 	-27,	-28,	395,	380,	-25,	-29,
	/* 48 */ 	-25,	-29,	-30,	-29,	-30,	-30,
	/* 54 */ 	-29,	-29,	-30,	-29,	-7,	-24,
	/* 60 */ 	352,	355,	353,	354,	397,	410,
	/* 66 */ 	396,	398,	-32,	-33,	-34,	-35,
	/* 72 */ 	-36,	361,	402,	399,	357,	360,
	/* 78 */ 	356,	358,	359,	362,	363,	364,
	/* 84 */ 	-37,	-38,	-39,	-40,	-18,	377,
	/* 90 */ 	-18,	377,	-41,	-42,	-43,	-44,
	/* 96 */ 	-45,	299,	-47,	-46,	295,	-47,
	/* 102 */ 	-7,	-46,	-18,	-18,	331,	-48,
	/* 108 */ 	-49,	-50,	-51,	-52,	389,	-18,
	/* 114 */ 	-42,	-53,	-54,	299,	389,	-55,
	/* 120 */ 	-42,	-56,	-54,	299,	389,	-42,
	/* 126 */ 	-57,	-54,	299,	-2,	389,	-18,
	/* 132 */ 	331,	-58,	293,	390,	388,	-59,
	/* 138 */ 	293,	390,	-59,	293,	390,	429,
	/* 144 */ 	-59,	293,	390,	389,	-58,	293,
	/* 150 */ 	411,	302,	261,	303,	293,	354,
	/* 156 */ 	261,	-42,	-2,	299,	354,	261,
	/* 162 */ 	-6,	-60,	-62,	295,	-60,	-61,
	/* 168 */ 	-62,	295,	-60,	-60,	-62,	-61,
	/* 174 */ 	-62,	-7,	-9,	-64,	-65,	-64,
	/* 180 */ 	-65,	-66,	-67,	-64,	-65,	-68,
	/* 186 */ 	348,	-69,	-70,	-71,	-64,	-72,
	/* 192 */ 	-70,	302,	-73,	303,	-74,	-70,
	/* 198 */ 	300,	-48,	301,	-70,	300,	301,
	/* 204 */ 	302,	-64,	303,	422,	-75,	302,
	/* 210 */ 	-73,	303,	-74,	-76,	-64,	310,
	/* 216 */ 	-74,	314,	429,	310,	-74,	-36,
	/* 222 */ 	-74,	-7,	-78,	350,	351,	-79,
	/* 228 */ 	-81,	-82,	-27,	-83,	-27,	-74,
	/* 234 */ 	-30,	-74,	-83,	-71,	-82,	-85,
	/* 240 */ 	-7,	-84,	302,	-73,	303,	-74,
	/* 246 */ 	-85,	302,	-73,	303,	-74,	302,
	/* 252 */ 	-84,	303,	-86,	-86,	-45,	345,
	/* 258 */ 	345,	-87,	-86,	295,	-87,	-24,
	/* 264 */ 	-64,	331,	-69,	-24,	-64,	-24,
	/* 270 */ 	-82,	331,	-69,	-24,	-82,	-77,
	/* 276 */ 	-31,	-60,	-77,	-89,	-16,	-17,
	/* 282 */ 	-90,	-3,	-91,	331,	-92,	302,
	/* 288 */ 	-93,	303,	-69,	-42,	-94,	-45,
	/* 294 */ 	299,	295,	-96,	295,	-7,	-95,
	/* 300 */ 	-92,	-95,	300,	-48,	301,	-92,
	/* 306 */ 	-95,	342,	-79,	-92,	-96,	-40,
	/* 312 */ 	-41,	-97,	-42,	-98,	-99,	299,
	/* 318 */ 	385,	379,	378,	417,	385,	417,
	/* 324 */ 	396,	385,	443,	444,	-101,	-99,
	/* 330 */ 	-102,	-103,	-104,	-99,	-37,	-103,
	/* 336 */ 	-105,	-99,	417,	-37,	-103,	-106,
	/* 342 */ 	-99,	-7,	-100,	293,	-40,	-18,
	/* 348 */ 	293,	-24,	-107,	293,	-24,	293,
	/* 354 */ 	-107,	293,	-10,	-22,	-108,	-65,
	/* 360 */ 	-107,	295,	-108,	-65,	-77,	-64,
	/* 366 */ 	331,	-48,	-103,	-48,	-18,	-103,
	/* 372 */ 	-48,	-7,	-103,	-109,	-110,	-109,
	/* 378 */ 	295,	-110,	-37,	396,	-37,	396,
	/* 384 */ 	-102,	-37,	-102,	-37,	-102,	396,
	/* 390 */ 	-37,	393,	394,	392,	384,	-112,
	/* 396 */ 	429,	384,	-112,	-81,	-113,	-71,
	/* 402 */ 	-113,	-7,	-114,	450,	-116,	-117,
	/* 408 */ 	294,	-118,	-119,	-7,	-115,	-120,
	/* 414 */ 	-117,	295,	-120,	-121,	-119,	295,
	/* 420 */ 	-121,	-18,	302,	-122,	303,	-18,
	/* 426 */ 	302,	-123,	303,	384,	-125,	429,
	/* 432 */ 	384,	-125,	413,	414,	415,	416,
	/* 438 */ 	308,	309,	310,	311,	312,	316,
	/* 444 */ 	314,	315,	313,	317,	331,	321,
	/* 450 */ 	322,	332,	333,	334,	335,	336,
	/* 456 */ 	339,	337,	338,	329,	330,	341,
	/* 462 */ 	340,	325,	326,	323,	324,	318,
	/* 468 */ 	319,	327,	328,	295,	347,	343,
	/* 474 */ 	-126,	302,	303,	300,	301,	258,
	/* 480 */ 	259,	261,	260,	263,	-127,	386,
	/* 486 */ 	302,	-129,	303,	-130,	-59,	-131,
	/* 492 */ 	-18,	-124,	-111,	423,	418,	257,
	/* 498 */ 	-124,	-111,	423,	-128,	-132,	300,
	/* 504 */ 	-129,	301,	-132,	302,	-123,	303,
	/* 510 */ 	-32,	302,	-123,	303,	-30,	302,
	/* 516 */ 	-123,	303,	-132,	342,	-79,	-132,
	/* 522 */ 	343,	-79,	-132,	342,	-133,	-132,
	/* 528 */ 	343,	-133,	-132,	327,	-132,	328,
	/* 534 */ 	-134,	321,	-80,	322,	302,	-129,
	/* 540 */ 	303,	387,	302,	-129,	303,	387,
	/* 546 */ 	302,	-80,	303,	407,	406,	409,
	/* 552 */ 	408,	-69,	-93,	295,	-69,	-93,
	/* 558 */ 	423,	-132,	327,	-136,	328,	-136,
	/* 564 */ 	-137,	-136,	381,	-135,	381,	302,
	/* 570 */ 	-80,	303,	-138,	-139,	310,	314,
	/* 576 */ 	308,	309,	317,	313,	413,	-140,
	/* 582 */ 	-141,	-142,	413,	-140,	302,	-80,
	/* 588 */ 	303,	-142,	302,	-93,	303,	-7,
	/* 594 */ 	-143,	-81,	-144,	-71,	-144,	-146,
	/* 600 */ 	-7,	-145,	300,	-129,	301,	-146,
	/* 606 */ 	300,	-48,	301,	302,	-123,	303,
	/* 612 */ 	-7,	-147,	414,	-136,	416,	-136,
	/* 618 */ 	-135,	302,	-80,	303,	-136,	302,
	/* 624 */ 	-80,	303,	-42,	-94,	-45,	299,
	/* 630 */ 	-136,	-148,	346,	-136,	-148,	347,
	/* 636 */ 	-136,	-148,	-149,	310,	-148,	-149,
	/* 642 */ 	311,	-148,	-149,	312,	-148,	-149,
	/* 648 */ 	-150,	308,	-149,	-150,	309,	-149,
	/* 654 */ 	-150,	-151,	329,	-150,	-151,	330,
	/* 660 */ 	-150,	-151,	-152,	321,	-151,	-152,
	/* 666 */ 	322,	-151,	-152,	323,	-151,	-152,
	/* 672 */ 	324,	-151,	-152,	-153,	325,	-152,
	/* 678 */ 	-153,	326,	-152,	-153,	-154,	314,
	/* 684 */ 	-153,	-154,	-155,	316,	-154,	-155,
	/* 690 */ 	-156,	315,	-155,	-156,	-157,	318,
	/* 696 */ 	-156,	-157,	-158,	319,	-157,	-158,
	/* 702 */ 	-158,	296,	-129,	-103,	-69,	-159,
	/* 708 */ 	-158,	-160,	-69,	331,	334,	335,
	/* 714 */ 	336,	332,	333,	341,	340,	337,
	/* 720 */ 	339,	338,	348,	-69,	-129,	295,
	/* 726 */ 	-69,	-7,	-129,	-159,	-163,	-164,
	/* 732 */ 	-166,	-167,	-3,	-168,	-169,	-170,
	/* 738 */ 	-171,	365,	302,	-165,	-172,	-174,
	/* 744 */ 	303,	-163,	-173,	366,	-163,	-172,
	/* 750 */ 	-174,	303,	-162,	-173,	-172,	-174,
	/* 756 */ 	303,	-163,	-173,	366,	-164,	370,
	/* 762 */ 	302,	-175,	-174,	303,	-162,	-18,
	/* 768 */ 	-103,	-162,	371,	-48,	-103,	-162,
	/* 774 */ 	372,	-103,	-162,	-161,	293,	298,
	/* 780 */ 	-176,	-177,	299,	-177,	-162,	-129,
	/* 786 */ 	-81,	-64,	331,	-69,	-81,	-64,
	/* 792 */ 	348,	-69,	-7,	-174,	368,	302,
	/* 798 */ 	-179,	-174,	303,	-162,	367,	-162,
	/* 804 */ 	368,	302,	-129,	303,	293,	369,
	/* 810 */ 	302,	-180,	-181,	-178,	293,	-161,
	/* 816 */ 	303,	-162,	-167,	-182,	-19,	373,
	/* 822 */ 	293,	374,	293,	376,	-161,	293,
	/* 828 */ 	375,	-18,	293,	-8,	421,	-55,
	/* 834 */ 	-183,	426,	427,	419,	420,	428,
	/* 840 */ 	257,	418,	421,	420,	419,	426,
	/* 846 */ 	427,	428,	-7,	-18,	298,	449,
	/* 852 */ 	294,	450,	430,	-186,	449,	-122,
	/* 858 */ 	299,	-122,	-188,	-122,	-189,	-187,
	/* 864 */ 	-42,	-122,	299,	302,	-122,	303,
	/* 870 */ 	300,	-122,	301,	258,	259,	261,
	/* 876 */ 	260,	263,	293,	-103,	296,	-126,
	/* 882 */ 	342,	346,	344,	345,	-36,	-32,
	/* 888 */ 	-26,	365,	366,	367,	368,	369,
	/* 894 */ 	370,	371,	372,	373,	374,	375,
	/* 900 */ 	376,	377,	380,	-40,	-28,	381,
	/* 906 */ 	412,	411,	384,	386,	387,	388,
	/* 912 */ 	389,	390,	391,	-102,	395,	403,
	/* 918 */ 	404,	405,	-134,	-18,	423,	349,
	/* 924 */ 	302,	302,	-187,	303,	303,	-7,
	/* 930 */ 	-190,
#line 187 "/u4/shaggy/u2/src/sos/util/shacc/shacc.c.parser"
};

static YYRTYPE yynt[] = {
	/* 0 */ 	0,	1,	5,	427,	3,	4,
	/* 6 */ 	7,	467,	21,	101,	153,	96,
	/* 12 */ 	79,	17,	15,	14,	224,	155,
	/* 18 */ 	457,	26,	95,	90,	91,	94,
	/* 24 */ 	35,	28,	42,	50,	47,	33,
	/* 30 */ 	66,	40,	55,	171,	71,	69,
	/* 36 */ 	127,	454,	455,	449,	173,	465,
	/* 42 */ 	468,	72,	75,	162,	73,	77,
	/* 48 */ 	405,	81,	87,	83,	85,	84,
	/* 54 */ 	89,	452,	86,	88,	450,	288,
	/* 60 */ 	98,	99,	105,	103,	110,	534,
	/* 66 */ 	107,	158,	109,	387,	112,	121,
	/* 72 */ 	129,	142,	125,	117,	118,	119,
	/* 78 */ 	124,	286,	130,	133,	137,	131,
	/* 84 */ 	135,	139,	146,	148,	152,	154,
	/* 90 */ 	156,	474,	160,	315,	169,	164,
	/* 96 */ 	166,	202,	172,	187,	180,	189,
	/* 102 */ 	211,	470,	182,	184,	186,	196,
	/* 108 */ 	198,	204,	206,	214,	216,	218,
	/* 114 */ 	217,	220,	221,	226,	223,	228,
	/* 120 */ 	230,	231,	478,	317,	232,	274,
	/* 126 */ 	234,	277,	282,	401,	287,	292,
	/* 132 */ 	297,	319,	311,	320,	351,	328,
	/* 138 */ 	334,	349,	337,	339,	347,	336,
	/* 144 */ 	342,	340,	344,	346,	354,	357,
	/* 150 */ 	361,	364,	367,	372,	375,	377,
	/* 156 */ 	379,	381,	383,	385,	389,	403,
	/* 162 */ 	406,	417,	419,	408,	423,	426,
	/* 168 */ 	421,	436,	444,	448,	415,	416,
	/* 174 */ 	431,	422,	428,	429,	434,	437,
	/* 180 */ 	440,	441,	443,	453,	456,	472,
	/* 186 */ 	475,	476,	483,	480,	533,
#line 191 "/u4/shaggy/u2/src/sos/util/shacc/shacc.c.parser"
};

#ifdef ndef
static yyu8 yytp[] = {
	/* 0 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 10 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 20 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 30 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 40 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 50 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 60 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 70 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 80 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 90 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 100 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 110 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 120 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 130 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 140 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 150 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 160 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 170 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 180 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 190 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 200 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 210 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 220 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 230 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 240 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 250 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 260 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 270 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 280 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 290 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 300 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 310 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 320 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 330 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 340 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 350 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 360 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 370 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 380 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 390 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 400 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 410 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 420 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 430 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 440 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/* 450 */   0,  0,  0,
#line 196 "/u4/shaggy/u2/src/sos/util/shacc/shacc.c.parser"
};
#endif

#if YYDEBUG
static const char * yysname[] = {
	/* -190 (1) */	"attribute",
	/* -189 (1) */	"save_statement_list",
	/* -188 (1) */	"any_statement_token",
	/* -187 (2) */	"save_statement_seq",
	/* -186 (1) */	"<475>",
	/* -185 (0) */	"ignore_savecode",
	/* -184 (0) */	"template_name",
	/* -183 (1) */	"namespace_alias",
	/* -182 (1) */	"<443>",
	/* -181 (1) */	"for_init_statement",
	/* -180 (1) */	"<440>",
	/* -179 (1) */	"<437>",
	/* -178 (1) */	"condition_opt",
	/* -177 (2) */	"statement_seq_opt",
	/* -176 (1) */	"<428>",
	/* -175 (1) */	"<422>",
	/* -174 (6) */	"condition",
	/* -173 (3) */	"restsc",
	/* -172 (3) */	"ifsavescope",
	/* -171 (1) */	"declaration_statement",
	/* -170 (1) */	"jump_statement",
	/* -169 (1) */	"iteration_statement",
	/* -168 (1) */	"selection_statement",
	/* -167 (2) */	"expression_statement",
	/* -166 (1) */	"labeled_statement",
	/* -165 (1) */	"other_statement",
	/* -164 (2) */	"unmatched_statement",
	/* -163 (4) */	"matched_statement",
	/* -162 (9) */	"statement",
	/* -161 (3) */	"expression_opt",
	/* -160 (1) */	"assignment_operator",
	/* -159 (2) */	"conditional_expression",
	/* -158 (4) */	"logical_or_expression",
	/* -157 (3) */	"logical_and_expression",
	/* -156 (3) */	"inclusive_or_expression",
	/* -155 (3) */	"exclusive_or_expression",
	/* -154 (3) */	"and_expression",
	/* -153 (4) */	"equality_expression",
	/* -152 (7) */	"relational_expression",
	/* -151 (7) */	"shift_expression",
	/* -150 (5) */	"additive_expression",
	/* -149 (6) */	"multiplicative_expression",
	/* -148 (6) */	"pm_expression",
	/* -147 (1) */	"new_initializer",
	/* -146 (2) */	"direct_new_declarator",
	/* -145 (1) */	"new_declarator",
	/* -144 (2) */	"new_declarator_opt",
	/* -143 (1) */	"new_placement",
	/* -142 (2) */	"new_initializer_opt",
	/* -141 (1) */	"new_type_id",
	/* -140 (2) */	"new_placement_opt",
	/* -139 (1) */	"delete_expression",
	/* -138 (1) */	"new_expression",
	/* -137 (1) */	"unary_operator",
	/* -136 (9) */	"cast_expression",
	/* -135 (2) */	"unary_expression",
	/* -134 (2) */	"newcast",
	/* -133 (2) */	"pseudo_destructor_name",
	/* -132 (9) */	"postfix_expression",
	/* -131 (1) */	"unqualified_id_val",
	/* -130 (1) */	"id_expression_val",
	/* -129 (10) */	"expression",
	/* -128 (1) */	"primary_expression",
	/* -127 (1) */	"literal",
	/* -126 (2) */	"simple_operator",
	/* -125 (2) */	"operator",
	/* -124 (2) */	"operator_function_id",
	/* -123 (5) */	"expression_list_opt",
	/* -122 (7) */	"save_statement_seq_opt",
	/* -121 (2) */	"mem_initializer",
	/* -120 (2) */	"save_mem_initializer",
	/* -119 (2) */	"mem_initializer_list",
	/* -118 (1) */	"<223>",
	/* -117 (2) */	"save_mem_initializer_list",
	/* -116 (1) */	"<221>",
	/* -115 (1) */	"ctor_initializer",
	/* -114 (1) */	"conversion_declarator",
	/* -113 (2) */	"conversion_declarator_opt",
	/* -112 (2) */	"conversion_type_id",
	/* -111 (2) */	"conversion_function_id",
	/* -110 (2) */	"base_specifier",
	/* -109 (2) */	"base_specifier_list",
	/* -108 (2) */	"member_declarator",
	/* -107 (3) */	"member_declarator_list",
	/* -106 (1) */	"<186>",
	/* -105 (1) */	"<184>",
	/* -104 (1) */	"<182>",
	/* -103 (11) */	"colon",
	/* -102 (5) */	"access_specifier",
	/* -101 (1) */	"member_declaration",
	/* -100 (1) */	"member_specification",
	/* -99 (5) */	"member_specification_opt",
	/* -98 (1) */	"<172>",
	/* -97 (1) */	"base_clause_opt",
	/* -96 (2) */	"initializer_list",
	/* -95 (3) */	"prev_initializer_list",
	/* -94 (2) */	"initializer_list_opt",
	/* -93 (4) */	"expression_list",
	/* -92 (4) */	"initializer_clause",
	/* -91 (1) */	"save_compound_statement",
	/* -90 (1) */	"<156>",
	/* -89 (1) */	"<154>",
	/* -88 (0) */	"eval_declarator_or_ctor",
	/* -87 (2) */	"parameter_declaration",
	/* -86 (3) */	"parameter_declaration_list",
	/* -85 (2) */	"direct_abstract_declarator",
	/* -84 (2) */	"abstract_declarator",
	/* -83 (2) */	"type_specifier_notypename_seq",
	/* -82 (4) */	"abstract_declarator_opt",
	/* -81 (5) */	"type_specifier_seq",
	/* -80 (6) */	"type_id",
	/* -79 (4) */	"id_expression",
	/* -78 (1) */	"cv_qualifier_seq",
	/* -77 (2) */	"declarator_or_ctor",
	/* -76 (1) */	"ctor_declarator",
	/* -75 (1) */	"ctor_declarator_id",
	/* -74 (9) */	"cv_qualifier_seq_opt",
	/* -73 (4) */	"parameter_declaration_clause",
	/* -72 (1) */	"declarator_id",
	/* -71 (4) */	"ptr_operator",
	/* -70 (4) */	"direct_declarator",
	/* -69 (12) */	"assignment_expression",
	/* -68 (1) */	"<109>",
	/* -67 (1) */	"initializer",
	/* -66 (1) */	"<107>",
	/* -65 (5) */	"attribute_opt",
	/* -64 (11) */	"declarator",
	/* -63 (0) */	"init_declarator_list_opt",
	/* -62 (4) */	"init_declarator",
	/* -61 (2) */	"init_declarator_list1",
	/* -60 (5) */	"save_scope",
	/* -59 (4) */	"unqualified_id",
	/* -58 (2) */	"namespace_name",
	/* -57 (1) */	"<88>",
	/* -56 (1) */	"<86>",
	/* -55 (2) */	"original_namespace_name",
	/* -54 (3) */	"namespace_body",
	/* -53 (1) */	"<84>",
	/* -52 (1) */	"extension_namespace_definition",
	/* -51 (1) */	"original_namespace_definition",
	/* -50 (1) */	"unnamed_namespace_definition",
	/* -49 (1) */	"named_namespace_definition",
	/* -48 (8) */	"constant_expression",
	/* -47 (2) */	"enumerator_definition",
	/* -46 (2) */	"enumerator_list",
	/* -45 (4) */	"comma_opt",
	/* -44 (1) */	"enumerator_list_opt",
	/* -43 (1) */	"<72>",
	/* -42 (9) */	"lbrace",
	/* -41 (2) */	"identifier_opt",
	/* -40 (4) */	"class_key",
	/* -39 (1) */	"typedef_name",
	/* -38 (1) */	"enum_name",
	/* -37 (8) */	"class_name",
	/* -36 (3) */	"cv_qualifier",
	/* -35 (1) */	"elaborated_type_specifier",
	/* -34 (1) */	"enum_specifier",
	/* -33 (1) */	"class_specifier",
	/* -32 (3) */	"simple_type_specifier_notypename",
	/* -31 (1) */	"decl_specifier_seq_opt",
	/* -30 (6) */	"type_name",
	/* -29 (6) */	"decl_specifier_notypename_seq",
	/* -28 (2) */	"function_specifier",
	/* -27 (3) */	"type_specifier_notypename",
	/* -26 (2) */	"storage_class_specifier",
	/* -25 (2) */	"decl_specifier_notypename",
	/* -24 (9) */	"decl_specifier_seq",
	/* -23 (1) */	"using_directive",
	/* -22 (2) */	"using_declaration",
	/* -21 (1) */	"namespace_alias_definition",
	/* -20 (1) */	"asm_directive",
	/* -19 (2) */	"simple_declaration",
	/* -18 (16) */	"identifier",
	/* -17 (2) */	"function_body",
	/* -16 (2) */	"ctor_initializer_opt",
	/* -15 (1) */	"<14>",
	/* -14 (1) */	"id_or_ctor",
	/* -13 (1) */	"anyscope",
	/* -12 (2) */	"namespace_definition",
	/* -11 (1) */	"linkage_specification",
	/* -10 (2) */	"function_definition",
	/* -9 (2) */	"init_declarator_list",
	/* -8 (2) */	"block_declaration",
	/* -7 (18) */	"none",
	/* -6 (2) */	"declaration",
	/* -5 (1) */	"<4>",
	/* -4 (1) */	"declaration_seq",
	/* -3 (3) */	"compound_statement",
	/* -2 (4) */	"declaration_seq_opt",
	/* -1 (1) */	"translation_unit",
	/* 0 (0) */	"$",
	/* 1 (0) */	"error",
	/* 2 (0) */	"?",
	/* 3 (0) */	"",
	/* 4 (0) */	"",
	/* 5 (0) */	"",
	/* 6 (0) */	"",
	/* 7 (0) */	"",
	/* 8 (0) */	"",
	/* 9 (0) */	"",
	/* 10 (0) */	"",
	/* 11 (0) */	"",
	/* 12 (0) */	"",
	/* 13 (0) */	"",
	/* 14 (0) */	"",
	/* 15 (0) */	"",
	/* 16 (0) */	"",
	/* 17 (0) */	"",
	/* 18 (0) */	"",
	/* 19 (0) */	"",
	/* 20 (0) */	"",
	/* 21 (0) */	"",
	/* 22 (0) */	"",
	/* 23 (0) */	"",
	/* 24 (0) */	"",
	/* 25 (0) */	"",
	/* 26 (0) */	"",
	/* 27 (0) */	"",
	/* 28 (0) */	"",
	/* 29 (0) */	"",
	/* 30 (0) */	"",
	/* 31 (0) */	"",
	/* 32 (0) */	"",
	/* 33 (0) */	"",
	/* 34 (0) */	"",
	/* 35 (0) */	"",
	/* 36 (0) */	"",
	/* 37 (0) */	"",
	/* 38 (0) */	"",
	/* 39 (0) */	"",
	/* 40 (0) */	"",
	/* 41 (0) */	"",
	/* 42 (0) */	"",
	/* 43 (0) */	"",
	/* 44 (0) */	"",
	/* 45 (0) */	"",
	/* 46 (0) */	"",
	/* 47 (0) */	"",
	/* 48 (0) */	"",
	/* 49 (0) */	"",
	/* 50 (0) */	"",
	/* 51 (0) */	"",
	/* 52 (0) */	"",
	/* 53 (0) */	"",
	/* 54 (0) */	"",
	/* 55 (0) */	"",
	/* 56 (0) */	"",
	/* 57 (0) */	"",
	/* 58 (0) */	"",
	/* 59 (0) */	"",
	/* 60 (0) */	"",
	/* 61 (0) */	"",
	/* 62 (0) */	"",
	/* 63 (0) */	"",
	/* 64 (0) */	"",
	/* 65 (0) */	"",
	/* 66 (0) */	"",
	/* 67 (0) */	"",
	/* 68 (0) */	"",
	/* 69 (0) */	"",
	/* 70 (0) */	"",
	/* 71 (0) */	"",
	/* 72 (0) */	"",
	/* 73 (0) */	"",
	/* 74 (0) */	"",
	/* 75 (0) */	"",
	/* 76 (0) */	"",
	/* 77 (0) */	"",
	/* 78 (0) */	"",
	/* 79 (0) */	"",
	/* 80 (0) */	"",
	/* 81 (0) */	"",
	/* 82 (0) */	"",
	/* 83 (0) */	"",
	/* 84 (0) */	"",
	/* 85 (0) */	"",
	/* 86 (0) */	"",
	/* 87 (0) */	"",
	/* 88 (0) */	"",
	/* 89 (0) */	"",
	/* 90 (0) */	"",
	/* 91 (0) */	"",
	/* 92 (0) */	"",
	/* 93 (0) */	"",
	/* 94 (0) */	"",
	/* 95 (0) */	"",
	/* 96 (0) */	"",
	/* 97 (0) */	"",
	/* 98 (0) */	"",
	/* 99 (0) */	"",
	/* 100 (0) */	"",
	/* 101 (0) */	"",
	/* 102 (0) */	"",
	/* 103 (0) */	"",
	/* 104 (0) */	"",
	/* 105 (0) */	"",
	/* 106 (0) */	"",
	/* 107 (0) */	"",
	/* 108 (0) */	"",
	/* 109 (0) */	"",
	/* 110 (0) */	"",
	/* 111 (0) */	"",
	/* 112 (0) */	"",
	/* 113 (0) */	"",
	/* 114 (0) */	"",
	/* 115 (0) */	"",
	/* 116 (0) */	"",
	/* 117 (0) */	"",
	/* 118 (0) */	"",
	/* 119 (0) */	"",
	/* 120 (0) */	"",
	/* 121 (0) */	"",
	/* 122 (0) */	"",
	/* 123 (0) */	"",
	/* 124 (0) */	"",
	/* 125 (0) */	"",
	/* 126 (0) */	"",
	/* 127 (0) */	"",
	/* 128 (0) */	"",
	/* 129 (0) */	"",
	/* 130 (0) */	"",
	/* 131 (0) */	"",
	/* 132 (0) */	"",
	/* 133 (0) */	"",
	/* 134 (0) */	"",
	/* 135 (0) */	"",
	/* 136 (0) */	"",
	/* 137 (0) */	"",
	/* 138 (0) */	"",
	/* 139 (0) */	"",
	/* 140 (0) */	"",
	/* 141 (0) */	"",
	/* 142 (0) */	"",
	/* 143 (0) */	"",
	/* 144 (0) */	"",
	/* 145 (0) */	"",
	/* 146 (0) */	"",
	/* 147 (0) */	"",
	/* 148 (0) */	"",
	/* 149 (0) */	"",
	/* 150 (0) */	"",
	/* 151 (0) */	"",
	/* 152 (0) */	"",
	/* 153 (0) */	"",
	/* 154 (0) */	"",
	/* 155 (0) */	"",
	/* 156 (0) */	"",
	/* 157 (0) */	"",
	/* 158 (0) */	"",
	/* 159 (0) */	"",
	/* 160 (0) */	"",
	/* 161 (0) */	"",
	/* 162 (0) */	"",
	/* 163 (0) */	"",
	/* 164 (0) */	"",
	/* 165 (0) */	"",
	/* 166 (0) */	"",
	/* 167 (0) */	"",
	/* 168 (0) */	"",
	/* 169 (0) */	"",
	/* 170 (0) */	"",
	/* 171 (0) */	"",
	/* 172 (0) */	"",
	/* 173 (0) */	"",
	/* 174 (0) */	"",
	/* 175 (0) */	"",
	/* 176 (0) */	"",
	/* 177 (0) */	"",
	/* 178 (0) */	"",
	/* 179 (0) */	"",
	/* 180 (0) */	"",
	/* 181 (0) */	"",
	/* 182 (0) */	"",
	/* 183 (0) */	"",
	/* 184 (0) */	"",
	/* 185 (0) */	"",
	/* 186 (0) */	"",
	/* 187 (0) */	"",
	/* 188 (0) */	"",
	/* 189 (0) */	"",
	/* 190 (0) */	"",
	/* 191 (0) */	"",
	/* 192 (0) */	"",
	/* 193 (0) */	"",
	/* 194 (0) */	"",
	/* 195 (0) */	"",
	/* 196 (0) */	"",
	/* 197 (0) */	"",
	/* 198 (0) */	"",
	/* 199 (0) */	"",
	/* 200 (0) */	"",
	/* 201 (0) */	"",
	/* 202 (0) */	"",
	/* 203 (0) */	"",
	/* 204 (0) */	"",
	/* 205 (0) */	"",
	/* 206 (0) */	"",
	/* 207 (0) */	"",
	/* 208 (0) */	"",
	/* 209 (0) */	"",
	/* 210 (0) */	"",
	/* 211 (0) */	"",
	/* 212 (0) */	"",
	/* 213 (0) */	"",
	/* 214 (0) */	"",
	/* 215 (0) */	"",
	/* 216 (0) */	"",
	/* 217 (0) */	"",
	/* 218 (0) */	"",
	/* 219 (0) */	"",
	/* 220 (0) */	"",
	/* 221 (0) */	"",
	/* 222 (0) */	"",
	/* 223 (0) */	"",
	/* 224 (0) */	"",
	/* 225 (0) */	"",
	/* 226 (0) */	"",
	/* 227 (0) */	"",
	/* 228 (0) */	"",
	/* 229 (0) */	"",
	/* 230 (0) */	"",
	/* 231 (0) */	"",
	/* 232 (0) */	"",
	/* 233 (0) */	"",
	/* 234 (0) */	"",
	/* 235 (0) */	"",
	/* 236 (0) */	"",
	/* 237 (0) */	"",
	/* 238 (0) */	"",
	/* 239 (0) */	"",
	/* 240 (0) */	"",
	/* 241 (0) */	"",
	/* 242 (0) */	"",
	/* 243 (0) */	"",
	/* 244 (0) */	"",
	/* 245 (0) */	"",
	/* 246 (0) */	"",
	/* 247 (0) */	"",
	/* 248 (0) */	"",
	/* 249 (0) */	"",
	/* 250 (0) */	"",
	/* 251 (0) */	"",
	/* 252 (0) */	"",
	/* 253 (0) */	"",
	/* 254 (0) */	"",
	/* 255 (0) */	"",
	/* 256 (0) */	"",
	/* 257 (2) */	"ID",
	/* 258 (2) */	"NUM",
	/* 259 (2) */	"CHAR",
	/* 260 (2) */	"FLOAT",
	/* 261 (5) */	"STR",
	/* 262 (0) */	"CSTR",
	/* 263 (2) */	"BOOL",
	/* 264 (0) */	"BACKSTR",
	/* 265 (0) */	"ANGSTR",
	/* 266 (0) */	"LINE",
	/* 267 (0) */	"SPACE",
	/* 268 (0) */	"EOL",
	/* 269 (0) */	"CPP",
	/* 270 (0) */	"CPP_JOIN",
	/* 271 (0) */	"CPP_DEFINED",
	/* 272 (0) */	"CPP_DEFINE",
	/* 273 (0) */	"CPP_UNDEF",
	/* 274 (0) */	"CPP_IF",
	/* 275 (0) */	"CPP_IFDEF",
	/* 276 (0) */	"CPP_IFNDEF",
	/* 277 (0) */	"CPP_ENDIF",
	/* 278 (0) */	"CPP_ELIF",
	/* 279 (0) */	"CPP_INCLUDE",
	/* 280 (0) */	"CPP_PRAGMA",
	/* 281 (0) */	"CPP_ASSERT",
	/* 282 (0) */	"CPP_UNASSERT",
	/* 283 (0) */	"CPP_LINE",
	/* 284 (0) */	"CPP_ERROR",
	/* 285 (0) */	"CPP_WARNING",
	/* 286 (0) */	"CPP_IDENT",
	/* 287 (0) */	"CPP__FILE",
	/* 288 (0) */	"CPP__LINE",
	/* 289 (0) */	"CPP__DATE",
	/* 290 (0) */	"CPP__TIME",
	/* 291 (0) */	"CPP__STDC",
	/* 292 (0) */	"CPP__STDCVER",
	/* 293 (23) */	"EOS",
	/* 294 (2) */	"COLON",
	/* 295 (13) */	"COMMA",
	/* 296 (2) */	"QMARK",
	/* 297 (0) */	"POUND",
	/* 298 (2) */	"LBRACE",
	/* 299 (11) */	"RBRACE",
	/* 300 (8) */	"LBRACK",
	/* 301 (8) */	"RBRACK",
	/* 302 (32) */	"LPAREN",
	/* 303 (34) */	"RPAREN",
	/* 304 (0) */	"QLINE",
	/* 305 (0) */	"DOTDOT",
	/* 306 (0) */	"AT",
	/* 307 (0) */	"BSLASH",
	/* 308 (3) */	"OP_ADD",
	/* 309 (3) */	"OP_SUB",
	/* 310 (5) */	"OP_MUL",
	/* 311 (2) */	"OP_DIV",
	/* 312 (2) */	"OP_MOD",
	/* 313 (2) */	"OP_NOT",
	/* 314 (4) */	"OP_AND",
	/* 315 (2) */	"OP_OR",
	/* 316 (2) */	"OP_XOR",
	/* 317 (2) */	"OP_LNOT",
	/* 318 (2) */	"OP_LAND",
	/* 319 (2) */	"OP_LOR",
	/* 320 (0) */	"OP_LXOR",
	/* 321 (3) */	"OP_LSS",
	/* 322 (3) */	"OP_GTR",
	/* 323 (2) */	"OP_LEQ",
	/* 324 (2) */	"OP_GEQ",
	/* 325 (2) */	"OP_EQU",
	/* 326 (2) */	"OP_NEQ",
	/* 327 (3) */	"OP_INC",
	/* 328 (3) */	"OP_DEC",
	/* 329 (2) */	"OP_LSHIFT",
	/* 330 (2) */	"OP_RSHIFT",
	/* 331 (9) */	"OP_ASN",
	/* 332 (2) */	"OP_ASNADD",
	/* 333 (2) */	"OP_ASNSUB",
	/* 334 (2) */	"OP_ASNMUL",
	/* 335 (2) */	"OP_ASNDIV",
	/* 336 (2) */	"OP_ASNMOD",
	/* 337 (2) */	"OP_ASNAND",
	/* 338 (2) */	"OP_ASNOR",
	/* 339 (2) */	"OP_ASNXOR",
	/* 340 (2) */	"OP_ASNLSHIFT",
	/* 341 (2) */	"OP_ASNRSHIFT",
	/* 342 (4) */	"OP_DOT",
	/* 343 (3) */	"OP_PTRTO",
	/* 344 (1) */	"OP_SCOPE",
	/* 345 (3) */	"ELIPSIS",
	/* 346 (2) */	"OP_MDOT",
	/* 347 (2) */	"OP_MPTRTO",
	/* 348 (3) */	"OP_CONDASN",
	/* 349 (1) */	"KW_ATTRIBUTE",
	/* 350 (1) */	"KW_CONST",
	/* 351 (1) */	"KW_VOLATILE",
	/* 352 (1) */	"KW_AUTO",
	/* 353 (1) */	"KW_STATIC",
	/* 354 (3) */	"KW_EXTERN",
	/* 355 (1) */	"KW_REGISTER",
	/* 356 (1) */	"KW_LONG",
	/* 357 (1) */	"KW_SHORT",
	/* 358 (1) */	"KW_SIGNED",
	/* 359 (1) */	"KW_UNSIGNED",
	/* 360 (1) */	"KW_INT",
	/* 361 (1) */	"KW_CHAR",
	/* 362 (1) */	"KW_FLOAT",
	/* 363 (1) */	"KW_DOUBLE",
	/* 364 (1) */	"KW_VOID",
	/* 365 (2) */	"KW_IF",
	/* 366 (3) */	"KW_ELSE",
	/* 367 (2) */	"KW_DO",
	/* 368 (3) */	"KW_WHILE",
	/* 369 (2) */	"KW_FOR",
	/* 370 (2) */	"KW_SWITCH",
	/* 371 (2) */	"KW_CASE",
	/* 372 (2) */	"KW_DEFAULT",
	/* 373 (2) */	"KW_BREAK",
	/* 374 (2) */	"KW_CONTINUE",
	/* 375 (2) */	"KW_GOTO",
	/* 376 (2) */	"KW_RETURN",
	/* 377 (3) */	"KW_ENUM",
	/* 378 (1) */	"KW_UNION",
	/* 379 (1) */	"KW_STRUCT",
	/* 380 (2) */	"KW_TYPEDEF",
	/* 381 (3) */	"OP_SIZEOF",
	/* 382 (0) */	"KW__FUNC",
	/* 383 (0) */	"KW__PFUNC",
	/* 384 (5) */	"KW_OPERATOR",
	/* 385 (3) */	"KW_CLASS",
	/* 386 (2) */	"KW_THIS",
	/* 387 (3) */	"KW_TYPEID",
	/* 388 (2) */	"KW_TYPENAME",
	/* 389 (6) */	"KW_NAMESPACE",
	/* 390 (5) */	"KW_USING",
	/* 391 (1) */	"KW_TEMPLATE",
	/* 392 (1) */	"KW_PUBLIC",
	/* 393 (1) */	"KW_PRIVATE",
	/* 394 (1) */	"KW_PROTECTED",
	/* 395 (2) */	"KW_FRIEND",
	/* 396 (5) */	"KW_VIRTUAL",
	/* 397 (1) */	"KW_MUTABLE",
	/* 398 (1) */	"KW_EXPLICIT",
	/* 399 (1) */	"KW_BOOL",
	/* 400 (0) */	"KW_TRUE",
	/* 401 (0) */	"KW_FALSE",
	/* 402 (1) */	"KW_WCHAR",
	/* 403 (1) */	"KW_THROW",
	/* 404 (1) */	"KW_CATCH",
	/* 405 (1) */	"KW_TRY",
	/* 406 (1) */	"KW_SCAST",
	/* 407 (1) */	"KW_DCAST",
	/* 408 (1) */	"KW_CCAST",
	/* 409 (1) */	"KW_RCAST",
	/* 410 (1) */	"KW_INLINE",
	/* 411 (2) */	"KW_ASM",
	/* 412 (1) */	"OP_TYPEOF",
	/* 413 (3) */	"OP_NEW",
	/* 414 (2) */	"OP_DELETE",
	/* 415 (1) */	"OP_NEWA",
	/* 416 (2) */	"OP_DELETEA",
	/* 417 (3) */	"KW_DYNAMIC",
	/* 418 (2) */	"VAL_ID",
	/* 419 (3) */	"AGGR_ID",
	/* 420 (2) */	"ENUM_ID",
	/* 421 (2) */	"TYPE_ID",
	/* 422 (2) */	"CTOR_ID",
	/* 423 (4) */	"DTOR_ID",
	/* 424 (0) */	"OPER_ID",
	/* 425 (0) */	"CONV_ID",
	/* 426 (3) */	"NSPACE_ID",
	/* 427 (3) */	"ASPACE_ID",
	/* 428 (1) */	"TPLATE_ID",
	/* 429 (5) */	"SCOPE",
	/* 430 (0) */	"TOKENLIST",
	/* 431 (0) */	"OP_REF",
	/* 432 (0) */	"OP_PTR",
	/* 433 (0) */	"OP_MPTR",
	/* 434 (0) */	"OP_UMINUS",
	/* 435 (0) */	"OP_UPLUS",
	/* 436 (0) */	"OP_INCP",
	/* 437 (0) */	"OP_DECP",
	/* 438 (0) */	"OP_TSIZEOF",
	/* 439 (0) */	"OP_COMMA",
	/* 440 (0) */	"OP_FUNC",
	/* 441 (0) */	"OP_INDEX",
	/* 442 (0) */	"OP_CAST",
	/* 443 (1) */	"KW_DCLASS",
	/* 444 (1) */	"KW_DTYPE",
	/* 445 (0) */	"NEXT_INSN",
	/* 446 (0) */	"BACKPATCH",
	/* 447 (0) */	"ACTION",
	/* 448 (0) */	"TBC",
	/* 449 (2) */	"LBRACE_SAVE",
	/* 450 (2) */	"COLON_SAVE",
	/* 451 (1) */	"PARSE_COMPOUND",
	/* 452 (1) */	"DEFINE",
#line 202 "/u4/shaggy/u2/src/sos/util/shacc/shacc.c.parser"
};
#endif

#ifdef YYIMPURE
YYSTYPE yylval;
#endif


#ifdef YYPDEBUG
static int nalloc = 0, nfree = 0, nnew = 0, ndelete = 0, ncopy = 0, nwrite = 0;
#endif

static YYNode *aln = 0;

#ifdef YYCLASS
class YYYYCLASS : YYCLASS {
#if YYDEBUG
	void yyprintnode(const YYNode *np);
#endif
#ifdef YYPDEBUG
	void yyprintfullnode(YY *yy, const YYNode *np);
	void yyprintactive(YY *yy, const YYNode *np, const char *str);
#endif
#if YYDEBUG
	void yyprintrule(int rn, int nt);
	void yyprintactiverules(YY *yy, const YYNode *np);
#endif
	int yyfollow(YY *yy, const YYNode *np, int s);
	void yygc(YY *yy, const YYNode *np);
	YYYYCLASS();
public:
	int YYPARSE(YYPARSEPARAMS);
};
#endif

#ifndef CCAST
#	ifdef _cplusplus
#		define	CCAST(t)	const_cast<t>	
#	else
#		define CCAST(t)	(t)
#	endif
#endif

#ifndef RCAST
#	ifdef _cplusplus
#		define	RCAST(t)	reinterpret_cast<t>	
#	else
#		define	RCAST(t)	(t)
#	endif
#endif

#define YYNODE_BAD	(RCAST(const YYNode*)(-1))

#define yynode_addact(yy, np) \
{ YYNode *_np = CCAST(YYNode*)(np); _np->a = (yy)->anp; (yy)->anp = _np; }
#define yynode_addred(yy, np) \
{ YYNode *_np = CCAST(YYNode*)(np); _np->a = (yy)->rnp; (yy)->rnp = _np; }
#define yynode_add(yy, np) \
{ const YYNode *_cnp = (np); if(_cnp->x >= yyrule[_cnp->r].ns) \
	yynode_addred((yy), _cnp) else yynode_addact((yy), _cnp); }


static YYNode *
yynode_alloc(YY *yy)
{
	YYNode *np;
	if(!yy->free) {
		int n = 255;
		void **m = RCAST(void**)(YYMALLOC(sizeof(void*)
							+n*sizeof(YYNode)));
		*m = yy->alloc;
		yy->alloc = RCAST(void*)(m);
		np = CCAST(YYNode*)(m+1);
		while(n--) {
			np->a = yy->free;
			yy->free = np;
			np++;
		}
	}
	np = yy->free;
	yy->free = RCAST(YYNode*)(yy->free->a);
	DBG(++nalloc);
	if(aln)
		aln->pp = np;
	np->np = aln;
	np->pp = 0;
	aln = np;
	return np;
}

void
yynode_free(YY *yy, YYNode *np)
{
	np->a = yy->free;
	yy->free = np;
	if(np->pp)
		np->pp->np = np->np;
	else 
		aln = np->np;
	if(np->np)
		np->np->pp = np->pp;
	DBG(++nfree);
}

void
yydogc(YYNode *np)
{
	if(np && np != YYNODE_BAD && !np->mark++) {
		yydogc(CCAST(YYNode*)(np->p));
		yydogc(CCAST(YYNode*)(np->s));
		yydogc(CCAST(YYNode*)(np->a));
	}
}

/* garbage collection - to get rid of cyclic structures that aren't
 * caught by reference counting alone
 */
void
YYPREFIX yygc(YY *yy, const YYNode *np)
{	
	YYNode *a = aln;
	int i;
	yy = yy;
	while(a) {
		a->mark = 0;
		a = a->np;
	}
	yydogc(CCAST(YYNode*)(np));
	yydogc(CCAST(YYNode*)(yy->anp));
	yydogc(CCAST(YYNode*)(yy->rnp));
	for(i=0; i<YYNNONTERMS; i++)
		yydogc(CCAST(YYNode*)(yy->nts[i]));
	i = 0;
	a = aln;
	while(a) {
		YYNode *n = a->np;
		if(!a->mark) {
			yynode_free(yy, a);
			if(a->s) {
				--(CCAST(YYNode*)(a->s))->rc;
				DBG(ndelete++);
			}
			if(a->p) {
				--(CCAST(YYNode*)(a->p))->rc;
				DBG(ndelete++);
			}
			i++;
		}
		a = n;
	}
#ifdef YYPDEBUG
	a = aln;
	while(a) {
		if(a->mark != a->rc)
			YYEPRINTF("GC RC: rc=%d, %d [%p]\n",
				a->rc, a->mark, a);
		a = a->np;
	}
	YYEPRINTF("GC: %d (%d)\n", i, i*sizeof(YYNode));
#endif
}

static YYNode *
yynode_new(YY *yy, int r, int x, const YYNode *p)
{
	YYNode *np = yynode_alloc(yy);
	np->rc = 1;
	np->c = -1;
	np->c1 = -1;
	np->s = 0;
	np->r = r;
	np->x = x;
	np->p = p;
	np->a = 0;
	np->rp = 0;
	DBG(++nnew;)
	return np;
}

static int
yynode_delete(YY *yy, const YYNode *np)
{
	YYNode *wnp = CCAST(YYNode*)(np);
	if(!wnp || wnp == YYNODE_BAD)
		return 0;
	DBG(++ndelete;)
	if(wnp->rc <= 0) {
		// sprintf(yy->errstr, "internal error: ref count rc=%d r=%d x=%d",
		//		wnp->rc, wnp->r, wnp->x);
		return -1;
	}
	if(!--wnp->rc) {
		yynode_delete(yy, wnp->s);
		yynode_delete(yy, wnp->p);
		yynode_free(yy, wnp);
	}
	/* Crazy cyclic checks... GC takes care of this now  
	else if(wnp->rc == 1 && wnp->p && wnp->p->rc == 1
			&& wnp->p->s == wnp) {
		np = wnp->p;
		wnp->p = 0;
		yynode_delete(yy, np);
	} else if(wnp->rc == 1 && wnp->s && wnp->s->rc == 1
			&& wnp->s->p == wnp) {
		np = wnp->s;
		wnp->s = 0;
		yynode_delete(yy, np);
	}
	*/
	return 0;
}

static const YYNode *
yynode_copy(YY *yy, const YYNode *np)
{
	yy = yy;
	if(!np || np == YYNODE_BAD)
		return np;
	if(!++(CCAST(YYNode*)(np))->rc) {
		// sprintf(yy->errstr, "internal error: ref count wraparound");
	}
	DBG(++ncopy;)
	return np;
}

void
yynode_assign(YY *yy, const YYNode **vnp, const YYNode *np)
{
	if(*vnp != np) {
		yynode_delete(yy, *vnp);
		*vnp = yynode_copy(yy, np);
	}
}

static YYNode *
yynode_canwrite(YY *yy, const YYNode *np)
{
	YYNode *wnp;
	if(np->rc == 1)
		wnp = CCAST(YYNode*)(np);
	else {
		YYNode *cnp, *cpp;
		wnp = yynode_alloc(yy);
		cnp = wnp->np;
		cpp = wnp->pp;
		*wnp = *np;
		wnp->np = cnp;
		wnp->pp = cpp;
		// memcpy(wnp, np, sizeof(*np)-8);
		wnp->rc = 1;
		wnp->a = 0;
		--(CCAST(YYNode*)(np))->rc;
		wnp->s = yynode_copy(yy, wnp->s);
		wnp->p = yynode_copy(yy, wnp->p);
	}
	DBG(++nwrite;)
	return wnp;
}

/* Notes:
 *	- w.r.t. ref counting and COW, YYNode.a is not considered to
 *	  be part of YYNode.  This is because it is simply used as 
 *	  a convenient place to keep the active and active reduction
 *	  lists, and since only one of each list exists at a time,
 *	  and there is no overlap, it is effectively equivalent to keeping
 *	  two separate lists for these and doesn't affect the COW semantics.
 *
 *	- All functions from this point on that take a YYNode* assume
 *	  that an explicit copy has been made if necessary, since they
 *	  can potentially modify the node.  These functions will
 *	  delete the copy when they are done (unless they add another
 *	  reference to the node).  If the node is going to be deleted
 *	  afterwards anyway, no copy is necessary, and this results
 *	  in an efficiency gain, since no extra copies are created.
 *
 *	- The substitution chain (YYNode.s) is another unusual case,
 *	  since the link needs to be added to nodes that already exist
 *
 *	- Possible bug: is it possible for an active node to get
 *	  made active again before reaching it while traversing
 *	  the active list?  (in which case, the YYNode.a pointer would
 *	  get changed before that part of the list is reached)
 *	  For now, a safety check will catch this and report an
 *	  internal error.
 *	
 *	- cyclic arrangements of nodes will never get deleted via
 *	  reference counting.  A garbage collector deals with this.
 *	
 *	- Recursive rule sets can cause themselves to exist,
 *	  since a rule needs to be activated before it can be tested
 */


#if YYDEBUG
YYSTATIC void
YYPREFIX yyprintnode(const YYNode *np)
{
	int i;
	YYRule *r;
	r = np->p ? &yyrule[np->p->r] : 0;
	YYEPRINTF("%s <-", r ? yysname[yysym[r->sym+np->p->x]
				+YYNNONTERMS-1] : "$");
	r = &yyrule[np->r];
	for(i=0; i<r->ns; i++) {
		if(i == np->x)
			YYEPRINTF(" .");
		YYEPRINTF(" %s",
			yysname[yysym[r->sym+i]+YYNNONTERMS-1]);
	}
	YYEPRINTF("\n");
}
#endif

#ifdef YYPDEBUG
YYSTATIC void
YYPREFIX yyprintfullnode(YY *yy, const YYNode *np)
{
	YYEPRINTF("\t%p: r=%d x=%d c=%d c1=%d p=%p s=%p rc=%d [r=%d]\n",
		np, np->r, np->x, np->c, np->c1, np->p, np->s, np->rc,
		np->c >= 0 ? yy->rstk[np->c].r : -1);
	YYEPRINTF("\t");
	yyprintnode(np);
}

YYSTATIC void
YYPREFIX yyprintactive(YY *yy, const YYNode *np, const char *str)
{
	YYEPRINTF("%s:\n", str);
	while(np) {
		yyprintfullnode(yy, np);
	 	np = np->a;
	}
}
#endif


YYSTATIC int
YYPREFIX yyfollow(YY *yy, const YYNode *np, int s)
{
	int m;
	if(np->x >= yyrule[np->r].ns) {
		yynode_addred(yy, np);
		return 1;
	}
	m = yysym[yyrule[np->r].sym + np->x];
	if(m < 0) {	/* it's a nonterminal */
		const YYNode **ntsp;
		YYNode *p;
		int rv=0;
		int y = 0;
		m = -m;
		ntsp = &yy->nts[m];
		if(*ntsp == YYNODE_BAD) {
			yynode_delete(yy, np);
			return 0;
		}
		while(*ntsp && (*ntsp)->c != np->c) 
			ntsp = &(*CCAST(YYNode**)(ntsp))->a;
		if(*ntsp) {
			YYNode *wnp;
			while((*ntsp)->s)
				ntsp = &(*CCAST(YYNode**)(ntsp))->s;
			wnp = CCAST(YYNode*)(*ntsp);
			p = yynode_canwrite(yy, np);
			DBG(YYEPRINTF("linking %p to %p\n", p, wnp));
			DBG(yyprintfullnode(yy, p));
			yynode_assign(yy, &p->s, 0);
			yynode_assign(yy, &wnp->s, p);
			yynode_delete(yy, p);
			return 1;
		}
		/* for recursive rules, need to make sure they don't
		 * simply cause themselves to exist...  need some valid
		 * reduction as well (will gc clean these up anyway,
		 * or are they cyclic?)
		 */
		p = yynode_canwrite(yy, np);
		yynode_assign(yy, ntsp, p);
		yynode_assign(yy, &p->s, 0);
		y = yynt[m];
		while(y > 0) {
			YYNode *wnp = yynode_new(yy, y, 0, yynode_copy(yy, p));
			wnp->c = p->c;
			wnp->c1 = p->c1;
			if(yyfollow(yy, wnp, s))
				rv=1;
			if(yyrule[y].skip)
				y += yyrule[y].skip;
			else	
				y = -1;
		}
		if(!rv) {
			// if(yy->nts[m])
			//	YYINTERR;
			yynode_assign(yy, &yy->nts[m], YYNODE_BAD);
		}
		yynode_delete(yy, p);
		return rv;
	} else {	/* it's a terminal */
		if(s == -1) {
			yynode_addact(yy, np);
			return 1;
		} else if(m == s) {
			YYNode *wnp = yynode_canwrite(yy, np);
			++wnp->x;
			yynode_add(yy, wnp);
			return 1;
		} else {
			yynode_delete(yy, np);
			return 0;
		}
	}
}



void
yyclearrc(YYNode *np)
{
	if(np->mark) {
		np->mark = 0;
		np->c = -1;
		if(np->s)
			yyclearrc(CCAST(YYNode*)(np->s));
		if(np->p)
			yyclearrc(CCAST(YYNode*)(np->p));
	}
}

#if YYDEBUG
void
YYPREFIX yyprintrule(int rn, int nt)
{
	int i;
	YYRule *r = &yyrule[rn];
	YYEPRINTF("r%d: %s <-", rn, yysname[nt+YYNNONTERMS-1]);
	for(i=0; i<r->ns; i++)
		YYEPRINTF(" %s", yysname[yysym[r->sym+i] +YYNNONTERMS-1]);
	YYEPRINTF("\n");
}

void
YYPREFIX yyprintactiverules(YY *yy, const YYNode *np)
{
	while(np) {
		int c = np->c;
		YYEPRINTF("yydebug:\n");
		YYEPRINTF("yydebug: ");
		yyprintnode(np);
		while(c >= 0) {	
			int nc = yy->rstk[c].p;
			yy->rstk[c].p = -1;
			YYEPRINTF("yydebug: %d: ", c);
			yyprintrule(yy->rstk[c].r, yy->rstk[c].nt);
			c = nc;
		}
		np = np->a;
	}
}
#endif


/* General overview of main loop: (needs updating)
 *	- if there's only one active rule or reduction
 *	 	- make sure any substitutions have equivalent reductions
 *		- if so, perform all reductions
 *	- go through all active reductions
 *		- substitute back into previous rules,
 *		  adding to reduction chain
 *		- check for any substitution links, and follow them,
 *		  also adding to reduction chain for each
 *	- if we don't currently have a token
 *		- get a new token
 *	- follow all active rules (advance to next token, eliminating
 *		the rule if it doesn't match)
 *	- if there are no active reductions
 *		- save yylval on stack
 *		- eat the current token	
 */

int
YYPREFIX YYPARSE(YYPARSEPARAMS)
{
	YYSTYPE yylval;
	int success = 0;
	int s, i;
	int eof = 0;
	YY yy;
	int maxrsp = 0;
	int rstksize = YYINITDEPTH;
	int ambig = 0;

	YYPARSE_VARS

	yy.rstk = RCAST(YYRedNode*)(YYMALLOC(rstksize*sizeof(YYRedNode)));
	yy.vsa = RCAST(YYSTYPE*)(YYMALLOC(YYINITDEPTH*sizeof(YYSTYPE)));
	yy.dvsa = RCAST(YYSTYPE*)(YYMALLOC(YYINITDEPTH*sizeof(YYSTYPE)));
	yy.rsp = 0;
	yy.dsp = 0;
	yy.dsrp = 0;
	yy.anp = 0;
	yy.rnp = 0;
	yy.vsp = yy.vsa;
	yy.alloc = 0;
	yy.free = 0;

	for(i=0; i<YYNNONTERMS; i++)
		yy.nts[i] = 0;
	yy.anp = 0;
	yynode_addact(&yy, yynode_new(&yy, 0,0,0));
	s = -1;
	ambig = 0;
	while(yy.anp || yy.rnp) {
		const YYNode *np;
		int pr = 0;
		int cf = -1;
		int ct = -1;

#ifdef YYPDEBUG
		YYEPRINTF("----------------------------------------------\n");
		yyprintactive(&yy, yy.anp, "active");
		yyprintactive(&yy, yy.rnp, "reduce");
#endif

		for(;;) {
			int c1;
			const YYNode *snp;
			np = yy.anp ? yy.anp : yy.rnp;
			snp = yy.anp ? yy.rnp : 0;
			c1 = np->c1;
			while(np) {
				if(np->c1 != c1) {
					c1 = -2;
					break;
				}
				if(!(np = np->a)) {
					np = snp;
					snp = 0;
				}
			}
		
			if(c1 == -1) {
				DBG(YYEPRINTF("no reductions\n"));
				break;
			} else if(c1 == -2) {
				DBG(YYEPRINTF("reduction ambiguity\n"));
				break;
			}
			DBG(YYEPRINTF("could reduce %d (cf=%d,ct=%d)\n",
						c1, cf, ct));
			yy.rstk[c1].p = -1;
			if(cf < 0)
				cf = c1;
			else
				yy.rstk[ct].p = c1;
			ct = c1;
			pr = 0;
			np = yy.anp ? yy.anp : yy.rnp;
			snp = yy.anp ? yy.rnp : 0;
			while(np) {
				int nc = np->c;
				int nnc;
				if(nc == c1) {
					nc = -1;
					(CCAST(YYNode*)(np))->c = -1;
				} else {
					pr = 1;
					while((nnc = yy.rstk[nc].p) != c1) {	
						if(nnc == -1)
							break;
						nc = nnc;
					}
					yy.rstk[nc].p = -1;
				}
				(CCAST(YYNode*)(np))->c1 = nc;
				if(!(np = np->a)) {
					np = snp;
					snp = 0;
				}
			}
		}

		/* perform any reduction actions that can be done */
		DBG(YYEPRINTF("cf=%d pr=%d\n", cf, pr));
		if(cf >= 0) {
			int sp = cf;
			YYSTYPE *yyvsp = yy.vsp;
			if(yy.rnp && !yy.rnp->a) {
				DBG(YYEPRINTF("Only one active reduction!\n"));
				yygc(&yy, yy.rnp);
			}
			while(sp >= 0) {
				YYRedNode *rnp = &yy.rstk[sp];
				YYSTYPE yyval;
				YYSTYPE *nvsp;

				while(yy.dsrp < rnp->sp)
					*yyvsp++ = yy.dvsa[yy.dsrp++];
				nvsp = yyvsp - yyrule[rnp->r].ns;
				yyval = *nvsp;
#if YYDEBUG
				if(YYDEBUGFLAG) {
					YYEPRINTF("yydebug: ");
					yyprintrule(rnp->r, rnp->nt);
				}
#endif
				switch(rnp->r) {
				/* 0: <EOF>: translation_unit <EOF> */
				/* 1: translation_unit: declaration_seq_opt */
				case 2: /* translation_unit: PARSE_COMPOUND compound_statement */
#line 672 "CParse.y"
					{ /* not used yet */ }
					break;
				case 3: /* declaration_seq: declaration_seq_opt <4> declaration */
#line 684 "CParse.y"
					{ _caction->complete(true);
		  if(_deftok && !_savecode) {
			inject(_deftok);
			_deftok = 0;
		  } }
					break;
				case 4: /* <4>: */
#line 683 "CParse.y"
					{ _caction->complete(false); }
					break;
				/* 5: declaration_seq_opt: none */
				/* 6: declaration_seq_opt: declaration_seq */
				case 7: /* declaration: block_declaration */
				yyrule7: /* 1 */
#line 704 "CParse.y"
					{}
					break;
				case 8: /* declaration: none init_declarator_list EOS */
#line 706 "CParse.y"
					goto yyrule7;
					break;
				/* 9: declaration: function_definition */
				/* 10: declaration: linkage_specification */
				/* 11: declaration: namespace_definition */
				/* 12: declaration: namespace_definition EOS */
				case 13: /* declaration: DEFINE anyscope id_or_ctor <14> ctor_initializer_opt function_body */
#line 717 "CParse.y"
					{ if(yyvsp[-2].token != T(NONE))
			do2(yyvsp[-1], CtorInit, yyvsp[-2], yyvsp[-1]);
		  do2(yyval, Define, yyvsp[-4], yyvsp[-1]);
		  restorescope(yyvsp[-5]); }
					break;
				case 14: /* <14>: */
#line 715 "CParse.y"
					{ savescope_swap(yyvsp[-2]); yyval = yyvsp[-1]; }
					break;
				/* 15: id_or_ctor: identifier */
				/* 16: id_or_ctor: CTOR_ID */
				/* 17: anyscope: AGGR_ID */
				/* 18: anyscope: NSPACE_ID */
				/* 19: anyscope: ASPACE_ID */
				/* 20: anyscope: SCOPE */
				/* 21: block_declaration: simple_declaration */
				/* 22: block_declaration: asm_directive */
				/* 23: block_declaration: namespace_alias_definition */
				/* 24: block_declaration: using_declaration */
				/* 25: block_declaration: using_directive */
				/* 26: simple_declaration: decl_specifier_seq init_declarator_list EOS */
				case 27: /* simple_declaration: decl_specifier_seq EOS */
				yyrule27: /* 1 */
#line 749 "CParse.y"
					{ do3(yyval, DeclSym, yyvsp[-2], none, curscope); }
					break;
				/* 28: decl_specifier_notypename: storage_class_specifier */
				/* 29: decl_specifier_notypename: type_specifier_notypename */
				/* 30: decl_specifier_notypename: function_specifier */
				/* 31: decl_specifier_notypename: KW_FRIEND */
				/* 32: decl_specifier_notypename: KW_TYPEDEF */
				case 33: /* decl_specifier_notypename_seq: decl_specifier_notypename */
				yyrule33: /* 2 */
#line 772 "CParse.y"
					{ do2(yyval, BuildTypeList, none, yyvsp[-1]); }
					break;
				case 34: /* decl_specifier_notypename_seq: decl_specifier_notypename_seq decl_specifier_notypename */
				yyrule34: /* 2 */
#line 774 "CParse.y"
					{ do2(yyval, BuildTypeList, yyvsp[-2], yyvsp[-1]); }
					break;
				/* 35: decl_specifier_seq: decl_specifier_notypename_seq */
				case 36: /* decl_specifier_seq: type_name */
#line 780 "CParse.y"
					goto yyrule33;
					break;
				case 37: /* decl_specifier_seq: decl_specifier_notypename_seq type_name */
#line 782 "CParse.y"
					goto yyrule34;
					break;
				case 38: /* decl_specifier_seq: type_name decl_specifier_notypename_seq */
				yyrule38: /* 1 */
#line 784 "CParse.y"
					{ do2(yyval, BuildTypeList, yyvsp[-1], yyvsp[-2]); }
					break;
				case 39: /* decl_specifier_seq: decl_specifier_notypename_seq type_name decl_specifier_notypename_seq */
#line 786 "CParse.y"
					{ do2(yyvsp[-3], BuildTypeList, yyvsp[-3], yyvsp[-2]); 
		  do2(yyval, BuildTypeList, yyvsp[-3], yyvsp[-1]); }
					break;
				/* 40: decl_specifier_seq_opt: none */
				/* 41: decl_specifier_seq_opt: decl_specifier_seq */
				/* 42: storage_class_specifier: KW_AUTO */
				/* 43: storage_class_specifier: KW_REGISTER */
				/* 44: storage_class_specifier: KW_STATIC */
				/* 45: storage_class_specifier: KW_EXTERN */
				/* 46: storage_class_specifier: KW_MUTABLE */
				/* 47: function_specifier: KW_INLINE */
				/* 48: function_specifier: KW_VIRTUAL */
				/* 49: function_specifier: KW_EXPLICIT */
				/* 50: type_specifier_notypename: simple_type_specifier_notypename */
				/* 51: type_specifier_notypename: class_specifier */
				/* 52: type_specifier_notypename: enum_specifier */
				/* 53: type_specifier_notypename: elaborated_type_specifier */
				/* 54: type_specifier_notypename: cv_qualifier */
				/* 55: simple_type_specifier_notypename: KW_CHAR */
				/* 56: simple_type_specifier_notypename: KW_WCHAR */
				/* 57: simple_type_specifier_notypename: KW_BOOL */
				/* 58: simple_type_specifier_notypename: KW_SHORT */
				/* 59: simple_type_specifier_notypename: KW_INT */
				/* 60: simple_type_specifier_notypename: KW_LONG */
				/* 61: simple_type_specifier_notypename: KW_SIGNED */
				/* 62: simple_type_specifier_notypename: KW_UNSIGNED */
				/* 63: simple_type_specifier_notypename: KW_FLOAT */
				/* 64: simple_type_specifier_notypename: KW_DOUBLE */
				/* 65: simple_type_specifier_notypename: KW_VOID */
				/* 66: type_name: class_name */
				/* 67: type_name: enum_name */
				/* 68: type_name: typedef_name */
				case 69: /* elaborated_type_specifier: class_key identifier */
#line 881 "CParse.y"
					{ do3(yyval, AggrRef, yyvsp[-2], yyvsp[-1], curscope);
		  newdecl(&_stmtlist, yyval); }
					break;
				case 70: /* elaborated_type_specifier: KW_ENUM identifier */
#line 884 "CParse.y"
					{ do3(yyval, EnumRef, yyvsp[-2], yyvsp[-1], curscope);
		  newdecl(&_stmtlist, yyval); }
					break;
				case 71: /* enum_specifier: KW_ENUM identifier_opt lbrace <72> enumerator_list_opt comma_opt RBRACE */
#line 899 "CParse.y"
					{ yyval = _enum_type; }
					break;
				case 72: /* <72>: */
#line 895 "CParse.y"
					{ do3(_enum_type, NewEnum, yyvsp[-3], yyvsp[-2], curscope);
		  _enum_val = none;	
		  newdecl(&_stmtlist, _enum_type); }
					break;
				/* 73: enumerator_list: enumerator_definition */
				/* 74: enumerator_list: enumerator_list COMMA enumerator_definition */
				/* 75: enumerator_list_opt: none */
				/* 76: enumerator_list_opt: enumerator_list */
				case 77: /* enumerator_definition: identifier */
#line 922 "CParse.y"
					{ Item s;
		  do3(s, DeclSym, _enum_type, yyvsp[-1], curscope);
		  do1(_enum_val, EnumNext, _enum_val);
		  do2(yyval, Define, s, _enum_val); }
					break;
				case 78: /* enumerator_definition: identifier OP_ASN constant_expression */
#line 927 "CParse.y"
					{ do3(yyvsp[-2], DeclSym, _enum_type, yyvsp[-3], curscope);
		  _enum_val = yyvsp[-1];
		  do2(yyval, Define, yyvsp[-2], yyvsp[-1]); }
					break;
				/* 79: namespace_definition: named_namespace_definition */
				/* 80: namespace_definition: unnamed_namespace_definition */
				/* 81: named_namespace_definition: original_namespace_definition */
				/* 82: named_namespace_definition: extension_namespace_definition */
				case 83: /* original_namespace_definition: KW_NAMESPACE identifier lbrace <84> namespace_body RBRACE */
#line 957 "CParse.y"
					{ getscope_restore(yyval, yyvsp[-4]); }
					break;
				case 84: /* <84>: */
#line 955 "CParse.y"
					{ savescope_new(yyval, NewNspace, yyvsp[-3], yyvsp[-2]); }
					break;
				case 85: /* extension_namespace_definition: KW_NAMESPACE original_namespace_name lbrace <86> namespace_body RBRACE */
				yyrule85: /* 1 */
#line 967 "CParse.y"
					{ getscope_restore(yyval, yyvsp[-3]); }
					break;
				case 86: /* <86>: */
#line 965 "CParse.y"
					{ savescope_set(yyval, yyvsp[-2]); }
					break;
				case 87: /* unnamed_namespace_definition: KW_NAMESPACE lbrace <88> namespace_body RBRACE */
#line 977 "CParse.y"
					goto yyrule85;
					break;
				case 88: /* <88>: */
#line 975 "CParse.y"
					{ savescope_new(yyval, NewNspace, yyvsp[-2], none); }
					break;
				/* 89: namespace_body: declaration_seq_opt */
				case 90: /* namespace_alias_definition: KW_NAMESPACE identifier OP_ASN namespace_name EOS */
#line 992 "CParse.y"
					{ UNSUPPORTED /* 1 */ }
					break;
				case 91: /* using_declaration: KW_USING KW_TYPENAME unqualified_id EOS */
#line 1004 "CParse.y"
					{ UNSUPPORTED /* 2 */ }
					break;
				case 92: /* using_declaration: KW_USING unqualified_id EOS */
#line 1006 "CParse.y"
					{ UNSUPPORTED /* 3 */ }
					break;
				case 93: /* using_declaration: KW_USING SCOPE unqualified_id EOS */
#line 1008 "CParse.y"
					{ UNSUPPORTED /* 4 */ }
					break;
				case 94: /* using_directive: KW_USING KW_NAMESPACE namespace_name EOS */
#line 1016 "CParse.y"
					{ UNSUPPORTED /* 5 */ }
					break;
				case 95: /* asm_directive: KW_ASM LPAREN STR RPAREN EOS */
#line 1024 "CParse.y"
					{ UNSUPPORTED /* 6 */ }
					break;
				/* 96: linkage_specification: KW_EXTERN STR lbrace declaration_seq_opt RBRACE */
				/* 97: linkage_specification: KW_EXTERN STR declaration */
				case 98: /* save_scope: */
#line 1047 "CParse.y"
					{ savescope(yyval); }
					break;
				case 99: /* init_declarator_list1: save_scope init_declarator COMMA save_scope */
				yyrule99: /* 3 */
#line 1052 "CParse.y"
					{ yyval = yyvsp[-1]; }
					break;
				case 100: /* init_declarator_list1: init_declarator_list1 init_declarator COMMA save_scope */
#line 1054 "CParse.y"
					goto yyrule99;
					break;
				case 101: /* init_declarator_list: save_scope init_declarator */
				yyrule101: /* 7 */
#line 1059 "CParse.y"
					{ yyval = yyvsp[-2]; }
					break;
				case 102: /* init_declarator_list: init_declarator_list1 init_declarator */
#line 1061 "CParse.y"
					goto yyrule101;
					break;
				/* 103: init_declarator_list_opt: none */
				/* 104: init_declarator_list_opt: init_declarator_list */
				case 105: /* init_declarator: declarator attribute_opt */
#line 1069 "CParse.y"
					{ eval_decl(yyval, yyvsp[-2], yyvsp[-4]);
		  newdecl(&_stmtlist, yyval);
		  restorescope(yyvsp[-3]); }
					break;
				case 106: /* init_declarator: declarator attribute_opt <107> initializer */
#line 1076 "CParse.y"
					{ do2(yyval, Define, yyvsp[-2], yyvsp[-1]); 
		  restorescope(yyvsp[-5]); 
		  yyval = yyvsp[-2]; }
					break;
				case 107: /* <107>: */
				yyrule107: /* 1 */
#line 1073 "CParse.y"
					{ eval_decl(yyval, yyvsp[-2], yyvsp[-4]); 
		  newdecl(&_stmtlist, yyval); }
					break;
				case 108: /* init_declarator: declarator attribute_opt <109> OP_CONDASN assignment_expression */
#line 1083 "CParse.y"
					{ do2(yyval, Define, yyvsp[-3], yyvsp[-1]); 
		  restorescope(yyvsp[-6]); 
		  yyval = yyvsp[-3]; }
					break;
				case 109: /* <109>: */
#line 1080 "CParse.y"
					goto yyrule107;
					break;
				/* 110: declarator: direct_declarator */
				case 111: /* declarator: ptr_operator declarator */
				yyrule111: /* 3 */
#line 1095 "CParse.y"
					{ declPtr(yyval, yyvsp[-2], yyvsp[-1]); }
					break;
				/* 112: direct_declarator: declarator_id */
				case 113: /* direct_declarator: direct_declarator LPAREN parameter_declaration_clause RPAREN cv_qualifier_seq_opt */
				yyrule113: /* 2 */
#line 1109 "CParse.y"
					{ declFunc(yyval, yyvsp[-5], yyvsp[-3], yyvsp[-1]); }
					break;
				case 114: /* direct_declarator: direct_declarator LBRACK constant_expression RBRACK */
				yyrule114: /* 1 */
#line 1111 "CParse.y"
					{ declArray(yyval, yyvsp[-4], yyvsp[-2]); }
					break;
				case 115: /* direct_declarator: direct_declarator LBRACK RBRACK */
#line 1113 "CParse.y"
					{ declArray(yyval, yyvsp[-3], none); }
					break;
				case 116: /* direct_declarator: LPAREN declarator RPAREN */
#line 1115 "CParse.y"
					goto yyrule101;
					break;
				case 117: /* ctor_declarator_id: CTOR_ID */
#line 1120 "CParse.y"
					{ do3(yyvsp[-1], SpecialId, T(CTOR_ID), yyvsp[-1], curscope);
		  declSym(yyval, curscope, yyvsp[-1]); 
		  if(yyvsp[-1].scope) {
			if(curscope.token == T(NONE)) {
				curscope.token = T(SCOPE);
				curscope.scope = yyvsp[-1].scope;
			} else 
				yyerror("scope cannot be specified for"
					" non-global constructor");
		  }
		}
					break;
				case 118: /* ctor_declarator: ctor_declarator_id LPAREN parameter_declaration_clause RPAREN cv_qualifier_seq_opt */
#line 1136 "CParse.y"
					goto yyrule113;
					break;
				/* 119: declarator_or_ctor: ctor_declarator */
				/* 120: declarator_or_ctor: declarator */
				case 121: /* ptr_operator: OP_MUL cv_qualifier_seq_opt */
#line 1151 "CParse.y"
					{ yyval = T(OP_PTR); yyval.val = yyvsp[-1].val; }
					break;
				case 122: /* ptr_operator: OP_AND */
				yyrule122: /* 1 */
#line 1153 "CParse.y"
					{ yyval = T(OP_REF); }
					break;
				case 123: /* ptr_operator: SCOPE OP_MUL cv_qualifier_seq_opt */
#line 1155 "CParse.y"
					{ yyval = T(OP_MPTR); yyval.scope = yyvsp[-3].scope; yyval.val = yyvsp[-1].val; }
					break;
				case 124: /* cv_qualifier_seq: cv_qualifier cv_qualifier_seq_opt */
#line 1163 "CParse.y"
					goto yyrule38;
					break;
				/* 125: cv_qualifier_seq_opt: none */
				/* 126: cv_qualifier_seq_opt: cv_qualifier_seq */
				/* 127: cv_qualifier: KW_CONST */
				/* 128: cv_qualifier: KW_VOLATILE */
				case 129: /* declarator_id: id_expression */
#line 1183 "CParse.y"
					{ 
		  declSym(yyval, curscope, yyvsp[-1]); 
		  if(yyvsp[-1].scope) {
			if(curscope.token == T(NONE)) {
				curscope.token = T(SCOPE);
				curscope.scope = yyvsp[-1].scope;
			} else 
				yyerror("scope cannot be specified for"
					" non-global declarator");
		  }
		}
					break;
				case 130: /* type_id: type_specifier_seq abstract_declarator_opt */
				yyrule130: /* 2 */
#line 1201 "CParse.y"
					{ eval_decl(yyval, yyvsp[-1], yyvsp[-2]); }
					break;
				case 131: /* type_specifier_notypename_seq: type_specifier_notypename */
#line 1209 "CParse.y"
					goto yyrule33;
					break;
				case 132: /* type_specifier_notypename_seq: type_specifier_notypename_seq type_specifier_notypename */
#line 1211 "CParse.y"
					goto yyrule34;
					break;
				case 133: /* type_specifier_seq: cv_qualifier_seq_opt type_name cv_qualifier_seq_opt */
#line 1216 "CParse.y"
					{ do2(yyval, BuildTypeList, yyvsp[-3], yyvsp[-2]);
		  if(yyvsp[-1].token != T(NONE))
		  	do2(yyval, BuildTypeList, yyval, yyvsp[-1]); }
					break;
				/* 134: type_specifier_seq: type_specifier_notypename_seq */
				case 135: /* abstract_declarator: ptr_operator abstract_declarator_opt */
#line 1228 "CParse.y"
					goto yyrule111;
					break;
				/* 136: abstract_declarator: direct_abstract_declarator */
				/* 137: abstract_declarator_opt: none */
				/* 138: abstract_declarator_opt: abstract_declarator */
				case 139: /* direct_abstract_declarator: LPAREN parameter_declaration_clause RPAREN cv_qualifier_seq_opt */
#line 1242 "CParse.y"
					{ declFunc(yyval, none, yyvsp[-3], yyvsp[-1]); }
					break;
				case 140: /* direct_abstract_declarator: direct_abstract_declarator LPAREN parameter_declaration_clause RPAREN cv_qualifier_seq_opt */
#line 1245 "CParse.y"
					goto yyrule113;
					break;
				case 141: /* direct_abstract_declarator: LPAREN abstract_declarator RPAREN */
#line 1247 "CParse.y"
					goto yyrule101;
					break;
				case 142: /* parameter_declaration_clause: */
#line 1255 "CParse.y"
					{ do3(yyval, BuildParamList, none, none, curscope); }
					break;
				/* 143: parameter_declaration_clause: parameter_declaration_list */
				case 144: /* parameter_declaration_clause: parameter_declaration_list comma_opt ELIPSIS */
#line 1258 "CParse.y"
					{ do3(yyval, BuildParamList, yyvsp[-3], T(ELIPSIS), curscope); }
					break;
				case 145: /* parameter_declaration_clause: ELIPSIS */
#line 1260 "CParse.y"
					{ do3(yyval, BuildParamList, none, T(ELIPSIS), curscope); }
					break;
				case 146: /* parameter_declaration_list: parameter_declaration */
#line 1269 "CParse.y"
					{ do3(yyval, BuildParamList, none, yyvsp[-1], curscope); }
					break;
				case 147: /* parameter_declaration_list: parameter_declaration_list COMMA parameter_declaration */
#line 1271 "CParse.y"
					{ do3(yyval, BuildParamList, yyvsp[-3], yyvsp[-1], curscope); }
					break;
				case 148: /* parameter_declaration: decl_specifier_seq declarator OP_ASN assignment_expression */
#line 1282 "CParse.y"
					{ eval_pdecl(yyvsp[-2], yyvsp[-3], yyvsp[-4]);
		  do2(yyval, DefParam, yyvsp[-2], yyvsp[-1]); }
					break;
				case 149: /* parameter_declaration: decl_specifier_seq declarator */
#line 1285 "CParse.y"
					{ eval_pdecl(yyval, yyvsp[-1], yyvsp[-2]); }
					break;
				case 150: /* parameter_declaration: decl_specifier_seq abstract_declarator_opt OP_ASN assignment_expression */
#line 1288 "CParse.y"
					{ eval_pdecl(yyvsp[-2], yyvsp[-3], yyvsp[-4]);
		  do2(yyvsp[-4], DeclParam, yyvsp[-2], none);
		  do2(yyval, DefParam, yyvsp[-4], yyvsp[-1]); }
					break;
				case 151: /* parameter_declaration: decl_specifier_seq abstract_declarator_opt */
#line 1292 "CParse.y"
					{ eval_pdecl(yyval, yyvsp[-1], yyvsp[-2]); yyvsp[-1] = yyval;
		  do2(yyval, DeclParam, yyvsp[-1], none); }
					break;
				case 152: /* eval_declarator_or_ctor: declarator_or_ctor */
#line 1302 "CParse.y"
					{ eval_decl(yyval, yyvsp[-1], yyvsp[-3]); 
			yywarning("%p,%p,%p\n", &yyvsp[-3], &yyvsp[-2], &yyvsp[-1]); }
					break;
				case 153: /* function_definition: decl_specifier_seq_opt save_scope declarator_or_ctor <154> ctor_initializer_opt function_body */
#line 1310 "CParse.y"
					{ if(yyvsp[-2].token == T(TOKENLIST)) {
		  	yyvsp[-2].TokenList->append_delete(yyvsp[-1].TokenList);
			yyvsp[-1] = yyvsp[-2];
		  } else if(yyvsp[-2].token != T(NONE))
			do2(yyvsp[-1], CtorInit, yyvsp[-2], yyvsp[-1]);
		  if(_savecode && !_gsavecode) {
			if(!_deftok)
				_deftok = new TokenList;
			_deftok->append(T(DEFINE));
			_deftok->append(curscope);
			_deftok->append(yyvsp[-3]);
			_deftok->append_delete(yyvsp[-1].TokenList);
			yyval = yyvsp[-3];
		  } else 
		  	do2(yyval, Define, yyvsp[-3], yyvsp[-1]);
		  restorescope(yyvsp[-5]); }
					break;
				case 154: /* <154>: */
#line 1308 "CParse.y"
					{ eval_decl(yyval, yyvsp[-1], yyvsp[-3]); }
					break;
				case 155: /* function_body: <156> compound_statement */
#line 1337 "CParse.y"
					{ restorescope(yyvsp[-2]); yyval = yyvsp[-1]; }
					break;
				case 156: /* <156>: */
				yyrule156: /* 1 */
#line 1335 "CParse.y"
					{ savescope_newfunc(yyval, yyvsp[-2]); }
					break;
				/* 157: function_body: save_compound_statement */
				case 158: /* initializer: OP_ASN initializer_clause */
#line 1349 "CParse.y"
					goto yyrule99;
					break;
				case 159: /* initializer: LPAREN expression_list RPAREN */
#line 1351 "CParse.y"
					goto yyrule101;
					break;
				/* 160: initializer_clause: assignment_expression */
				case 161: /* initializer_clause: lbrace initializer_list_opt comma_opt RBRACE */
#line 1362 "CParse.y"
					{ yyval = yyvsp[-3]; }
					break;
				/* 162: comma_opt: */
				/* 163: comma_opt: COMMA */
				/* 164: prev_initializer_list: initializer_list COMMA */
				/* 165: prev_initializer_list: none */
				case 166: /* initializer_list: prev_initializer_list initializer_clause */
#line 1383 "CParse.y"
					{ do2(yyval, BuildArray, yyvsp[-2], yyvsp[-1]); }
					break;
				case 167: /* initializer_list: prev_initializer_list LBRACK constant_expression RBRACK initializer_clause */
#line 1386 "CParse.y"
					{ do2(yyval, BuildArray, yyvsp[-5], yyvsp[-1]); }
					break;
				case 168: /* initializer_list: prev_initializer_list OP_DOT id_expression initializer_clause */
#line 1389 "CParse.y"
					{ do2(yyval, BuildArray, yyvsp[-4], yyvsp[-1]); }
					break;
				case 169: /* initializer_list_opt: */
#line 1394 "CParse.y"
					{ do2(yyval, BuildArray, none, none); }
					break;
				/* 170: initializer_list_opt: initializer_list */
				case 171: /* class_specifier: class_key identifier_opt base_clause_opt lbrace <172> member_specification_opt RBRACE */
#line 1419 "CParse.y"
					{ do2(yyval, EndAggr, yyvsp[-4], yyvsp[-3]);
		  restorescope(yyvsp[-3]);
		  _savecode = yyvsp[-7].Bool; }
					break;
				case 172: /* <172>: */
#line 1412 "CParse.y"
					{ do3(yyvsp[-1], NewAggr, yyvsp[-4], yyvsp[-3], curscope); 
		  newdecl(&_stmtlist, yyvsp[-1]);
		  if(yyvsp[-2].token != T(NONE)) { Item t;
		  	eval_decl(t, yyvsp[-2], yyvsp[-1]); yyvsp[-1] = t; }
		  savescope_set(yyval, yyvsp[-1]);
		  yyvsp[-4].Bool = _savecode; _savecode = true; }
					break;
				/* 173: class_key: KW_CLASS */
				/* 174: class_key: KW_STRUCT */
				/* 175: class_key: KW_UNION */
				case 176: /* class_key: KW_DYNAMIC KW_CLASS */
#line 1440 "CParse.y"
					{ yyval = T(KW_DCLASS); }
					break;
				case 177: /* class_key: KW_DYNAMIC KW_VIRTUAL KW_CLASS */
#line 1442 "CParse.y"
					{ yyval = T(KW_DTYPE); }
					break;
				/* 178: class_key: KW_DCLASS */
				/* 179: class_key: KW_DTYPE */
				/* 180: member_specification: member_declaration member_specification_opt */
				/* 181: member_specification: access_specifier colon <182> member_specification_opt */
				case 182: /* <182>: */
#line 1457 "CParse.y"
					{ do2(yyval, SetAccess, curscope, yyvsp[-2]); curscope = yyval; }
					break;
				/* 183: member_specification: class_name colon <184> member_specification_opt */
				case 184: /* <184>: */
#line 1461 "CParse.y"
					{ do3(yyvsp[-2], FindSym, T(AGGR_ID), yyvsp[-2], curscope); 
		  if(yyvsp[-2].token != T(NONE)) {
			do2(yyval, SetAccess, curscope, yyvsp[-2]); curscope = yyval;
		  }}
					break;
				/* 185: member_specification: KW_DYNAMIC class_name colon <186> member_specification_opt */
				case 186: /* <186>: */
#line 1467 "CParse.y"
					{ yyvsp[-3].token = T(AGGR_ID);
		  yyvsp[-3].tval = T(KW_DYNAMIC);
		  do3(yyvsp[-2], FindSym, yyvsp[-3], yyvsp[-2], curscope);
		  if(yyvsp[-3].token != T(NONE)) {
			do2(yyval, SetAccess, curscope, yyvsp[-2]); curscope = yyval;
		  }}
					break;
				/* 187: member_specification_opt: none */
				/* 188: member_specification_opt: member_specification */
				/* 189: member_declaration: EOS */
				case 190: /* member_declaration: class_key identifier EOS */
#line 1488 "CParse.y"
					{ do3(yyval, AggrDecl, yyvsp[-3], yyvsp[-2], curscope);
		  newdecl(&_stmtlist, yyval); }
					break;
				case 191: /* member_declaration: decl_specifier_seq member_declarator_list EOS */
#line 1491 "CParse.y"
					{ eval_decl(yyval, yyvsp[-2], yyvsp[-3]); }
					break;
				case 192: /* member_declaration: decl_specifier_seq EOS */
#line 1493 "CParse.y"
					goto yyrule27;
					break;
				case 193: /* member_declaration: member_declarator_list EOS */
#line 1495 "CParse.y"
					{ eval_decl(yyval, yyvsp[-2], none); }
					break;
				case 194: /* member_declaration: function_definition */
#line 1497 "CParse.y"
					{ do3(yyval, SetAttr, yyvsp[-1], T(KW_INLINE), none); }
					break;
				/* 195: member_declaration: using_declaration */
				/* 196: member_declarator_list: member_declarator attribute_opt */
				case 197: /* member_declarator_list: member_declarator_list COMMA member_declarator attribute_opt */
#line 1510 "CParse.y"
					{ buildDeclList(yyval, yyvsp[-4], yyvsp[-2]); }
					break;
				/* 198: member_declarator: declarator_or_ctor */
				case 199: /* member_declarator: declarator OP_ASN constant_expression */
#line 1527 "CParse.y"
					{ defineSym(yyval, yyvsp[-3], yyvsp[-1]); }
					break;
				case 200: /* member_declarator: colon constant_expression */
				yyrule200: /* 2 */
#line 1529 "CParse.y"
					{ yyval = none; }
					break;
				case 201: /* member_declarator: identifier colon constant_expression */
#line 1531 "CParse.y"
					{ setAttr(yyvsp[-2], T(TBC), T(COLON), yyvsp[-1]);
		  declSym2(yyval, yyvsp[-2], curscope, yyvsp[-3]); }
					break;
				/* 202: base_clause_opt: none */
				case 203: /* base_clause_opt: colon base_specifier_list */
#line 1545 "CParse.y"
					goto yyrule99;
					break;
				/* 204: base_specifier_list: base_specifier */
				case 205: /* base_specifier_list: base_specifier_list COMMA base_specifier */
#line 1555 "CParse.y"
					{ buildDeclList(yyval, yyvsp[-3], yyvsp[-1]); }
					break;
				case 206: /* base_specifier: class_name */
#line 1567 "CParse.y"
					{ declInherit(yyval, none, yyvsp[-1]); }
					break;
				case 207: /* base_specifier: KW_VIRTUAL class_name */
#line 1569 "CParse.y"
					{ yyvsp[-2].token = T(NONE); yyvsp[-2].tval = T(KW_VIRTUAL); declInherit(yyval, yyvsp[-2], yyvsp[-1]); }
					break;
				case 208: /* base_specifier: KW_VIRTUAL access_specifier class_name */
#line 1571 "CParse.y"
					{ yyvsp[-2].tval = T(KW_VIRTUAL); declInherit(yyval, yyvsp[-2], yyvsp[-1]); }
					break;
				case 209: /* base_specifier: access_specifier class_name */
#line 1573 "CParse.y"
					{ declInherit(yyval, yyvsp[-2], yyvsp[-1]); }
					break;
				case 210: /* base_specifier: access_specifier KW_VIRTUAL class_name */
#line 1575 "CParse.y"
					{ yyvsp[-3].tval = T(KW_VIRTUAL); declInherit(yyval, yyvsp[-3], yyvsp[-1]); }
					break;
				/* 211: access_specifier: KW_PRIVATE */
				/* 212: access_specifier: KW_PROTECTED */
				/* 213: access_specifier: KW_PUBLIC */
				case 214: /* conversion_function_id: KW_OPERATOR conversion_type_id */
#line 1597 "CParse.y"
					{ yyvsp[-1].scope = 0;
		  do3(yyval, SpecialId, T(CONV_ID), yyvsp[-1], curscope); }
					break;
				case 215: /* conversion_function_id: SCOPE KW_OPERATOR conversion_type_id */
#line 1600 "CParse.y"
					{ yyvsp[-1].scope = yyvsp[-3].scope;
		  do3(yyval, SpecialId, T(CONV_ID), yyvsp[-1], curscope); }
					break;
				case 216: /* conversion_type_id: type_specifier_seq conversion_declarator_opt */
#line 1609 "CParse.y"
					goto yyrule130;
					break;
				case 217: /* conversion_declarator: ptr_operator conversion_declarator_opt */
#line 1617 "CParse.y"
					goto yyrule111;
					break;
				/* 218: conversion_declarator_opt: none */
				/* 219: conversion_declarator_opt: conversion_declarator */
				case 220: /* ctor_initializer: COLON_SAVE <221> save_mem_initializer_list */
#line 1629 "CParse.y"
					{ _rawid = yyvsp[-2].Bool;
		  yyvsp[-3].token = T(COLON);
		  (yyvsp[-1].TokenList)->prepend(yyvsp[-3]); 
		  yyval = yyvsp[-1]; }
					break;
				case 221: /* <221>: */
				yyrule221: /* 1 */
#line 1627 "CParse.y"
					{ yyval.Bool = _rawid; _rawid = true; }
					break;
				case 222: /* ctor_initializer: COLON <223> mem_initializer_list */
#line 1636 "CParse.y"
					{ yyval = yyvsp[-1]; restorescope(yyvsp[-2]); }
					break;
				case 223: /* <223>: */
#line 1634 "CParse.y"
					goto yyrule156;
					break;
				/* 224: ctor_initializer_opt: none */
				/* 225: ctor_initializer_opt: ctor_initializer */
				/* 226: save_mem_initializer_list: save_mem_initializer */
				case 227: /* save_mem_initializer_list: save_mem_initializer_list COMMA save_mem_initializer */
#line 1648 "CParse.y"
					{ (yyvsp[-3].TokenList)->append(yyvsp[-2]); 
		  (yyvsp[-3].TokenList)->append_delete(yyvsp[-1].TokenList); 
		  yyval = yyvsp[-3]; }
					break;
				case 228: /* mem_initializer_list: mem_initializer */
#line 1655 "CParse.y"
					{ do3(yyval, BuildStmtList, none, yyvsp[-1], curscope); }
					break;
				case 229: /* mem_initializer_list: mem_initializer_list COMMA mem_initializer */
#line 1657 "CParse.y"
					{ do3(yyval, BuildStmtList, yyvsp[-3], yyvsp[-1], curscope); }
					break;
				case 230: /* save_mem_initializer: identifier LPAREN save_statement_seq_opt RPAREN */
#line 1669 "CParse.y"
					{ yyvsp[-4].token = T(ID); 
		  (yyvsp[-2].TokenList)->prepend(yyvsp[-3]);
		  (yyvsp[-2].TokenList)->prepend(yyvsp[-4]);
		  (yyvsp[-2].TokenList)->append(yyvsp[-1]);
		  yyval = yyvsp[-2]; }
					break;
				case 231: /* mem_initializer: identifier LPAREN expression_list_opt RPAREN */
				yyrule231: /* 2 */
#line 1678 "CParse.y"
					{ do3(yyval, CtorCall, yyvsp[-4], yyvsp[-2], curscope); }
					break;
				case 232: /* operator_function_id: KW_OPERATOR operator */
#line 1690 "CParse.y"
					{ yyvsp[-1].scope = 0;
		  do3(yyval, SpecialId, T(OPER_ID), yyvsp[-1], curscope); }
					break;
				case 233: /* operator_function_id: SCOPE KW_OPERATOR operator */
#line 1693 "CParse.y"
					{ yyvsp[-1].scope = yyvsp[-3].scope;
		  do3(yyval, SpecialId, T(OPER_ID), yyvsp[-1], curscope); }
					break;
				/* 234: simple_operator: OP_NEW */
				/* 235: simple_operator: OP_DELETE */
				/* 236: simple_operator: OP_NEWA */
				/* 237: simple_operator: OP_DELETEA */
				/* 238: simple_operator: OP_ADD */
				/* 239: simple_operator: OP_SUB */
				/* 240: simple_operator: OP_MUL */
				/* 241: simple_operator: OP_DIV */
				/* 242: simple_operator: OP_MOD */
				/* 243: simple_operator: OP_XOR */
				/* 244: simple_operator: OP_AND */
				/* 245: simple_operator: OP_OR */
				/* 246: simple_operator: OP_NOT */
				/* 247: simple_operator: OP_LNOT */
				/* 248: simple_operator: OP_ASN */
				/* 249: simple_operator: OP_LSS */
				/* 250: simple_operator: OP_GTR */
				/* 251: simple_operator: OP_ASNADD */
				/* 252: simple_operator: OP_ASNSUB */
				/* 253: simple_operator: OP_ASNMUL */
				/* 254: simple_operator: OP_ASNDIV */
				/* 255: simple_operator: OP_ASNMOD */
				/* 256: simple_operator: OP_ASNXOR */
				/* 257: simple_operator: OP_ASNAND */
				/* 258: simple_operator: OP_ASNOR */
				/* 259: simple_operator: OP_LSHIFT */
				/* 260: simple_operator: OP_RSHIFT */
				/* 261: simple_operator: OP_ASNRSHIFT */
				/* 262: simple_operator: OP_ASNLSHIFT */
				/* 263: simple_operator: OP_EQU */
				/* 264: simple_operator: OP_NEQ */
				/* 265: simple_operator: OP_LEQ */
				/* 266: simple_operator: OP_GEQ */
				/* 267: simple_operator: OP_LAND */
				/* 268: simple_operator: OP_LOR */
				/* 269: simple_operator: OP_INC */
				/* 270: simple_operator: OP_DEC */
				/* 271: simple_operator: COMMA */
				/* 272: simple_operator: OP_MPTRTO */
				/* 273: simple_operator: OP_PTRTO */
				/* 274: operator: simple_operator */
				case 275: /* operator: LPAREN RPAREN */
#line 1717 "CParse.y"
					{ yyval = T(OP_FUNC); }
					break;
				case 276: /* operator: LBRACK RBRACK */
#line 1719 "CParse.y"
					{ yyval = T(OP_INDEX); }
					break;
				/* 277: literal: NUM */
				/* 278: literal: CHAR */
				/* 279: literal: STR */
				/* 280: literal: FLOAT */
				/* 281: literal: BOOL */
				case 282: /* primary_expression: literal */
#line 1820 "CParse.y"
					{ do1(yyval, Literal, yyvsp[-1]); }
					break;
				case 283: /* primary_expression: KW_THIS */
#line 1822 "CParse.y"
					{ do3(yyval, SpecialId, yyvsp[-1], yyvsp[-1], curscope); }
					break;
				case 284: /* primary_expression: LPAREN expression RPAREN */
#line 1824 "CParse.y"
					goto yyrule101;
					break;
				case 285: /* primary_expression: id_expression_val */
#line 1826 "CParse.y"
					{ do2(yyval, Primary, yyvsp[-1], curscope); }
					break;
				/* 286: id_expression: unqualified_id */
				/* 287: id_expression_val: unqualified_id_val */
				/* 288: unqualified_id: identifier */
				/* 289: unqualified_id: operator_function_id */
				/* 290: unqualified_id: conversion_function_id */
				case 291: /* unqualified_id: DTOR_ID */
				yyrule291: /* 2 */
#line 1854 "CParse.y"
					{ do3(yyval, SpecialId, T(DTOR_ID), yyvsp[-1], curscope); }
					break;
				/* 292: unqualified_id_val: VAL_ID */
				case 293: /* unqualified_id_val: ID */
#line 1861 "CParse.y"
					{ do2(yyval, Undeclared, yyvsp[-1], curscope); }
					break;
				/* 294: unqualified_id_val: operator_function_id */
				/* 295: unqualified_id_val: conversion_function_id */
				case 296: /* unqualified_id_val: DTOR_ID */
#line 1865 "CParse.y"
					goto yyrule291;
					break;
				/* 297: postfix_expression: primary_expression */
				case 298: /* postfix_expression: postfix_expression LBRACK expression RBRACK */
#line 1903 "CParse.y"
					{ do2(yyval, Index, yyvsp[-4], yyvsp[-2]); }
					break;
				case 299: /* postfix_expression: postfix_expression LPAREN expression_list_opt RPAREN */
#line 1905 "CParse.y"
					{ do3(yyval, Call, yyvsp[-4], yyvsp[-2], curscope); }
					break;
				case 300: /* postfix_expression: simple_type_specifier_notypename LPAREN expression_list_opt RPAREN */
#line 1907 "CParse.y"
					goto yyrule231;
					break;
				case 301: /* postfix_expression: type_name LPAREN expression_list_opt RPAREN */
#line 1909 "CParse.y"
					goto yyrule231;
					break;
				case 302: /* postfix_expression: postfix_expression OP_DOT id_expression */
				yyrule302: /* 24 */
#line 1911 "CParse.y"
					{ do3(yyval, BinaryOp, yyvsp[-2], yyvsp[-3], yyvsp[-1]); }
					break;
				case 303: /* postfix_expression: postfix_expression OP_PTRTO id_expression */
#line 1913 "CParse.y"
					goto yyrule302;
					break;
				case 304: /* postfix_expression: postfix_expression OP_DOT pseudo_destructor_name */
#line 1915 "CParse.y"
					goto yyrule302;
					break;
				case 305: /* postfix_expression: postfix_expression OP_PTRTO pseudo_destructor_name */
#line 1917 "CParse.y"
					goto yyrule302;
					break;
				case 306: /* postfix_expression: postfix_expression OP_INC */
#line 1919 "CParse.y"
					{ do2(yyval, UnaryOp, T(OP_INCP), yyvsp[-2]); }
					break;
				case 307: /* postfix_expression: postfix_expression OP_DEC */
#line 1921 "CParse.y"
					{ do2(yyval, UnaryOp, T(OP_DECP), yyvsp[-2]); }
					break;
				case 308: /* postfix_expression: newcast OP_LSS type_id OP_GTR LPAREN expression RPAREN */
#line 1923 "CParse.y"
					{ do3(yyval, Cast, yyvsp[-2], yyvsp[-5], yyvsp[-7]); }
					break;
				case 309: /* postfix_expression: KW_TYPEID LPAREN expression RPAREN */
#line 1925 "CParse.y"
					{ UNSUPPORTED /* 8 */ }
					break;
				case 310: /* postfix_expression: KW_TYPEID LPAREN type_id RPAREN */
#line 1927 "CParse.y"
					{ UNSUPPORTED /* 9 */ }
					break;
				/* 311: newcast: KW_DCAST */
				/* 312: newcast: KW_SCAST */
				/* 313: newcast: KW_RCAST */
				/* 314: newcast: KW_CCAST */
				case 315: /* expression_list: assignment_expression */
#line 1943 "CParse.y"
					{ do2(yyval, BuildExprList, none, yyvsp[-1]); }
					break;
				case 316: /* expression_list: expression_list COMMA assignment_expression */
#line 1945 "CParse.y"
					{ do2(yyval, BuildExprList, yyvsp[-3], yyvsp[-1]); }
					break;
				case 317: /* expression_list_opt: */
#line 1948 "CParse.y"
					{ do2(yyval, BuildExprList, none, none); }
					break;
				/* 318: expression_list_opt: expression_list */
				case 319: /* pseudo_destructor_name: DTOR_ID */
#line 1956 "CParse.y"
					goto yyrule291;
					break;
				/* 320: unary_expression: postfix_expression */
				case 321: /* unary_expression: OP_INC cast_expression */
				yyrule321: /* 5 */
#line 1976 "CParse.y"
					{ do2(yyval, UnaryOp, yyvsp[-2], yyvsp[-1]); }
					break;
				case 322: /* unary_expression: OP_DEC cast_expression */
#line 1978 "CParse.y"
					goto yyrule321;
					break;
				case 323: /* unary_expression: unary_operator cast_expression */
#line 1980 "CParse.y"
					goto yyrule321;
					break;
				case 324: /* unary_expression: OP_SIZEOF unary_expression */
#line 1982 "CParse.y"
					goto yyrule321;
					break;
				case 325: /* unary_expression: OP_SIZEOF LPAREN type_id RPAREN */
#line 1984 "CParse.y"
					{ do2(yyval, UnaryOp, T(OP_TSIZEOF), yyvsp[-2]); }
					break;
				/* 326: unary_expression: new_expression */
				/* 327: unary_expression: delete_expression */
				case 328: /* unary_operator: OP_MUL */
#line 1993 "CParse.y"
					{ yyval = T(OP_PTR); }
					break;
				case 329: /* unary_operator: OP_AND */
#line 1994 "CParse.y"
					goto yyrule122;
					break;
				case 330: /* unary_operator: OP_ADD */
#line 1995 "CParse.y"
					{ yyval = T(OP_UPLUS); }
					break;
				case 331: /* unary_operator: OP_SUB */
#line 1996 "CParse.y"
					{ yyval = T(OP_UMINUS); }
					break;
				/* 332: unary_operator: OP_LNOT */
				/* 333: unary_operator: OP_NOT */
				case 334: /* new_expression: OP_NEW new_placement_opt new_type_id new_initializer_opt */
#line 2007 "CParse.y"
					{ do3(yyval, OpNew, yyvsp[-2], yyvsp[-1], yyvsp[-3]); }
					break;
				case 335: /* new_expression: OP_NEW new_placement_opt LPAREN type_id RPAREN new_initializer_opt */
#line 2009 "CParse.y"
					{ do3(yyval, OpNew, yyvsp[-3], yyvsp[-1], yyvsp[-5]); }
					break;
				case 336: /* new_placement: LPAREN expression_list RPAREN */
#line 2017 "CParse.y"
					goto yyrule101;
					break;
				/* 337: new_placement_opt: none */
				/* 338: new_placement_opt: new_placement */
				case 339: /* new_type_id: type_specifier_seq new_declarator_opt */
#line 2027 "CParse.y"
					goto yyrule130;
					break;
				case 340: /* new_declarator: ptr_operator new_declarator_opt */
#line 2036 "CParse.y"
					goto yyrule111;
					break;
				/* 341: new_declarator: direct_new_declarator */
				/* 342: new_declarator_opt: none */
				/* 343: new_declarator_opt: new_declarator */
				case 344: /* direct_new_declarator: LBRACK expression RBRACK */
#line 2048 "CParse.y"
					{ declArray(yyval, none, yyvsp[-2]); }
					break;
				case 345: /* direct_new_declarator: direct_new_declarator LBRACK constant_expression RBRACK */
#line 2050 "CParse.y"
					goto yyrule114;
					break;
				case 346: /* new_initializer: LPAREN expression_list_opt RPAREN */
#line 2058 "CParse.y"
					goto yyrule101;
					break;
				/* 347: new_initializer_opt: none */
				/* 348: new_initializer_opt: new_initializer */
				case 349: /* delete_expression: OP_DELETE cast_expression */
#line 2070 "CParse.y"
					goto yyrule321;
					break;
				case 350: /* delete_expression: OP_DELETEA cast_expression */
#line 2072 "CParse.y"
					goto yyrule321;
					break;
				/* 351: cast_expression: unary_expression */
				case 352: /* cast_expression: LPAREN type_id RPAREN cast_expression */
#line 2084 "CParse.y"
					{ do3(yyval, Cast, yyvsp[-1], yyvsp[-3], none); }
					break;
				case 353: /* cast_expression: LPAREN type_id RPAREN lbrace initializer_list_opt comma_opt RBRACE */
#line 2087 "CParse.y"
					{ do3(yyval, Cast, yyvsp[-3], yyvsp[-6], none); }
					break;
				/* 354: pm_expression: cast_expression */
				case 355: /* pm_expression: pm_expression OP_MDOT cast_expression */
#line 2098 "CParse.y"
					goto yyrule302;
					break;
				case 356: /* pm_expression: pm_expression OP_MPTRTO cast_expression */
#line 2100 "CParse.y"
					goto yyrule302;
					break;
				/* 357: multiplicative_expression: pm_expression */
				case 358: /* multiplicative_expression: multiplicative_expression OP_MUL pm_expression */
#line 2112 "CParse.y"
					goto yyrule302;
					break;
				case 359: /* multiplicative_expression: multiplicative_expression OP_DIV pm_expression */
#line 2114 "CParse.y"
					goto yyrule302;
					break;
				case 360: /* multiplicative_expression: multiplicative_expression OP_MOD pm_expression */
#line 2116 "CParse.y"
					goto yyrule302;
					break;
				/* 361: additive_expression: multiplicative_expression */
				case 362: /* additive_expression: additive_expression OP_ADD multiplicative_expression */
#line 2127 "CParse.y"
					goto yyrule302;
					break;
				case 363: /* additive_expression: additive_expression OP_SUB multiplicative_expression */
#line 2129 "CParse.y"
					goto yyrule302;
					break;
				/* 364: shift_expression: additive_expression */
				case 365: /* shift_expression: shift_expression OP_LSHIFT additive_expression */
#line 2140 "CParse.y"
					goto yyrule302;
					break;
				case 366: /* shift_expression: shift_expression OP_RSHIFT additive_expression */
#line 2142 "CParse.y"
					goto yyrule302;
					break;
				/* 367: relational_expression: shift_expression */
				case 368: /* relational_expression: relational_expression OP_LSS shift_expression */
#line 2155 "CParse.y"
					goto yyrule302;
					break;
				case 369: /* relational_expression: relational_expression OP_GTR shift_expression */
#line 2157 "CParse.y"
					goto yyrule302;
					break;
				case 370: /* relational_expression: relational_expression OP_LEQ shift_expression */
#line 2159 "CParse.y"
					goto yyrule302;
					break;
				case 371: /* relational_expression: relational_expression OP_GEQ shift_expression */
#line 2161 "CParse.y"
					goto yyrule302;
					break;
				/* 372: equality_expression: relational_expression */
				case 373: /* equality_expression: equality_expression OP_EQU relational_expression */
#line 2172 "CParse.y"
					goto yyrule302;
					break;
				case 374: /* equality_expression: equality_expression OP_NEQ relational_expression */
#line 2174 "CParse.y"
					goto yyrule302;
					break;
				/* 375: and_expression: equality_expression */
				case 376: /* and_expression: and_expression OP_AND equality_expression */
#line 2184 "CParse.y"
					goto yyrule302;
					break;
				/* 377: exclusive_or_expression: and_expression */
				case 378: /* exclusive_or_expression: exclusive_or_expression OP_XOR and_expression */
#line 2195 "CParse.y"
					goto yyrule302;
					break;
				/* 379: inclusive_or_expression: exclusive_or_expression */
				case 380: /* inclusive_or_expression: inclusive_or_expression OP_OR exclusive_or_expression */
#line 2205 "CParse.y"
					goto yyrule302;
					break;
				/* 381: logical_and_expression: inclusive_or_expression */
				case 382: /* logical_and_expression: logical_and_expression OP_LAND inclusive_or_expression */
#line 2215 "CParse.y"
					goto yyrule302;
					break;
				/* 383: logical_or_expression: logical_and_expression */
				case 384: /* logical_or_expression: logical_or_expression OP_LOR logical_and_expression */
#line 2225 "CParse.y"
					goto yyrule302;
					break;
				/* 385: conditional_expression: logical_or_expression */
				case 386: /* conditional_expression: logical_or_expression QMARK expression colon assignment_expression */
#line 2235 "CParse.y"
					{ do3(yyval, CondExpr, yyvsp[-5], yyvsp[-3], yyvsp[-1]); }
					break;
				/* 387: assignment_expression: conditional_expression */
				case 388: /* assignment_expression: logical_or_expression assignment_operator assignment_expression */
#line 2246 "CParse.y"
					goto yyrule302;
					break;
				/* 389: assignment_operator: OP_ASN */
				/* 390: assignment_operator: OP_ASNMUL */
				/* 391: assignment_operator: OP_ASNDIV */
				/* 392: assignment_operator: OP_ASNMOD */
				/* 393: assignment_operator: OP_ASNADD */
				/* 394: assignment_operator: OP_ASNSUB */
				/* 395: assignment_operator: OP_ASNRSHIFT */
				/* 396: assignment_operator: OP_ASNLSHIFT */
				/* 397: assignment_operator: OP_ASNAND */
				/* 398: assignment_operator: OP_ASNXOR */
				/* 399: assignment_operator: OP_ASNOR */
				/* 400: assignment_operator: OP_CONDASN */
				/* 401: expression: assignment_expression */
				case 402: /* expression: expression COMMA assignment_expression */
#line 2277 "CParse.y"
					{ do3(yyval, BinaryOp, T(OP_COMMA), yyvsp[-3], yyvsp[-1]); }
					break;
				/* 403: expression_opt: none */
				/* 404: expression_opt: expression */
				/* 405: constant_expression: conditional_expression */
				/* 406: statement: matched_statement */
				/* 407: statement: unmatched_statement */
				/* 408: other_statement: labeled_statement */
				/* 409: other_statement: expression_statement */
				/* 410: other_statement: compound_statement */
				/* 411: other_statement: selection_statement */
				/* 412: other_statement: iteration_statement */
				/* 413: other_statement: jump_statement */
				/* 414: other_statement: declaration_statement */
				case 415: /* ifsavescope: KW_IF LPAREN */
#line 2329 "CParse.y"
					{ savescope_newlocal(yyval); }
					break;
				case 416: /* restsc: */
#line 2333 "CParse.y"
					{ restorescope(yyvsp[-4]); }
					break;
				/* 417: matched_statement: other_statement */
				case 418: /* matched_statement: ifsavescope condition RPAREN matched_statement restsc KW_ELSE matched_statement */
				yyrule418: /* 1 */
#line 2340 "CParse.y"
					{ do3(yyval, IfElse, yyvsp[-6], yyvsp[-4], yyvsp[-1]); }
					break;
				case 419: /* unmatched_statement: ifsavescope condition RPAREN statement restsc */
#line 2345 "CParse.y"
					{ do3(yyval, IfElse, yyvsp[-4], yyvsp[-2], none); }
					break;
				case 420: /* unmatched_statement: ifsavescope condition RPAREN matched_statement restsc KW_ELSE unmatched_statement */
#line 2348 "CParse.y"
					goto yyrule418;
					break;
				case 421: /* selection_statement: KW_SWITCH LPAREN <422> condition RPAREN statement */
#line 2355 "CParse.y"
					{ do2(yyval, Switch, yyvsp[-3], yyvsp[-1]);
		  restorescope(yyvsp[-5]); }
					break;
				case 422: /* <422>: */
				yyrule422: /* 2 */
#line 2353 "CParse.y"
					{ savescope_newlocal(yyvsp[-1]); }
					break;
				case 423: /* labeled_statement: identifier colon statement */
#line 2366 "CParse.y"
					{ NOSCOPE(yyvsp[-3]); do3(yyval, Label, none, yyvsp[-3], yyvsp[-1]); }
					break;
				case 424: /* labeled_statement: KW_CASE constant_expression colon statement */
#line 2368 "CParse.y"
					{ do3(yyval, Label, yyvsp[-4], yyvsp[-3], yyvsp[-1]); }
					break;
				case 425: /* labeled_statement: KW_DEFAULT colon statement */
#line 2370 "CParse.y"
					{ do3(yyval, Label, yyvsp[-3], none, yyvsp[-1]); }
					break;
				/* 426: expression_statement: expression_opt EOS */
				case 427: /* compound_statement: LBRACE <428> statement_seq_opt RBRACE */
#line 2390 "CParse.y"
					{ yyval = _stmtlist; _stmtlist = yyvsp[-4]; 
		  restorescope(yyvsp[-3]); }
					break;
				case 428: /* <428>: */
#line 2385 "CParse.y"
					{ savescope_newlocal(yyval);
		  yyvsp[-1] = _stmtlist;
		  do3(_stmtlist, BuildStmtList, none, none, curscope);
		  _stmtlist.scope = curscope.scope; }
					break;
				/* 429: statement_seq_opt: */
				case 430: /* statement_seq_opt: statement_seq_opt statement */
#line 2400 "CParse.y"
					{ do3(_stmtlist, BuildStmtList, _stmtlist, yyvsp[-1], curscope); }
					break;
				/* 431: condition: expression */
				case 432: /* condition: type_specifier_seq declarator OP_ASN assignment_expression */
				yyrule432: /* 1 */
#line 2412 "CParse.y"
					{ 
		  defineSym(yyvsp[-2], yyvsp[-3], yyvsp[-1]); 
		  eval_decl(yyvsp[-3], yyvsp[-2], yyvsp[-4]);
		  do3(yyval, BuildStmtList, none, none, curscope);
		  yyval.scope = curscope.scope; 
		  newdecl(&yyval, yyvsp[-3]);
		}
					break;
				case 433: /* condition: type_specifier_seq declarator OP_CONDASN assignment_expression */
#line 2420 "CParse.y"
					goto yyrule432;
					break;
				/* 434: condition_opt: none */
				/* 435: condition_opt: condition */
				case 436: /* iteration_statement: KW_WHILE LPAREN <437> condition RPAREN statement */
#line 2440 "CParse.y"
					{ do3(yyval, While, yyvsp[-3], yyvsp[-1], none);
		  restorescope(yyvsp[-5]); }
					break;
				case 437: /* <437>: */
#line 2438 "CParse.y"
					goto yyrule422;
					break;
				case 438: /* iteration_statement: KW_DO statement KW_WHILE LPAREN expression RPAREN EOS */
#line 2443 "CParse.y"
					{ do3(yyval, DoWhile, none, yyvsp[-6], yyvsp[-3]); }
					break;
				case 439: /* iteration_statement: KW_FOR LPAREN <440> for_init_statement condition_opt EOS expression_opt RPAREN statement */
#line 2447 "CParse.y"
					{ do3(yyvsp[-9], ForExpr, yyvsp[-6], yyvsp[-5], yyvsp[-3]);
		  do2(yyval, For, yyvsp[-9], yyvsp[-1]);
		  restorescope(yyvsp[-8]); }
					break;
				case 440: /* <440>: */
#line 2445 "CParse.y"
					goto yyrule422;
					break;
				/* 441: for_init_statement: expression_statement */
				case 442: /* for_init_statement: <443> simple_declaration */
#line 2463 "CParse.y"
					{ yyval = _stmtlist; _stmtlist = yyvsp[-2]; }
					break;
				case 443: /* <443>: */
#line 2459 "CParse.y"
					{ yyval = _stmtlist;
	    	  do3(_stmtlist, BuildStmtList, none, none, curscope);
		  _stmtlist.scope = curscope.scope; }
					break;
				case 444: /* jump_statement: KW_BREAK EOS */
#line 2474 "CParse.y"
					{ do1(yyval, Break, yyvsp[-2]); }
					break;
				case 445: /* jump_statement: KW_CONTINUE EOS */
#line 2476 "CParse.y"
					{ do1(yyval, Continue, yyvsp[-2]); }
					break;
				case 446: /* jump_statement: KW_RETURN expression_opt EOS */
#line 2478 "CParse.y"
					{ do1(yyval, Return, yyvsp[-2]); }
					break;
				case 447: /* jump_statement: KW_GOTO identifier EOS */
#line 2480 "CParse.y"
					{ NOSCOPE(yyvsp[-2]); do2(yyval, Goto, none, yyvsp[-2]); }
					break;
				case 448: /* declaration_statement: block_declaration */
#line 2488 "CParse.y"
					goto yyrule200;
					break;
				/* 449: typedef_name: TYPE_ID */
				/* 450: namespace_name: original_namespace_name */
				/* 451: namespace_name: namespace_alias */
				/* 452: original_namespace_name: NSPACE_ID */
				/* 453: namespace_alias: ASPACE_ID */
				/* 454: class_name: AGGR_ID */
				/* 455: enum_name: ENUM_ID */
				/* 456: template_name: TPLATE_ID */
				/* 457: identifier: ID */
				/* 458: identifier: VAL_ID */
				/* 459: identifier: TYPE_ID */
				/* 460: identifier: ENUM_ID */
				/* 461: identifier: AGGR_ID */
				/* 462: identifier: NSPACE_ID */
				/* 463: identifier: ASPACE_ID */
				/* 464: identifier: TPLATE_ID */
				/* 465: identifier_opt: none */
				/* 466: identifier_opt: identifier */
				case 467: /* none: */
#line 2570 "CParse.y"
					goto yyrule200;
					break;
				/* 468: lbrace: LBRACE */
				case 469: /* lbrace: LBRACE_SAVE */
#line 2575 "CParse.y"
					{ yyval.token = T(LBRACE); }
					break;
				/* 470: colon: COLON */
				case 471: /* colon: COLON_SAVE */
#line 2577 "CParse.y"
					{ yyval.token = T(COLON); }
					break;
				/* 472: ignore_savecode: */
				/* 473: ignore_savecode: TOKENLIST */
				case 474: /* save_compound_statement: <475> LBRACE_SAVE save_statement_seq_opt RBRACE */
#line 2584 "CParse.y"
					{ _rawid = yyvsp[-4].Bool;
		  yyvsp[-3].token = T(LBRACE);
		  yyvsp[-2].TokenList->prepend(yyvsp[-3]); 
		  yyvsp[-2].TokenList->append(yyvsp[-1]);
		  yyval = yyvsp[-2]; }
					break;
				case 475: /* <475>: */
#line 2582 "CParse.y"
					goto yyrule221;
					break;
				case 476: /* save_statement_seq: save_statement_seq_opt any_statement_token */
#line 2593 "CParse.y"
					{ yyval.TokenList->append(yyvsp[-1]); }
					break;
				case 477: /* save_statement_seq: save_statement_seq_opt save_statement_list */
#line 2595 "CParse.y"
					{ yyval.TokenList->append_delete(yyvsp[-1].TokenList); }
					break;
				case 478: /* save_statement_seq_opt: */
#line 2599 "CParse.y"
					{ yyval.token = T(TOKENLIST); yyval.TokenList = new TokenList; }
					break;
				/* 479: save_statement_seq_opt: save_statement_seq */
				case 480: /* save_statement_list: lbrace save_statement_seq_opt RBRACE */
				yyrule480: /* 2 */
#line 2605 "CParse.y"
					{ yyvsp[-2].TokenList->prepend(yyvsp[-3]); 
		  yyvsp[-2].TokenList->append(yyvsp[-1]);
		  yyval = yyvsp[-2]; }
					break;
				case 481: /* save_statement_list: LPAREN save_statement_seq_opt RPAREN */
#line 2609 "CParse.y"
					goto yyrule480;
					break;
				case 482: /* save_statement_list: LBRACK save_statement_seq_opt RBRACK */
#line 2613 "CParse.y"
					goto yyrule480;
					break;
				/* 483: any_statement_token: NUM */
				/* 484: any_statement_token: CHAR */
				/* 485: any_statement_token: STR */
				/* 486: any_statement_token: FLOAT */
				/* 487: any_statement_token: BOOL */
				/* 488: any_statement_token: EOS */
				/* 489: any_statement_token: colon */
				/* 490: any_statement_token: QMARK */
				/* 491: any_statement_token: simple_operator */
				/* 492: any_statement_token: OP_DOT */
				/* 493: any_statement_token: OP_MDOT */
				/* 494: any_statement_token: OP_SCOPE */
				/* 495: any_statement_token: ELIPSIS */
				/* 496: any_statement_token: cv_qualifier */
				/* 497: any_statement_token: simple_type_specifier_notypename */
				/* 498: any_statement_token: storage_class_specifier */
				/* 499: any_statement_token: KW_IF */
				/* 500: any_statement_token: KW_ELSE */
				/* 501: any_statement_token: KW_DO */
				/* 502: any_statement_token: KW_WHILE */
				/* 503: any_statement_token: KW_FOR */
				/* 504: any_statement_token: KW_SWITCH */
				/* 505: any_statement_token: KW_CASE */
				/* 506: any_statement_token: KW_DEFAULT */
				/* 507: any_statement_token: KW_BREAK */
				/* 508: any_statement_token: KW_CONTINUE */
				/* 509: any_statement_token: KW_GOTO */
				/* 510: any_statement_token: KW_RETURN */
				/* 511: any_statement_token: KW_ENUM */
				/* 512: any_statement_token: KW_TYPEDEF */
				/* 513: any_statement_token: class_key */
				/* 514: any_statement_token: function_specifier */
				/* 515: any_statement_token: OP_SIZEOF */
				/* 516: any_statement_token: OP_TYPEOF */
				/* 517: any_statement_token: KW_ASM */
				/* 518: any_statement_token: KW_OPERATOR */
				/* 519: any_statement_token: KW_THIS */
				/* 520: any_statement_token: KW_TYPEID */
				/* 521: any_statement_token: KW_TYPENAME */
				/* 522: any_statement_token: KW_NAMESPACE */
				/* 523: any_statement_token: KW_USING */
				/* 524: any_statement_token: KW_TEMPLATE */
				/* 525: any_statement_token: access_specifier */
				/* 526: any_statement_token: KW_FRIEND */
				/* 527: any_statement_token: KW_THROW */
				/* 528: any_statement_token: KW_CATCH */
				/* 529: any_statement_token: KW_TRY */
				/* 530: any_statement_token: newcast */
				case 531: /* any_statement_token: identifier */
#line 2645 "CParse.y"
					{ yyval.token = T(ID); }
					break;
				/* 532: any_statement_token: DTOR_ID */
				case 533: /* attribute: KW_ATTRIBUTE LPAREN LPAREN save_statement_seq RPAREN RPAREN */
#line 2660 "CParse.y"
					{ /* just ignore it for now */ }
					break;
				/* 534: attribute_opt: none */
				/* 535: attribute_opt: attribute */
#line 810 "/u4/shaggy/u2/src/sos/util/shacc/shacc.c.parser"
				}
				*nvsp = yyval;
				yyvsp = nvsp+1;
				sp = yy.rstk[sp].p;
			}
			if(!pr) {
				while(yy.dsrp < yy.dsp)
					*yyvsp++ = yy.dvsa[yy.dsrp++];
				if(yyvsp-yy.vsa >= YYINITDEPTH) {
					YYERROR("vsa overflow");
					return 0;
				}
				DBG(YYEPRINTF("clearing rstk\n"));
				yy.rsp = 0; 
				yy.dsp = 0;
				yy.dsrp = 0;
			}
			yy.vsp = yyvsp;
		}

		/* reduce all reductions and substitute them back into
		 *	their previous rules.  Also follow all substitution
		 *	links for additional substitutions.
		 *	All reductions get added as reduction chain links.
		 */
		np = yy.rnp;
		yy.rnp = 0;
		if(np) {
		    while(np) {
			YYNode *wnp;
			const YYNode *nnp = np->a;
			const YYNode *pp = np->p;
			const YYNode *sp;
			int nt;
			int srsp = yy.rsp;
			(CCAST(YYNode*)(np))->a = 0;
#ifdef YYPDEBUG
			YYEPRINTF("reducing: ");
			yyprintfullnode(&yy, np);
#endif
			if(yyrule[np->r].uniq && (yy.anp || yy.rnp || nnp)) 
				ambig = 1;
			if(!pp) {
#if YYDEBUG
				if(YYDEBUGFLAG) {
					YYEPRINTF("yydebug: success:\n");
					yyprintactiverules(&yy, np);
				}
#endif
				success++;
			} else {
				int c1;
				nt = yysym[yyrule[pp->r].sym + pp->x];
				if(!yyrule[np->r].hasact
						&& yyrule[np->r].ns == 1) {
					srsp = np->c;
				} else {
					if(yy.rsp+1 > maxrsp)
					    if((maxrsp = yy.rsp+1)
								> rstksize) {
						YYERROR("rstk overflow");
						return 0;
					    }
					yy.rstk[yy.rsp].r = np->r;
					yy.rstk[yy.rsp].sp = yy.dsp;
					yy.rstk[yy.rsp].p = np->c;
#if YYDEBUG
					yy.rstk[yy.rsp].nt = nt;
#endif
					yy.rsp++;
				}
				wnp = yynode_canwrite(&yy, pp);
				++wnp->x;
				wnp->c = srsp;
				if((c1 = np->c1) == -1)
					c1 = srsp;
				wnp->c1 = c1;
				yynode_assign(&yy, &wnp->a, 0);
#ifdef YYPDEBUG
				YYEPRINTF("to: ");
				yyprintfullnode(&yy, wnp);
#endif
				yynode_copy(&yy, pp);
				sp = wnp->s;
				yynode_add(&yy, wnp);
				while(sp) {
					wnp = yynode_canwrite(&yy, sp);
					wnp->c = srsp;
					wnp->c1 = c1;
					++wnp->x;
#ifdef YYPDEBUG
					YYEPRINTF("also to: ");
					yyprintfullnode(&yy, wnp);
#endif
					yynode_copy(&yy, sp);
					sp = wnp->s;
					yynode_add(&yy, wnp);
				}
			}
			yynode_delete(&yy, np);
			np = nnp;
		    }

		    /* attempt to resolve any ambiguities 
		     * via reduction precedence rules
		     */
		    if(ambig) {
			int d = 0;
			for(;;) {
				int c, cc;
				int r, cr;
				int rp, crp, mrp;
				const YYNode *snp;
				const YYNode **pnp;
				const YYNode **psnp;
				np = yy.anp ? yy.anp : yy.rnp;
				snp = yy.anp ? yy.rnp : 0;
				c = -3;
				r = -3;
				rp = 0;
				mrp = 0;
				while(np) {
					int i;
					cc = np->c;
					for(i=0; i<d; i++)
						cc = yy.rstk[cc].p;
					if(c == -3)
						c = cc;
					else if(cc != c) 
						c = -2;
					cr = yy.rstk[cc].r;
					if(r == -3)
						r = cr;
					else if(cr != r)
						r = -2;
					if((crp = yyrule[cr].rrp)) {
						if(crp > mrp)
							mrp = crp;
						if(!rp || crp < rp)
							rp = crp;
					} else
						rp = -1;
					if(!(np = np->a)) {
						np = snp;
						snp = 0;
					}
				}
				if(c > -2) {
					ambig = 0;
					break;
				}
				if(r > -2) {
					++d;
					continue;
				}
				if(rp < 1 || mrp <= rp)
					break;
				pnp = yy.anp ? &yy.anp : &yy.rnp;
				psnp = yy.anp ? &yy.rnp : 0;
				while(pnp && (np = *pnp)) {
					int i;
					cc = np->c;
					for(i=0; i<d; i++)
						cc = yy.rstk[cc].p;
					cr = yy.rstk[cc].r;
					if(yyrule[cr].rrp != rp) {
						*pnp = np->a;
						yynode_delete(&yy, np);
					} else
						pnp = CCAST(const YYNode**)(&np->a);
					if(!*pnp) {
						pnp = psnp;
						psnp = 0;
					}
				}
			}
		    }
		    continue;	
		}
		if(ambig) {
			YYERROR("ambiguous grammar");
#if YYDEBUG
			if(YYDEBUGFLAG) {
				yyprintactiverules(&yy, yy.rnp);
				yyprintactiverules(&yy, yy.anp);
			}
			return -1;
#endif
		}

		if(yy.rnp)
			YYINTERR;

		/* Follow all paths as far as possible,
		 *	seeing if empty rules perhaps help us to reduce
		 */
		np = yy.anp;
		yy.anp = 0;
		while(np) {
			const YYNode *nnp = np->a;
			(CCAST(YYNode*)(np))->a = 0;
			yyfollow(&yy, np, -1);
			np = nnp;
		}
		if(yy.rnp)		/* if we got any reductions */
			continue;	/* go ahead and use them */

		/* Get a new token */
		s = eof ? 0 : YYLEXCALL;
		eof = (s == 0);
#if YYDEBUG
		if(YYDEBUGFLAG)
			YYEPRINTF("yydebug: read token: %d (%s)\n",
					s, yysname[s+YYNNONTERMS-1]);
#endif

		/* Follow all possible paths with this token,
		 *	eliminating ones that no longer match
		 */
		np = yy.anp;
		yy.anp = 0;
		while(np) {
			const YYNode *nnp = np->a;
			(CCAST(YYNode*)(np))->a = 0;
			yyfollow(&yy, np, s);
			np = nnp;
		}

		if(yy.dsp >= YYINITDEPTH) {
			YYERROR("dvsa overflow");
			return 0;
		}
		yy.dvsa[yy.dsp++] = yylval;

		for(i=0; i<YYNNONTERMS; i++)
			yynode_assign(&yy, &yy.nts[i], 0);
		
#ifdef YYPDEBUG
		YYEPRINTF("After following token:\n");
		yyprintactive(&yy, yy.anp, "active");
		yyprintactive(&yy, yy.rnp, "reduce");
#endif
		
	}
	YYFREE(yy.rstk);
	YYFREE(yy.vsa);
	YYFREE(yy.dvsa);
	
	while(yy.alloc) {
		void *a = yy.alloc;
		yy.alloc = *RCAST(void**)(a);
		YYFREE(a);
	}
	
	if(!success) {
		YYERROR("parse error");
		return -1;
	} else if (success > 1) {
		YYERROR("ambiguous grammar");
		return -1;
	}
#ifdef YYPDEBUG
	YYEPRINTF("active=%p reduce=%p\n", yy.rnp, yy.anp);
	YYEPRINTF("nalloc=%d nfree=%d nnew=%d ndelete=%d ncopy=%d nwrite=%d\n",
		nalloc, nfree, nnew, ndelete, ncopy, nwrite);
	YYEPRINTF("aln=%p maxrsp=%d lostmem=%d\n", aln, maxrsp,
				sizeof(YYNode)*(nalloc-nfree));
	while(aln) {
		yyprintfullnode(&yy, aln);
		aln = aln->np;
	}
#endif
	return 0;
}

#ifdef YYCLASS
int
YYCLASS::YYPARSE(YYPARSEPARAMS)
{
	return static_cast<YYYYCLASS*>(this)->YYPARSE(YYPARSEPARAM);
}
#endif

#line 2665 "CParse.y"
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

